// ==================================================
//	[INCLUDED FILES]     :  <<INCLUDE>>
// --------------------------------------------------
#include      <sgl.h>
#include      <sl_def.h>
#include      <sgl_cd.h>
#include      <sega_cdc.h>
#include      <sddrvs.dat>
#include      <sega_bup.h>
// ==================================================

// ==================================================
//	[GLOBAL DEFINES]     :  <<DEFINE>>
// --------------------------------------------------
#define       YES                       1
#define       NO                        0
#define       NONE                     -1
// --------------------------------------------------
#define       CDROM_max_open            128
#define       CDROM_slsize              2
#define       CDROM_syscdinit1(i) \
              ((**(void(**)(int))0x60002dc)(i))
#define       CDROM_syscdinit2() \
              ((**(void(**)(void))0x600029c)())
Sint32        CDROM_lib_work[SLCD_WORK_SIZE(CDROM_max_open)];
char          CDROM_data_buffer[(CDBUF_FORM1 * CDROM_slsize) / sizeof(char)];
Sint32        CDROM_ndir;
Sint32        CDROM_ndata[2];
CDHN          CDROM_cdhn;
CDKEY         CDROM_key[2];
CDBUF         CDROM_buffer[2];
int           CDROM_data_buffer_location = 0;
Sint32        CDROM_return_value;
#define       max_CDROM_load            10 /*
                                              The max allocation of CD loading arrays, this value can easily be
                                              changed to suit your needs!  Chances are, you'll be making the
                                              value higher, so you can load more at a time...just remember though,
                                              the higher you make the values...the more memory it takes up.
                                           */

#define       repeat_forever            15 // This value sets CDDA audio playback to continuously loop.
// --------------------------------------------------
#define       BACK_COL_ADR              (void *)(VDP2_VRAM_A1 + 0x1fffe)
#define       offset_A                  0
#define       offset_B                  1

#define       max_IMAGE2Ds              50 /*
                                              Max number of IMAGE2D's/textures that can be in spritevram at once.
                                              You can change this number to suit your needs.  For example, if you
                                              wanted to be able to handle more 2D sprites...just make the number
                                              larger.  However, since its a static declaration it'll take up
                                              memory whether you actually use every space or not.
                                           */
TEXTURE       IMAGE2D_texture[max_IMAGE2Ds];
PICTURE       IMAGE2D_picture[max_IMAGE2Ds];
Uint32        IMAGE2D_memory_address = 0;

#define       palette_16_colors         0
#define       palette_64_colors         4
#define       palette_128_colors        8
#define       palette_256_colors        12

#define       sprite_NO_flip            0
#define       sprite_H_flip             1
#define       sprite_V_flip             2
#define       sprite_HV_flip            3

#define       sprite_Polyline          -1
#define       sprite_Polygon           -2
// --------------------------------------------------
#define       PERIPHERAL_NONE           255
#define       PERIPHERAL_CONTROLPAD_DIGITAL 2
#define       PERIPHERAL_CONTROLPAD_ANALOG  22
#define       PERIPHERAL_VIRTUAGUN      37

#define       CONTROLPORT_1             0
#define       CONTROLPORT_2             15

extern Sint8  SynchCount;
extern Uint16 VDP2_EXTEN;

#define       CONTROLPAD_1              0
#define       CONTROLPAD_2              15
#define       CONTROLPAD_u_button       0
#define       CONTROLPAD_d_button       1
#define       CONTROLPAD_r_button       2
#define       CONTROLPAD_l_button       3
#define       CONTROLPAD_a_button       4
#define       CONTROLPAD_b_button       5
#define       CONTROLPAD_c_button       6
#define       CONTROLPAD_s_button       7
#define       CONTROLPAD_x_button       8
#define       CONTROLPAD_y_button       9
#define       CONTROLPAD_z_button       10
#define       CONTROLPAD_tr_button      11
#define       CONTROLPAD_tl_button      12
Uint8         CONTROLPAD_analog_x;
Uint8         CONTROLPAD_analog_y;
Uint8         CONTROLPAD_analog_z;
int           CONTROLPAD_button[13];
static Uint16 CONTROLPAD_button_layout[] = {PER_DGT_KU, PER_DGT_KD, PER_DGT_KR, PER_DGT_KL, PER_DGT_TA, PER_DGT_TB, PER_DGT_TC, PER_DGT_ST, PER_DGT_TX, PER_DGT_TY, PER_DGT_TZ, PER_DGT_TR, PER_DGT_TL};

#define       MEGA_ID_StnShooting       0x0a

#define       VIRTUAGUN_1               0
#define       VIRTUAGUN_2               1
#define       VIRTUAGUN_s_button        63487
#define       VIRTUAGUN_t_button        64511
#define       VIRTUAGUN_s_and_t_buttons 62463
#define       VIRTUAGUN_x_position      0
#define       VIRTUAGUN_y_position      1
#define       VIRTUAGUN_button          2
FIXED         VIRTUAGUN_data[2][9];        /*
                                              VIRTUAGUN_data[][0] = X position.
                                              VIRTUAGUN_data[][1] = Y position.
                                              --
                                              VIRTUAGUN_data[][2] = Button data.
                                              --
                                              VIRTUAGUN_data[][3] = X coordinate divisor.
                                              VIRTUAGUN_data[][4] = Y coordinate divisor.
                                              --
                                              VIRTUAGUN_data[][5] = X calibrated offset.
                                              VIRTUAGUN_data[][6] = Y calibrated offset.
                                              --
                                              VIRTUAGUN_data[][7] = X screen adjustment.
                                              VIRTUAGUN_data[][8] = Y screen adjustment.
                                           */
FIXED         VIRTUAGUN_HRes_Correction = toFIXED(171.0);  /*
                                                              Adjust this value only if you find that VIRTUAGUN shots
                                                              to the far right side of the screen aren't quite accurate.
                                                              171.0 is the default for a Horizontal Resolution of 320.

                                                              This might not even need to be changed, but if your shots
                                                              are way off only on the far right side, then adjusting this
                                                              could help.
                                                           */
static Uint8  GunCtrlFlag1P, GunCtrlFlag2P;
// --------------------------------------------------
#define	      BACKUP_memory_address     0x6070000

#define       BACKUP_internal_memory    0
#define       BACKUP_cartridge          1

#define       BACKUP_success            0
#define       BACKUP_fail               5

#define       BACKUP_unformatted        BUP_UNFORMAT

BupConfig     BACKUP_system_conf[3];
BupStat	      BACKUP_system_sttb;
BupDir	      BACKUP_system_dir;

Uint32        BACKUP_device;               /*
                                              [Usage]:
                                               BACKUP_device = BACKUP_internal_memory;
                                               or
                                               BACKUP_device = BACKUP_cartridge.
                                           */
char          BACKUP_filename[11];         // You must use 11 characters for the filename to save/load.
char          BACKUP_comment[10];          // You must use 10 characters for the file comment.
Uint8         BACKUP_data_buffer[256];     /*
                                              Adjust this value to the amount of save/load data you're
                                              working with.  The larger you make the array, the more blocks
                                              of memory it'll take up.

                                              Also, remember that data is stored in unsigned integer type.  So
                                              if you're using negative numbers, then you'll have to use a flag
                                              to represent the '-'.  For example:  Say if a character with the
                                              ascii code of '@' is read, then that means the following number
                                              is a negative.

                                              Finally, these BACKUP routines do not save/load the date and time data
                                              automatically.  If you need that data, you're going to have to write it to
                                              this array yourself.
                                           */
int           BACKUP_data_buffer_size = sizeof(BACKUP_data_buffer);
// ==================================================

// ==================================================
//	[GLOBAL STRUCTURES]  :  <<STRUCTURE>>
// --------------------------------------------------
//	[FADE]
typedef struct tag_FADE
{
 int          play_animation;
 int          loop_animation;

 int          show_fade;

 int          current_frame;
 int          total_frames;

 int          use_color_offset;

 int          timer[XYZ];

 int          (*fade_data)[12];
} FADE;
FADE * pFADE;
// --------------------------------------------------
//  [PALETTE2D]
typedef struct tag_PALETTE2D
{
 int          total_colors;

 Uint16       *palette_data;
} PALETTE2D;
PALETTE2D * pPALETTE2D;
// --------------------------------------------------
//	[IMAGE2D_PAL]
typedef struct tag_IMAGE2D_PAL
{
 int          horizontal_size;
 int          vertical_size;

 int          total_colors;

 unsigned char *image_data;
} IMAGE2D_PAL;
IMAGE2D_PAL *pIMAGE2D_PAL;
// --------------------------------------------------
//	[IMAGE2D_32K]
typedef struct tag_IMAGE2D_32K
{
 int          horizontal_size;
 int          vertical_size;

 unsigned short *image_data;
} IMAGE2D_32K;
IMAGE2D_32K *pIMAGE2D_32K;
// --------------------------------------------------
//  [SPRITE2D_ANIMATION_FRAME]
typedef struct tag_SPRITE2D_ANIMATION_FRAME
{
 int          total_frames;

 int          *image2D_number;
 int          *frame_target;
 FIXED        (*frame_position_offset)[XYZ];
} SPRITE2D_ANIMATION_FRAME;
SPRITE2D_ANIMATION_FRAME * pSPRITE2D_ANIMATION_FRAME;
// --------------------------------------------------
//  [SPRITE2D_ANIMATION_MOVEMENT]
typedef struct tag_SPRITE2D_ANIMATION_MOVEMENT
{
 int          total_frames;

 int          (*movement_target)[XYZ];
 FIXED        (*movement_increment)[XYZ];
} SPRITE2D_ANIMATION_MOVEMENT;
SPRITE2D_ANIMATION_MOVEMENT * pSPRITE2D_ANIMATION_MOVEMENT;
// --------------------------------------------------
//  [SPRITE2D_ANIMATION_ROTATION]
typedef struct tag_SPRITE2D_ANIMATION_ROTATION
{
 int          total_frames;

 int          *rotation_target;
 ANGLE        *rotation_increment;
} SPRITE2D_ANIMATION_ROTATION;
SPRITE2D_ANIMATION_ROTATION * pSPRITE2D_ANIMATION_ROTATION;
// --------------------------------------------------
//  [SPRITE2D_ANIMATION_SCALING]
typedef struct tag_SPRITE2D_ANIMATION_SCALING
{
 int          total_frames;

 int          *scaling_target;
 FIXED        *scaling_increment;
} SPRITE2D_ANIMATION_SCALING;
SPRITE2D_ANIMATION_SCALING * pSPRITE2D_ANIMATION_SCALING;
// --------------------------------------------------
//	[SPRITE2D_PAL_BASIC]
typedef struct tag_SPRITE2D_PAL_BASIC
{
 int          show_sprite;

 int          image2D_number;

 FIXED        position[XYZ];
 ANGLE        angle;
 FIXED        scale;

 int          z_distance_affect;

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;

 Uint16       palette_memory_address;
 int          palette_type;
} SPRITE2D_PAL_BASIC;
SPRITE2D_PAL_BASIC * pSPRITE2D_PAL_BASIC;
// --------------------------------------------------
//  [SPRITE2D_PAL_EXTRA]
typedef struct tag_SPRITE2D_PAL_EXTRA
{
 int          show_sprite;

 int          frame_animate;
 int          frame_loop;
 int          frame_current_animation;
 int          frame_current_frame;
 int          frame_timer;

 FIXED        position[XYZ];
 ANGLE        angle;
 FIXED        scale;

 int          z_distance_affect;

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;

 int          flip_sprite;

 Uint16       palette_memory_address;
 int          palette_type;
} SPRITE2D_PAL_EXTRA;
SPRITE2D_PAL_EXTRA * pSPRITE2D_PAL_EXTRA;
// --------------------------------------------------
//  [SPRITE2D_PAL_ADVANCED]
typedef struct tag_SPRITE2D_PAL_ADVANCED
{
 int          show_sprite;

 int          frame_animate;
 int          frame_loop;
 int          frame_current_animation;
 int          frame_current_frame;
 int          frame_timer;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XYZ];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer;

 int          scaling_animate;
 int          scaling_loop;
 int          scaling_current_animation;
 int          scaling_current_frame;
 int          scaling_timer;

 FIXED        position[XYZ];
 ANGLE        angle;
 FIXED        scale;

 int          z_distance_affect;

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;

 int          flip_sprite;

 Uint16       palette_memory_address;
 int          palette_type;
} SPRITE2D_PAL_ADVANCED;
SPRITE2D_PAL_ADVANCED * pSPRITE2D_PAL_ADVANCED;
// --------------------------------------------------
//	[SPRITE2D_32K_BASIC]
typedef struct tag_SPRITE2D_32K_BASIC
{
 int          show_sprite;

 int          image2D_number;

 FIXED        position[XYZ];
 ANGLE        angle;
 FIXED        scale;

 int          z_distance_affect;

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;
} SPRITE2D_32K_BASIC;
SPRITE2D_32K_BASIC * pSPRITE2D_32K_BASIC;
// --------------------------------------------------
//  [SPRITE2D_32K_EXTRA]
typedef struct tag_SPRITE2D_32K_EXTRA
{
 int          show_sprite;

 int          frame_animate;
 int          frame_loop;
 int          frame_current_animation;
 int          frame_current_frame;
 int          frame_timer;

 FIXED        position[XYZ];
 ANGLE        angle;
 FIXED        scale;

 int          z_distance_affect;

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;

 int          flip_sprite;
} SPRITE2D_32K_EXTRA;
SPRITE2D_32K_EXTRA * pSPRITE2D_32K_EXTRA;
// --------------------------------------------------
//  [SPRITE2D_32K_ADVANCED]
typedef struct tag_SPRITE2D_32K_ADVANCED
{
 int          show_sprite;

 int          frame_animate;
 int          frame_loop;
 int          frame_current_animation;
 int          frame_current_frame;
 int          frame_timer;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XYZ];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer;

 int          scaling_animate;
 int          scaling_loop;
 int          scaling_current_animation;
 int          scaling_current_frame;
 int          scaling_timer;

 FIXED        position[XYZ];
 ANGLE        angle;
 FIXED        scale;

 int          z_distance_affect;

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;

 int          flip_sprite;
} SPRITE2D_32K_ADVANCED;
SPRITE2D_32K_ADVANCED * pSPRITE2D_32K_ADVANCED;
// --------------------------------------------------
//  [COLLISION_BOX]
typedef struct tag_COLLISION_BOX
{
 FIXED        collision_left_boundary;
 FIXED        collision_right_boundary;
 FIXED        collision_top_boundary;
 FIXED        collision_bottom_boundary;
 FIXED        collision_front_boundary;
 FIXED        collision_back_boundary;
} COLLISION_BOX;
COLLISION_BOX * pCOLLISION_BOX;
// --------------------------------------------------
//  [MAP2D]
typedef struct tag_MAP2D
{
 int          map_size;

 Uint16       (*map_data)[8];
} MAP2D;
MAP2D *pMAP2D;
// --------------------------------------------------
//  [CEL2D]
typedef struct tag_CEL2D
{
 int          cel_size;

 Uint8        (*cel_data)[8];
} CEL2D;
CEL2D *pCEL2D;
// --------------------------------------------------
//  [SCROLLPLANE_ANIMATION_MAP2D]
typedef struct tag_SCROLLPLANE_ANIMATION_MAP2D
{
 int          total_frames;

 int          *map2D_number;
 int          *map_target;
} SCROLLPLANE_ANIMATION_MAP2D;
SCROLLPLANE_ANIMATION_MAP2D * pSCROLLPLANE_ANIMATION_MAP2D;
// --------------------------------------------------
//  [SCROLLPLANE_ANIMATION_CEL2D]
typedef struct tag_SCROLLPLANE_ANIMATION_CEL2D
{
 int          total_frames;

 int          *cel2D_number;
 int          *cel_target;
} SCROLLPLANE_ANIMATION_CEL2D;
SCROLLPLANE_ANIMATION_CEL2D * pSCROLLPLANE_ANIMATION_CEL2D;
// --------------------------------------------------
//  [SCROLLPLANE_ANIMATION_PALETTE2D]
typedef struct tag_SCROLLPLANE_ANIMATION_PALETTE2D
{
 int          total_frames;

 int          *palette2D_number;
 int          *palette_target;
} SCROLLPLANE_ANIMATION_PALETTE2D;
SCROLLPLANE_ANIMATION_PALETTE2D * pSCROLLPLANE_ANIMATION_PALETTE2D;
// --------------------------------------------------
//  [SCROLLPLANE_ANIMATION_MOVEMENT]
typedef struct tag_SCROLLPLANE_ANIMATION_MOVEMENT
{
 int          total_frames;

 int          (*movement_target)[XYZ];
 FIXED        (*movement_increment)[XYZ];
} SCROLLPLANE_ANIMATION_MOVEMENT;
SCROLLPLANE_ANIMATION_MOVEMENT * pSCROLLPLANE_ANIMATION_MOVEMENT;
// --------------------------------------------------
//  [SCROLLPLANE_ANIMATION_ROTATION]
typedef struct tag_SCROLLPLANE_ANIMATION_ROTATION
{
 int          total_frames;

 int          (*rotation_target)[XYZ];
 ANGLE        (*rotation_increment)[XYZ];
} SCROLLPLANE_ANIMATION_ROTATION;
SCROLLPLANE_ANIMATION_ROTATION * pSCROLLPLANE_ANIMATION_ROTATION;
// --------------------------------------------------
//  [SCROLLPLANE_ANIMATION_SCALING]
typedef struct tag_SCROLLPLANE_ANIMATION_SCALING
{
 int          total_frames;

 int          (*scaling_target)[XY];
 FIXED        (*scaling_increment)[XY];
} SCROLLPLANE_ANIMATION_SCALING;
SCROLLPLANE_ANIMATION_SCALING * pSCROLLPLANE_ANIMATION_SCALING;
// --------------------------------------------------
//  [SCROLLPLANE_BASIC]
typedef struct tag_SCROLLPLANE_BASIC
{
 int          use_scrollplane;

 int          map_animate;
 int          map_loop;
 int          map_current_animation;
 int          map_current_frame;
 int          map_timer;

 int          cel_animate;
 int          cel_loop;
 int          cel_current_animation;
 int          cel_current_frame;
 int          cel_timer;

 int          palette_animate;
 int          palette_loop;
 int          palette_current_animation;
 int          palette_current_frame;
 int          palette_timer;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XY];

 int          scaling_animate;
 int          scaling_loop;
 int          scaling_current_animation;
 int          scaling_current_frame;
 int          scaling_timer[XY];

 FIXED        position[XY];
 FIXED        scale[XY];

 int          current_scrollplane_map;
 int          current_scrollplane_cel;
 int          current_scrollplane_palette;

 int          scrollplane_map_memory_address;
 int          scrollplane_cel_memory_address;
 int          scrollplane_palette_memory_address;

 int          use_palette;
} SCROLLPLANE_BASIC;
SCROLLPLANE_BASIC * pSCROLLPLANE_BASIC;
// --------------------------------------------------
//  [SCROLLPLANE_EXTRA]
typedef struct tag_SCROLLPLANE_EXTRA
{
 int          use_scrollplane;

 int          map_animate;
 int          map_loop;
 int          map_current_animation;
 int          map_current_frame;
 int          map_timer;

 int          cel_animate;
 int          cel_loop;
 int          cel_current_animation;
 int          cel_current_frame;
 int          cel_timer;

 int          palette_animate;
 int          palette_loop;
 int          palette_current_animation;
 int          palette_current_frame;
 int          palette_timer;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XY];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer;

 int          scaling_animate;
 int          scaling_loop;
 int          scaling_current_animation;
 int          scaling_current_frame;
 int          scaling_timer[XY];

 FIXED        position[XY];
 ANGLE        angle;
 FIXED        scale[XY];

 FIXED        rotation_position[XY];

 int          current_scrollplane_map;
 int          current_scrollplane_cel;
 int          current_scrollplane_palette;

 int          scrollplane_map_memory_address;
 int          scrollplane_cel_memory_address;
 int          scrollplane_palette_memory_address;

 int          rotation_parameter_memory_address;

 int          use_palette;
} SCROLLPLANE_EXTRA;
SCROLLPLANE_EXTRA * pSCROLLPLANE_EXTRA;
// --------------------------------------------------
//  [SCROLLPLANE_ADVANCED]
typedef struct tag_SCROLLPLANE_ADVANCED
{
 int          use_scrollplane;

 int          map_animate;
 int          map_loop;
 int          map_current_animation;
 int          map_current_frame;
 int          map_timer;

 int          cel_animate;
 int          cel_loop;
 int          cel_current_animation;
 int          cel_current_frame;
 int          cel_timer;

 int          palette_animate;
 int          palette_loop;
 int          palette_current_animation;
 int          palette_current_frame;
 int          palette_timer;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XYZ];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer[XYZ];

 int          scaling_animate;
 int          scaling_loop;
 int          scaling_current_animation;
 int          scaling_current_frame;
 int          scaling_timer[XY];

 FIXED        position[XYZ];
 ANGLE        angle[XYZ];
 FIXED        scale[XY];

 FIXED        rotation_position[XY];

 int          current_scrollplane_cel;
 int          current_scrollplane_map;
 int          current_scrollplane_palette;

 int          scrollplane_cel_memory_address;
 int          scrollplane_map_memory_address;
 int          scrollplane_palette_memory_address;

 int          rotation_parameter_memory_address;
 int          rotation_table_memory_address;

 int          use_palette;
} SCROLLPLANE_ADVANCED;
SCROLLPLANE_ADVANCED * pSCROLLPLANE_ADVANCED;
// --------------------------------------------------
//  [LIGHT_SOURCE_ANIMATION_MOVEMENT]
typedef struct tag_LIGHT_SOURCE_ANIMATION_MOVEMENT
{
 int          total_frames;

 int          (*movement_target)[XYZ];
 FIXED        (*movement_increment)[XYZ];
} LIGHT_SOURCE_ANIMATION_MOVEMENT;
LIGHT_SOURCE_ANIMATION_MOVEMENT * pLIGHT_SOURCE_ANIMATION_MOVEMENT;
// --------------------------------------------------
//  [LIGHT_SOURCE_ANIMATION_ROTATION]
typedef struct tag_LIGHT_SOURCE_ANIMATION_ROTATION
{
 int          total_frames;

 int          (*rotation_target)[XYZ];
 ANGLE        (*rotation_increment)[XYZ];
 ANGLE        (*rotation_final_position)[4];
} LIGHT_SOURCE_ANIMATION_ROTATION;
LIGHT_SOURCE_ANIMATION_ROTATION * pLIGHT_SOURCE_ANIMATION_ROTATION;
// --------------------------------------------------
//  [LIGHT_SOURCE]
typedef struct tag_LIGHT_SOURCE
{
 int          show_sprite;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XYZ];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer[XYZ];

 FIXED        position[XYZ];
 ANGLE        angle[XYZ];
 FIXED        light_vector[XYZ];

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;
} LIGHT_SOURCE;
LIGHT_SOURCE * pLIGHT_SOURCE;
// --------------------------------------------------
//  [CAMERA_SOURCE_ANIMATION_MOVEMENT]
typedef struct tag_CAMERA_SOURCE_ANIMATION_MOVEMENT
{
 int          total_frames;

 int          (*movement_target)[XYZ];
 FIXED        (*movement_increment)[XYZ];
} CAMERA_SOURCE_ANIMATION_MOVEMENT;
CAMERA_SOURCE_ANIMATION_MOVEMENT * pCAMERA_SOURCE_ANIMATION_MOVEMENT;
// --------------------------------------------------
//  [CAMERA_SOURCE_ANIMATION_ROTATION]
typedef struct tag_CAMERA_SOURCE_ANIMATION_ROTATION
{
 int          total_frames;

 int          (*rotation_target)[XYZ];
 ANGLE        (*rotation_increment)[XYZ];
 ANGLE        (*rotation_final_position)[4];
} CAMERA_SOURCE_ANIMATION_ROTATION;
CAMERA_SOURCE_ANIMATION_ROTATION * pCAMERA_SOURCE_ANIMATION_ROTATION;
// --------------------------------------------------
//  [CAMERA_SOURCE]
typedef struct tag_CAMERA_SOURCE
{
 int          show_sprite;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XYZ];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer[XYZ];

 FIXED        position[XYZ];
 ANGLE        angle[XYZ];
 FIXED        camera_target[XYZ];

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;
} CAMERA_SOURCE;
CAMERA_SOURCE * pCAMERA_SOURCE;
// --------------------------------------------------
//	[IMAGE3D]
typedef struct tag_IMAGE3D
{
 int          total_vertices;
 int          total_polygons;

 POINT        *model_points;
 POLYGON      *model_polygons;
 ATTR         *model_attributes;

 PDATA        model_data;
} IMAGE3D;
IMAGE3D * pIMAGE3D;
// --------------------------------------------------
// [SPRITE3D_ANIMATION_MOVEMENT]
typedef struct tag_SPRITE3D_ANIMATION_MOVEMENT
{
 int          total_frames;

 int          (*movement_target)[XYZ];
 FIXED        (*movement_increment)[XYZ];
} SPRITE3D_ANIMATION_MOVEMENT;
SPRITE3D_ANIMATION_MOVEMENT * pSPRITE3D_ANIMATION_MOVEMENT;
// --------------------------------------------------
// [SPRITE3D_ANIMATION_ROTATION]
typedef struct tag_SPRITE3D_ANIMATION_ROTATION
{
 int          total_frames;

 int          (*rotation_target)[XYZ];
 ANGLE        (*rotation_increment)[XYZ];
 ANGLE        (*rotation_final_position)[4];
} SPRITE3D_ANIMATION_ROTATION;
SPRITE3D_ANIMATION_ROTATION * pSPRITE3D_ANIMATION_ROTATION;
// --------------------------------------------------
// [SPRITE3D_ANIMATION_SCALING]
typedef struct tag_SPRITE3D_ANIMATION_SCALING
{
 int          total_frames;

 int          (*scaling_target)[XYZ];
 FIXED        (*scaling_increment)[XYZ];
} SPRITE3D_ANIMATION_SCALING;
SPRITE3D_ANIMATION_SCALING * pSPRITE3D_ANIMATION_SCALING;
// --------------------------------------------------
//  [SPRITE3D]
typedef struct tag_SPRITE3D
{
 int          show_sprite;

 int          image3D_number;

 int          movement_animate;
 int          movement_loop;
 int          movement_current_animation;
 int          movement_current_frame;
 int          movement_timer[XYZ];

 int          rotation_animate;
 int          rotation_loop;
 int          rotation_current_animation;
 int          rotation_current_frame;
 int          rotation_timer[XYZ];

 int          scaling_animate;
 int          scaling_loop;
 int          scaling_current_animation;
 int          scaling_current_frame;
 int          scaling_timer[XYZ];

 FIXED        position[XYZ];
 ANGLE        angle[XYZ];
 FIXED        scale[XYZ];

 int          clipping_check;
 FIXED        clipping_left_boundary;
 FIXED        clipping_right_boundary;
 FIXED        clipping_top_boundary;
 FIXED        clipping_bottom_boundary;
 FIXED        clipping_front_boundary;
 FIXED        clipping_back_boundary;
} SPRITE3D;
SPRITE3D * pSPRITE3D;
// --------------------------------------------------
//  [SPRITE3D_ANIMATION_TEXTURE]
typedef struct tag_SPRITE3D_ANIMATION_TEXTURE
{
 int          total_frames;

 int          *image2D_number;

 FIXED        *frame_target;
 FIXED        *frame_increment;
} SPRITE3D_ANIMATION_TEXTURE;
SPRITE3D_ANIMATION_TEXTURE * pSPRITE3D_ANIMATION_TEXTURE;
// --------------------------------------------------
//  [SPRITE3D_TEXTURE]
typedef struct tag_SPRITE3D_TEXTURE
{
 int          show_sprite;

 int          frame_animate;
 int          frame_loop;
 int          frame_current_animation;
 int          frame_current_frame;
 FIXED        frame_timer;
} SPRITE3D_TEXTURE;
SPRITE3D_TEXTURE * pSPRITE3D_TEXTURE;
// --------------------------------------------------
//	[SOUND_PCM]
typedef struct tag_SOUND_PCM
{
 Uint32       sound_size;

 char         *sound_data;

 PCM          sound_info;
} SOUND_PCM;
SOUND_PCM * pSOUND_PCM;
// --------------------------------------------------
//  [SOUND_ANIMATION_PCM]
typedef struct tag_SOUND_ANIMATION_PCM
{
 int          total_frames;

 int          *frame_target;
 int          *pcm_number;
} SOUND_ANIMATION_PCM;
SOUND_ANIMATION_PCM * pSOUND_ANIMATION_PCM;
// --------------------------------------------------
//  [SOUND_SPRITE_PCM]
typedef struct tag_SOUND_SPRITE_PCM
{
 int          play_sprite;

 int          frame_animate;
 int          frame_loop;
 int          frame_current_animation;
 int          frame_current_frame;
 int          frame_timer;

 int          play_mode;
} SOUND_SPRITE_PCM;
SOUND_SPRITE_PCM * pSOUND_SPRITE_PCM;
// ==================================================
//	[END OF FILE]        :  <<EOF>>
// ==================================================
