// ==================================================
//	[INCLUDED FILES]     :  <<INCLUDE>>
// --------------------------------------------------
#include      "E2_def.h"
// ==================================================

// ==================================================
//	[START OF ROUTINES]  :  <<SOR>>
// ==================================================
//	[ASCII]              :  <<ASCII>>
// --------------------------------------------------
int e2_ASCII_reference_table(int temp1)
{
 /*
    temp1 = The ASCII character value to find.
 */
 switch(temp1)
 {
  case 43:
   temp1 = 0;
   break;

  case 45:
   temp1 = -1;
   break;

  case 48:
   temp1 = 0;
   break;

  case 49:
   temp1 = 1;
   break;

  case 50:
   temp1 = 2;
   break;

  case 51:
   temp1 = 3;
   break;

  case 52:
   temp1 = 4;
   break;

  case 53:
   temp1 = 5;
   break;

  case 54:
   temp1 = 6;
   break;

  case 55:
   temp1 = 7;
   break;

  case 56:
   temp1 = 8;
   break;

  case 57:
   temp1 = 9;
   break;
 }
 return(temp1);
}
// ==================================================
//	[CDROM]              :  <<CDROM>>
// --------------------------------------------------
int e2_CDROM_initialize()
{
 Sint32  CDROM_return_value;
 CdcStat CDROM_status;
 volatile int CDROM_delay;
 CDROM_syscdinit1(3);
 CDROM_syscdinit2();
 do
 {
  for(CDROM_delay = 100000; CDROM_delay; CDROM_delay--);
  CDROM_return_value = CDC_GetCurStat(&CDROM_status);
 } while ((CDROM_return_value != 0) || (CDC_STAT_STATUS(&CDROM_status) == 0xff));
 return (int) CDC_STAT_STATUS(&CDROM_status);
}
// --------------------------------------------------
void e2_CDROM_clear_data_buffer(void)
{
 slCdResetBuf(CDROM_cdhn, &CDROM_key[0]);
 CDROM_data_buffer_location = 0;
 return;
}
// --------------------------------------------------
void e2_CDROM_load_file(char temp1[])
{
 /*
    temp1 = The name of the file to open from CD-ROM.
 */
 CDROM_ndir = slCdInit(CDROM_max_open, CDROM_lib_work);
 CDROM_key[0].cn = CDROM_key[0].sm = CDROM_key[0].ci = CDKEY_NONE;
 CDROM_key[1].cn = CDKEY_TERM;
 CDROM_cdhn = slCdOpen(temp1, CDROM_key);
 slPrint("slCdInit:", slLocate(2, 1)); slPrintFX(toFIXED(CDROM_ndir), slLocate(12, 1));
 slPrint("slCdOpen:", slLocate(2, 2)); slDispHex((Uint32)CDROM_cdhn,  slLocate(12, 2));
 CDROM_buffer[0].type = CDBUF_COPY;
 CDROM_buffer[0].trans.copy.addr = CDROM_data_buffer;
 CDROM_buffer[0].trans.copy.unit = CDBUF_FORM1;
 CDROM_buffer[0].trans.copy.size = CDROM_slsize;
 CDROM_buffer[1].type = CDBUF_TERM;
 CDROM_data_buffer_location = 0;
 e2_CDROM_clear_data_buffer();
 slCdLoadFile(CDROM_cdhn, CDROM_buffer);
 while(1)
 {
  CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata);
  if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED)
  {
   break;
  }
 }
 return;
}
// --------------------------------------------------
int e2_CDROM_read_number(int temp1)
{
 /*
    temp1 = The number of places the number has (1 - 9).
            If 9 is specified then it means you have an 8 digit number with a +/- sign at the front.
 */
 int number_1 = 0, number_2 = 0, number_3 = 0, number_4 = 0, number_5 = 0, number_6 = 0, number_7 = 0, number_8 = 0, number_9 = 0, number_place, final_number;
 switch(temp1)
 {
  case 1:
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

  case 2:
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

  case 3:                                                                                                                
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

   case 4:
   number_place = 1000;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

   case 5:
   number_place = 10000;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

   case 6:
   number_place = 100000;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10000;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000;
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

   case 7:
   number_place = 1000000;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100000;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10000;                                                                                                   
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000;
   if(CDROM_data_buffer_location < 4096){number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_7 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_7 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

   case 8:
   number_place = 10000000;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000000;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100000;
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10000;
   if(CDROM_data_buffer_location < 4096){number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000;                                                                                                  
   if(CDROM_data_buffer_location < 4096){number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;                                                                                                    
   if(CDROM_data_buffer_location < 4096){number_7 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_7 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_8 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_8 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;

   case 9:
   number_place = 100000000;
   if(CDROM_data_buffer_location < 4096){number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_1 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10000000;
   if(CDROM_data_buffer_location < 4096){number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_2 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000000;
   if(CDROM_data_buffer_location < 4096){number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_3 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100000;
   if(CDROM_data_buffer_location < 4096){number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_4 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10000;
   if(CDROM_data_buffer_location < 4096){number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_5 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1000;
   if(CDROM_data_buffer_location < 4096){number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_6 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 100;
   if(CDROM_data_buffer_location < 4096){number_7 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_7 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 10;
   if(CDROM_data_buffer_location < 4096){number_8 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_8 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   number_place = 1;
   if(CDROM_data_buffer_location < 4096){number_9 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} else{e2_CDROM_clear_data_buffer(); while(1){CDROM_return_value = slCdGetStatus(CDROM_cdhn, CDROM_ndata); if(CDROM_ndata[0] == 4096 || CDROM_return_value == CDSTAT_COMPLETED){break;}}number_9 = e2_ASCII_reference_table(CDROM_data_buffer[CDROM_data_buffer_location]) * number_place;} CDROM_data_buffer_location++;
   break;
 }
 if(number_1 < 0)
 {
  final_number = number_2 + number_3 + number_4 + number_5 + number_6 + number_7 + number_8 + number_9;
  final_number *= -1;
 }
 else
  final_number = number_1 + number_2 + number_3 + number_4 + number_5 + number_6 + number_7 + number_8 + number_9;
 return(final_number);
}
// ==================================================
//	[RAMCART]            :  <<RAMCART>>
// --------------------------------------------------
int e2_RAMCART_initialize()
{
 /*
    [NOTE]:
      RAM-CART memory starting address  = (void*)0x22400000.
 */
 int      temp1, temp2 = 1;
 Uint32   temp3 = 0;

 slDMACopy((void*)&temp2, (void*)0x257EFFFE, (int)1);

 slDMACopy((void*)0x24FFFFFF, (void*)&temp3, (Uint32)1);
 if(temp3 == 0x5A000000){temp1 = 1;}     // return a 1 for a 1-meg ram-cart.
 if(temp3 == 0x5C000000){temp1 = 4;}     // return a 4 for a 4-meg ram-cart.
 if(temp3 != 0x5A000000 && temp3 != 0x5C000000){temp1 = NONE; return(temp1);}     // return 'NONE' for no ram-cart at all!

 temp3 = 0x23301FF0;
 slDMACopy((void*)&temp3, (void*)0x25FE0080, (Uint32)1);
 temp3 = 0x00000013;
 slDMACopy((void*)&temp3, (void*)0x25FE0033, (Uint32)1);
 return(temp1);
}
// ==================================================
//	[CONTROLPAD]         :  <<CONTROLPAD>>
// --------------------------------------------------
void e2_CONTROLPAD_check_buttons(int temp1)
{
 /*
    temp1 = The controlpad to check.
            Specify either CONTROLPAD_1 or CONTROLPAD_2.
 */
 int           temp4;
 static Sint32 temp5;
 Uint16        data;
 PerAnalog     *analog_data;

 if(temp1 == CONTROLPAD_1) if(!Per_Connect1) return;
 if(temp1 == CONTROLPAD_2) if(!Per_Connect2) return;

 temp4 = e2_PERIPHERAL_check_whats_connected(temp1);

 if(temp4 == PERIPHERAL_CONTROLPAD_DIGITAL)
 {
  data = Smpc_Peripheral[temp1].data;
  CONTROLPAD_analog_x = 0;
  CONTROLPAD_analog_y = 0;
  CONTROLPAD_analog_z = 0;
  for(temp5 = 0; temp5 < 13; temp5++)
  {
   if((data & CONTROLPAD_button_layout[temp5]) == 0){CONTROLPAD_button[temp5] = YES;}
   if((data & CONTROLPAD_button_layout[temp5]) != 0){CONTROLPAD_button[temp5] = NO;}
  }
  return;
 }

 if(temp4 = PERIPHERAL_CONTROLPAD_ANALOG)
 {
  analog_data = (PerAnalog *)Smpc_Peripheral;
  data = Smpc_Peripheral[temp1].data;
  CONTROLPAD_analog_x = analog_data[temp1].x;
  CONTROLPAD_analog_y = analog_data[temp1].y;
  CONTROLPAD_analog_z = analog_data[temp1].z;
  for(temp5 = 0; temp5 < 13; temp5++)
  {
   if((data & CONTROLPAD_button_layout[temp5]) == 0){CONTROLPAD_button[temp5] = YES;}
   if((data & CONTROLPAD_button_layout[temp5]) != 0){CONTROLPAD_button[temp5] = NO;}
  }
 }
 return;
}
// ==================================================
//	[VIRTUAGUN]          :  <<VIRTUAGUN>>
// --------------------------------------------------
static Uint8 e2_VIRTUAGUN_system_control_0(Uint8 pd1, Uint8 pd0)
{
 Uint8 mid;

 pd1  = (pd1 & 0x0a) | ((pd1 & 0x05) << 1);
 mid  = (pd1 & 0x08) | ((pd1 & 0x02) << 1);
 pd0  = (pd0 & 0x05) | ((pd0 & 0x0a) >> 1);
 mid |= (pd0 & 0x01) | ((pd0 & 0x04) >> 1);
 return(mid);
}
// --------------------------------------------------
static void e2_VIRTUAGUN_system_control_1()
{
 PerPoint* pPerPoint;
 Uint8 pd1, pd0, mid;

 if(SynchCount) return;
 pPerPoint = (PerPoint*)(&(Smpc_Peripheral[0]));
 if((GunCtrlFlag1P)&&(pPerPoint->id == PER_ID_StnShooting))
 {
  slSetPortDir1(0x40);
  pd1 = slGetPortData1();
  slSetPortDir1(0x00);
  pd0 = slGetPortData1();
  mid = e2_VIRTUAGUN_system_control_0(pd1, pd0);
  if(mid != MEGA_ID_StnShooting)
  {
   GunCtrlFlag1P = FALSE;
   slIntBackCancel();
  }
 }

 pPerPoint = (PerPoint*)(&(Smpc_Peripheral[15]));
 if((GunCtrlFlag2P)&&(pPerPoint->id == PER_ID_StnShooting))
 {
  slSetPortDir2(0x40);
  pd1 = slGetPortData2();
  slSetPortDir2(0x00);
  pd0 = slGetPortData2();
  mid = e2_VIRTUAGUN_system_control_0(pd1, pd0);
  if(mid != MEGA_ID_StnShooting)
  {
   GunCtrlFlag2P = FALSE;
   slIntBackCancel();
  }
 }
}
// --------------------------------------------------
static void e2_VIRTUAGUN_initialize()
{
 int temp1;
 VDP2_EXTEN = 0x0200;
 GunCtrlFlag1P = GunCtrlFlag2P = FALSE;
 slGetStatus();
 slIntFunction(e2_VIRTUAGUN_system_control_1);

 for(temp1 = 0; temp1 != 2; temp1++)
 {
  VIRTUAGUN_data[temp1][3] = VIRTUAGUN_data[temp1][4] = toFIXED(1.0);
  VIRTUAGUN_data[temp1][5] = VIRTUAGUN_data[temp1][6] = toFIXED(0.0);
  VIRTUAGUN_data[temp1][7] = VIRTUAGUN_data[temp1][8] = toFIXED(0.0);
 }
}
// --------------------------------------------------
static void e2_VIRTUAGUN_system_control_2()
{
 PerPoint* pPerPoint;
 static Uint8 id1 = PER_ID_StnShooting;
 static Uint8 id2 = PER_ID_StnShooting;

 if(!(slCheckIntBackSet()))
 {
  if(GunCtrlFlag1P)
  {
   slSetPortDir1(0x00);
   slSetPortData1(0x7f);
   slSetPortSelect1(SMPC_SH2_DIRECT);
  }
  else
  {
   slSetPortSelect1(SMPC_CONTROL);
   slSetPortExt1(SMPC_EXL_DIS);
  }
  if(GunCtrlFlag2P)
  {
   slSetPortDir2(0x00);
   slSetPortData2(0x7f);
   slSetPortSelect2(SMPC_SH2_DIRECT);
  }
  else
  {
   slSetPortSelect2(SMPC_CONTROL);
   slSetPortExt2(SMPC_EXL_DIS);
  }
  slGetStatus();
  return;
 }

 pPerPoint = (PerPoint*)(&(Smpc_Peripheral[0]));
 if((id1 != PER_ID_NotConnect)&& (pPerPoint->id == (MEGA_ID_StnShooting | 0xf0)))
 {
  GunCtrlFlag1P = TRUE;
  slIntBackCancel();
 }
 id1 = pPerPoint->id;

 pPerPoint = (PerPoint*)(&(Smpc_Peripheral[15]));
 if((id2 != PER_ID_NotConnect)&& (pPerPoint->id == (MEGA_ID_StnShooting | 0xf0)))
 {
  GunCtrlFlag2P = TRUE;
  slIntBackCancel();
 }
 id2 = pPerPoint->id;
}
// --------------------------------------------------
e2_VIRTUAGUN_check(int temp1)
{
 /*
    temp1 = The virtuagun to check.
            Specify either VIRTUAGUN_1 or VIRTUAGUN_2.
 */
 int       temp3 = 0;
 PerPoint* pPerPoint;

 if(temp1 == VIRTUAGUN_1)
 {
  temp3 = 0;
  if(!Per_Connect1) return;
 }
 if(temp1 == VIRTUAGUN_2)
 {
  temp3 = 15;
  if(!Per_Connect2) return;
 }
 if(temp1 != VIRTUAGUN_1 && temp1 != VIRTUAGUN_2) return;

 e2_VIRTUAGUN_system_control_2();
 pPerPoint = (PerPoint*)(&(Smpc_Peripheral[temp3]));

 if(pPerPoint->id == PER_ID_StnShooting)
 {
  VIRTUAGUN_data[temp1][VIRTUAGUN_x_position] = toFIXED(pPerPoint->x);
  VIRTUAGUN_data[temp1][VIRTUAGUN_y_position] = toFIXED(pPerPoint->y);
  VIRTUAGUN_data[temp1][VIRTUAGUN_button]     = pPerPoint->data;

  if(VIRTUAGUN_data[temp1][VIRTUAGUN_x_position] >= toFIXED(699.0)) VIRTUAGUN_data[temp1][VIRTUAGUN_x_position] -= VIRTUAGUN_HRes_Correction;

  VIRTUAGUN_data[temp1][VIRTUAGUN_x_position] += VIRTUAGUN_data[temp1][5];
  VIRTUAGUN_data[temp1][VIRTUAGUN_x_position]  = slDivFX(VIRTUAGUN_data[temp1][3], VIRTUAGUN_data[temp1][VIRTUAGUN_x_position]);
  VIRTUAGUN_data[temp1][VIRTUAGUN_x_position] -= VIRTUAGUN_data[temp1][7];

  VIRTUAGUN_data[temp1][VIRTUAGUN_y_position] += VIRTUAGUN_data[temp1][6];
  VIRTUAGUN_data[temp1][VIRTUAGUN_y_position]  = slDivFX(VIRTUAGUN_data[temp1][4], VIRTUAGUN_data[temp1][VIRTUAGUN_y_position]);
  VIRTUAGUN_data[temp1][VIRTUAGUN_y_position] -= VIRTUAGUN_data[temp1][8];
 }
 return;
}
// --------------------------------------------------
e2_VIRTUAGUN_calibrate(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The virtuagun to check.
            Specify either VIRTUAGUN_1 or VIRTUAGUN_2.
    temp2 = The Horizontal screen resolution.
    temp3 = The Vertical screen resolution
 */
 FIXED  temp4 = toFIXED(0.0);

 slPrint("Calibration Mode:      ", slLocate(2, 20));
 slPrint("  Shoot screen center to calibrate.", slLocate(2, 21));
 slPrint("  Shoot offscreen to exit.", slLocate(2, 22));
 while(VIRTUAGUN_data[temp1][VIRTUAGUN_button] == VIRTUAGUN_t_button){e2_VIRTUAGUN_check(temp1); slSynch();}   // While trigger is pulled.
 while(VIRTUAGUN_data[temp1][VIRTUAGUN_button] != VIRTUAGUN_t_button){e2_VIRTUAGUN_check(temp1); slSynch();}   // While trigger is not pulled.

 if(VIRTUAGUN_data[temp1][X] == 0 && VIRTUAGUN_data[temp1][Y] == 0) // This only happens if they cancel (shoot offscreen).
 {
  slPrint("Calibration Cancelled: ", slLocate(2, 20));
  slPrint("  Pull the trigger to exit.        ", slLocate(2, 21));
  slPrint("                          ", slLocate(2, 22));

  while(VIRTUAGUN_data[temp1][VIRTUAGUN_button] == VIRTUAGUN_t_button){e2_VIRTUAGUN_check(temp1); slSynch();}  // While the trigger is pulled.
  while(VIRTUAGUN_data[temp1][VIRTUAGUN_button] != VIRTUAGUN_t_button){e2_VIRTUAGUN_check(temp1); slSynch();}  // While trigger is not pulled.
  slPrint("                       ", slLocate(2, 20));
  slPrint("                                   ", slLocate(2, 21));
  VIRTUAGUN_data[temp1][3] = VIRTUAGUN_data[temp1][4] = toFIXED(1.0);
  VIRTUAGUN_data[temp1][5] = VIRTUAGUN_data[temp1][6] = toFIXED(0.0);
  VIRTUAGUN_data[temp1][7] = VIRTUAGUN_data[temp1][8] = toFIXED(0.0);
  return;
 }

 VIRTUAGUN_data[temp1][3] = slDivFX(toFIXED(temp2), toFIXED(699.0));
 VIRTUAGUN_data[temp1][4] = slDivFX(toFIXED(temp3), toFIXED(233.0));

 temp4 = slDivFX(toFIXED(2.0), toFIXED(699.0));
 VIRTUAGUN_data[temp1][5] = temp4 - VIRTUAGUN_data[temp1][VIRTUAGUN_x_position];
 temp4 = slDivFX(toFIXED(2.0), toFIXED(233.0));
 VIRTUAGUN_data[temp1][6] = temp4 - VIRTUAGUN_data[temp1][VIRTUAGUN_y_position];

 VIRTUAGUN_data[temp1][7] = slDivFX(toFIXED(2.0), toFIXED(temp2));
 VIRTUAGUN_data[temp1][8] = slDivFX(toFIXED(2.0), toFIXED(temp3));

 slPrint("Calibration Completed: ", slLocate(2, 20));
 slPrint("  Pull the trigger to exit.        ", slLocate(2, 21));
 slPrint("                          ", slLocate(2, 22));
 while(VIRTUAGUN_data[temp1][VIRTUAGUN_button] == VIRTUAGUN_t_button){e2_VIRTUAGUN_check(temp1); slSynch();}  // While the trigger is pulled.
 while(VIRTUAGUN_data[temp1][VIRTUAGUN_button] != VIRTUAGUN_t_button){e2_VIRTUAGUN_check(temp1); slSynch();}  // While trigger is not pulled.
 slPrint("                       ", slLocate(2, 20));
 slPrint("                                   ", slLocate(2, 21));
 return;
}
// ==================================================
//	[PERIPHERAL]         :  <<PERIPHERAL>>
// --------------------------------------------------
e2_PERIPHERAL_check_whats_connected(int temp1)
{
 /*
    temp1 = The controlport to check.
            Specify either CONTROLPORT_1 or CONTROLPORT_2.
 */
 Uint8     temp2 = PERIPHERAL_NONE;
 PerPoint* pPerPoint;

 e2_VIRTUAGUN_system_control_2();
 pPerPoint = (PerPoint*)(&(Smpc_Peripheral[temp1]));
 temp2 = pPerPoint->id;
 return(temp2);
}
// ==================================================
//	[BACKCOLOR]          :  <<BACKCOLOR>>
// --------------------------------------------------
void e2_BACKCOLOR_setup(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The Red color value   (0 - 31).
    temp2 = The Green color value (0 - 31).
    temp3 = The Blue color value  (0 - 31).
 */
 temp1 = (temp1);
 temp2 = (temp2 << 5);
 temp3 = (temp3 << 10);
 slBack1ColSet((void*)BACK_COL_ADR, (temp1|temp2|temp3|RGB_Flag));
 return;
}
// ==================================================
//	[FADE] :  <<FADE>>
// --------------------------------------------------
e2_FADE_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of sprite slots.
    temp2 = The desired number of sprite slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pFADE = (FADE*)realloc(pFADE, temp2 * sizeof(FADE));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pFADE[temp3].fade_data);
  }
  pFADE = (FADE*)realloc(pFADE, temp2 * sizeof(FADE));
 }
 return;
}
// --------------------------------------------------
e2_FADE_setup(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8, int temp9, int temp10)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = Whether to play the sprite's animation or not.
             Specify either YES or NO.
    temp4  = Whether to loop the sprite's animation or not.
             Specify either YES or NO.
    temp5  = The current frame number in the sprite's animation.
    temp6  = The total number of frames in the sprite's animation.
    temp7  = The color offset for the sprite to use.
             Specify either offset_A or offset_B.
    temp8  = The sprite animation's Red timer value.
    temp9  = The sprite animation's Green timer value.
    temp10 = The sprite animation's Blue timer value.
 */
 pFADE[temp1].show_fade = temp2;
 pFADE[temp1].play_animation = temp3;
 pFADE[temp1].loop_animation = temp4;
 pFADE[temp1].current_frame = temp5;
 pFADE[temp1].total_frames = temp6;
 pFADE[temp1].use_color_offset = temp7;
 pFADE[temp1].timer[X] = temp8;
 pFADE[temp1].timer[Y] = temp9;
 pFADE[temp1].timer[Z] = temp10;
 return;
}
// --------------------------------------------------
e2_FADE_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = The desired number of frames in the sprite's animation.
 */
 pFADE[temp1].fade_data = (int(*)[12])realloc(pFADE[temp1].fade_data, temp2 * sizeof(int * [12]));
 return;
}
// --------------------------------------------------
e2_FADE_setup_frame(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8, int temp9, int temp10, int temp11, int temp12, int temp13, int temp14)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The animation frame number to edit.
    temp3  = Whether or not to animate the frame.
             Specify either YES or NO.
    temp4  = The current Red value of the sprite.
             Specify a value between 257 and 767 (257 = black, 512 = clear, 767 = white).
    temp5  = The current Green value of the sprite.
             Specify a value between 257 and 767 (257 = black, 512 = clear, 767 = white).
    temp6  = The current Blue value of the sprite.
             Specify a value between 257 and 767 (257 = black, 512 = clear, 767 = white).
    temp7  = The desired final Red value.
             Specify a value between 257 and 767 (257 = black, 512 = clear, 767 = white).
    temp8  = The desired final Green value.
             Specify a value between 257 and 767 (257 = black, 512 = clear, 767 = white).
    temp9  = The desired final Blue value.
             Specify a value between 257 and 767 (257 = black, 512 = clear, 767 = white).
    temp10 = The Red increment-per-frame amount.
    temp11 = The Green increment-per-frame amount.
    temp12 = The Blue increment-per-frame amount.
    temp13 = The frame's delay value (How long to display the current frame onscreen).
    temp14 = The frame's delay counter value.
    [Note]:
     Remember to use 'slColOffsetOn' to set the planes offset_A effects, and use
     'slColOffsetBUse' to set the planes offset_B effects!!
 */
 pFADE[temp1].fade_data[temp2][0] = temp3;
 pFADE[temp1].fade_data[temp2][1] = temp4;
 pFADE[temp1].fade_data[temp2][2] = temp5;
 pFADE[temp1].fade_data[temp2][3] = temp6;
 pFADE[temp1].fade_data[temp2][4] = temp7;
 pFADE[temp1].fade_data[temp2][5] = temp8;
 pFADE[temp1].fade_data[temp2][6] = temp9;
 pFADE[temp1].fade_data[temp2][7] = temp10;
 pFADE[temp1].fade_data[temp2][8] = temp11;
 pFADE[temp1].fade_data[temp2][9] = temp12;
 pFADE[temp1].fade_data[temp2][10] = temp13;
 pFADE[temp1].fade_data[temp2][11] = temp14;
 return;
}
// --------------------------------------------------
e2_FADE_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int red_value = (pFADE[temp1].fade_data[pFADE[temp1].current_frame][1] + pFADE[temp1].timer[X]);
 int green_value = (pFADE[temp1].fade_data[pFADE[temp1].current_frame][2] + pFADE[temp1].timer[Y]);
 int blue_value = (pFADE[temp1].fade_data[pFADE[temp1].current_frame][3] + pFADE[temp1].timer[Z]);

 if(pFADE[temp1].play_animation == YES)
 {
  if(pFADE[temp1].current_frame != pFADE[temp1].total_frames)
  {
   if(pFADE[temp1].fade_data[pFADE[temp1].current_frame][0] == YES)
   {
    if(pFADE[temp1].fade_data[pFADE[temp1].current_frame][11] >= pFADE[temp1].fade_data[pFADE[temp1].current_frame][10])
    {
     if(red_value < 257) red_value = 257; else if(red_value > 767) red_value = 767;
     if(green_value < 257) green_value = 257; else if(green_value > 767) red_value = 767;
     if(blue_value < 257) blue_value = 257; else if(blue_value > 767) red_value = 767;   

     if(pFADE[temp1].show_fade == YES)
     {
      if(pFADE[temp1].use_color_offset == offset_A) slColOffsetA(red_value, green_value, blue_value);
      if(pFADE[temp1].use_color_offset == offset_B) slColOffsetB(red_value, green_value, blue_value);
     }

     if((pFADE[temp1].fade_data[pFADE[temp1].current_frame][1] + pFADE[temp1].timer[X]) != pFADE[temp1].fade_data[pFADE[temp1].current_frame][4]){pFADE[temp1].timer[X] += pFADE[temp1].fade_data[pFADE[temp1].current_frame][7];}
     if((pFADE[temp1].fade_data[pFADE[temp1].current_frame][2] + pFADE[temp1].timer[Y]) != pFADE[temp1].fade_data[pFADE[temp1].current_frame][5]){pFADE[temp1].timer[Y] += pFADE[temp1].fade_data[pFADE[temp1].current_frame][8];}
     if((pFADE[temp1].fade_data[pFADE[temp1].current_frame][3] + pFADE[temp1].timer[Z]) != pFADE[temp1].fade_data[pFADE[temp1].current_frame][6]){pFADE[temp1].timer[Z] += pFADE[temp1].fade_data[pFADE[temp1].current_frame][9];}
     pFADE[temp1].fade_data[pFADE[temp1].current_frame][11] = 0;
    }
    else
     pFADE[temp1].fade_data[pFADE[temp1].current_frame][11]++;
    if((pFADE[temp1].fade_data[pFADE[temp1].current_frame][1] + pFADE[temp1].timer[X]) == pFADE[temp1].fade_data[pFADE[temp1].current_frame][4] && (pFADE[temp1].fade_data[pFADE[temp1].current_frame][2] + pFADE[temp1].timer[Y]) == pFADE[temp1].fade_data[pFADE[temp1].current_frame][5] && (pFADE[temp1].fade_data[pFADE[temp1].current_frame][3] + pFADE[temp1].timer[Z]) == pFADE[temp1].fade_data[pFADE[temp1].current_frame][6])
    {
     pFADE[temp1].fade_data[pFADE[temp1].current_frame][11] = 0;
     pFADE[temp1].current_frame++;
     pFADE[temp1].timer[X] = pFADE[temp1].timer[Y] = pFADE[temp1].timer[Z] = 0;
    }
   }
   else
    pFADE[temp1].current_frame++;
  }
  else
   if(pFADE[temp1].loop_animation == YES)
   {
    pFADE[temp1].current_frame = 0;
   }
   else
   { 
    pFADE[temp1].current_frame = 0;
    pFADE[temp1].play_animation = NO;
    pFADE[temp1].loop_animation = NO;
   }
 }
 return;
}
// --------------------------------------------------
e2_FADE_load_from_CDROM(int FADE_number, char FADE_sheet_filename[])
{
 /*
    FADE_number         = The starting slot number of the sprite to begin loading into.
    FADE_sheet_filename = The file name of the sprites to load.
 */
 int number_of_fades, temp1;

 e2_CDROM_load_file(FADE_sheet_filename);
 number_of_fades = e2_CDROM_read_number(4);
 e2_FADE_reallocate(FADE_number, FADE_number + number_of_fades);
 for(temp1 = 0; temp1 != number_of_fades; temp1++)
 {
  pFADE[FADE_number + temp1].show_fade = e2_CDROM_read_number(1);
  pFADE[FADE_number + temp1].play_animation = e2_CDROM_read_number(1);
  pFADE[FADE_number + temp1].loop_animation = e2_CDROM_read_number(1);
  pFADE[FADE_number + temp1].current_frame = e2_CDROM_read_number(4);
  pFADE[FADE_number + temp1].total_frames = e2_CDROM_read_number(4);
  pFADE[FADE_number + temp1].use_color_offset = e2_CDROM_read_number(1);
  pFADE[FADE_number + temp1].timer[X] = e2_CDROM_read_number(4);
  pFADE[FADE_number + temp1].timer[Y] = e2_CDROM_read_number(4);
  pFADE[FADE_number + temp1].timer[Z] = e2_CDROM_read_number(4);
  e2_FADE_reallocate_frame(FADE_number + temp1, pFADE[FADE_number + temp1].total_frames);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_FADE_load_frame_from_CDROM(int FADE_number, char FADE_animation_filename[])
{
 /*
    FADE_number             = The slot number of the sprite to load this animation into.
    FADE_animation_filename = The file name of the animation to load.
 */
 int number_of_animations, temp1, temp2, number_of_frames_per_animation[max_CDROM_load];

 e2_CDROM_load_file(FADE_animation_filename);
 number_of_animations = e2_CDROM_read_number(4);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  number_of_frames_per_animation[temp1] = e2_CDROM_read_number(4);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  for(temp2 = 0; temp2 != number_of_frames_per_animation[temp1]; temp2++)
  {
   pFADE[FADE_number + temp1].fade_data[temp2][0] = e2_CDROM_read_number(1);
   pFADE[FADE_number + temp1].fade_data[temp2][1] = e2_CDROM_read_number(3);
   pFADE[FADE_number + temp1].fade_data[temp2][2] = e2_CDROM_read_number(3);
   pFADE[FADE_number + temp1].fade_data[temp2][3] = e2_CDROM_read_number(3);
   pFADE[FADE_number + temp1].fade_data[temp2][4] = e2_CDROM_read_number(3);
   pFADE[FADE_number + temp1].fade_data[temp2][5] = e2_CDROM_read_number(3);
   pFADE[FADE_number + temp1].fade_data[temp2][6] = e2_CDROM_read_number(3);
   pFADE[FADE_number + temp1].fade_data[temp2][7] = e2_CDROM_read_number(4);
   pFADE[FADE_number + temp1].fade_data[temp2][8] = e2_CDROM_read_number(4);
   pFADE[FADE_number + temp1].fade_data[temp2][9] = e2_CDROM_read_number(4);
   pFADE[FADE_number + temp1].fade_data[temp2][10] = e2_CDROM_read_number(4);
   pFADE[FADE_number + temp1].fade_data[temp2][11] = e2_CDROM_read_number(4);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_FADE_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pFADE[temp1].play_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].loop_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].show_fade, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].use_color_offset, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].timer[X], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].timer[Y], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pFADE[temp1].timer[Z], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_FADE_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].play_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].loop_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].show_fade, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].use_color_offset, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pFADE[temp1].timer[Z], sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_FADE_save_frame_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3, temp4;

 for(temp3 = 0; temp3 != pFADE[temp1].total_frames; temp3++)
 {
  for(temp4 = 0; temp4 != 12; temp4++)
  {
   slDMACopy((void*)&pFADE[temp1].fade_data[temp3][temp4], (void*)temp2, sizeof(int));
   temp2 += sizeof(int);
  }
 }
 return(temp2);
}
// --------------------------------------------------
e2_FADE_load_frame_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3, temp4;

 for(temp3 = 0; temp3 != pFADE[temp1].total_frames; temp3++)
 {
  for(temp4 = 0; temp4 != 12; temp4++)
  {
   slDMACopy((void*)temp2, (void*)&pFADE[temp1].fade_data[temp3][temp4], sizeof(int));
   temp2 += sizeof(int);
  }
 }
 return(temp2);
}
// ==================================================
//	[PALETTE2D]           :  <<PALETTE2D>>
// --------------------------------------------------
e2_PALETTE2D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of palette slots.
    temp2 = The desired number of palette slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pPALETTE2D = (PALETTE2D*)realloc(pPALETTE2D, temp2 * sizeof(PALETTE2D));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pPALETTE2D[temp3].palette_data);
  }
  pPALETTE2D = (PALETTE2D*)realloc(pPALETTE2D, temp2 * sizeof(PALETTE2D));
 }
 return;
}
// --------------------------------------------------
e2_PALETTE2D_reallocate_number_of_colors(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the palette to edit.
    temp2 = The number of colors in the palette.
 */
 pPALETTE2D[temp1].palette_data = (Uint16*)realloc(pPALETTE2D[temp1].palette_data, temp2 * sizeof(Uint16));
 return;
}
// --------------------------------------------------
void e2_PALETTE2D_system_load_into_COLORRAM(Uint16 *Pal_Data, void *Col_Adr, Uint32 Entries)
{
 /*
    Pal_Data = The slot number of the palette to save into the colorram (ex: &pPALETTE2D[0].palette_data[0]).
    Col_Adr  = The colorram address to begin saving at (ex:  (void *)NBG1_COL_ADR).
    Entries  = The number of colors in the palette.
 */
 Uint16 loop;
 Uint16 *VRAM;

 VRAM = (Uint16 *)Col_Adr;

 for (loop = 0; loop < Entries; loop++)
 {
  *(VRAM++) = *(Pal_Data++);
 }
 return;
}
// --------------------------------------------------
void e2_PALETTE2D_load_into_COLORRAM(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the palette to save into the colorram.
    temp2 = The colorram address to begin saving at.
    temp3 = The number of colors in the palette.
 */
 e2_PALETTE2D_system_load_into_COLORRAM(&pPALETTE2D[temp1].palette_data[0], (void *)temp2, temp3);
 return;
}
// --------------------------------------------------
e2_PALETTE2D_combine_palettes(int temp1, int temp2, int temp3, int temp4, int temp5)
{
 /*
    temp1 = The slot number of the first palette to combine.
    temp2 = The slot number of the second palette to combine.
    temp3 = The offset value of the first palette to start loading the new colors into.
    temp4 = The offset value of the second palette to start reading the new colors from.
    temp5 = The number of colors to read from the second palette.
 */
 int temp6 = 0;

 for(temp6 = 0; temp6 != temp5; temp6++)
  pPALETTE2D[temp1].palette_data[temp3 + temp6] = pPALETTE2D[temp2].palette_data[temp4 + temp6];
 return;
}
// --------------------------------------------------
e2_PALETTE2D_set_transparent_color(int temp1, int temp2)
{
 /*
    temp1 = The slot number if the palette to edit.
    temp2 = The current number of colors in the palette.
    [NOTE]:
      Make sure that the transparent color of the palette of the sprites you've created is the last color in
      the palette order.

      Remember that the transparent color always occupies '.palette_data[0]', so once this
      routine has finished...you'll need to offset the colors of any pal sprites that use this palette
      by 1 using the routine 'e2_IMAGE2D_PAL_offset_colors', and then set the transparent
      color for the sprites using the routine 'e2_IMAGE2D_PAL_set_transparent_color'.
 */
 Uint16 temp4[temp2];
 int    temp5;

 for(temp5 = 1; temp5 != temp2; temp5++)
  temp4[temp5] = pPALETTE2D[temp1].palette_data[(temp5 - 1)];
 temp4[0] = pPALETTE2D[temp1].palette_data[(temp2 - 1)];

 for(temp5 = 0; temp5 != temp2; temp5++)
  pPALETTE2D[temp1].palette_data[temp5] = temp4[temp5];
 return;
}
// --------------------------------------------------
e2_PALETTE2D_load_from_CDROM(int palette_number, char palette_sheet_filename[])
{
 /*
    palette_number         = The starting slot number of the palette to begin loading into.
    palette_sheet_filename = The file name of the palettes to load.
 */
 int number_of_palettes, number_of_colors_per_palette[max_CDROM_load], temp1, temp2;

 e2_CDROM_load_file(palette_sheet_filename);
 number_of_palettes = e2_CDROM_read_number(4);
 e2_PALETTE2D_reallocate(palette_number, palette_number + number_of_palettes);
 for(temp1 = 0; temp1 != number_of_palettes; temp1++)
 {
  number_of_colors_per_palette[temp1] = e2_CDROM_read_number(3);	// The number of colors in the palettes.
  e2_PALETTE2D_reallocate_number_of_colors((palette_number + temp1), number_of_colors_per_palette[temp1]);
  pPALETTE2D[(palette_number + temp1)].total_colors = number_of_colors_per_palette[temp1];
 }
 for(temp1 = 0; temp1 != number_of_palettes; temp1++)
 {
  for(temp2 = 0; temp2 != number_of_colors_per_palette[temp1]; temp2++)
   pPALETTE2D[(palette_number + temp1)].palette_data[temp2] = (Uint16)e2_CDROM_read_number(5);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_PALETTE2D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the palette to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pPALETTE2D[temp1].total_colors, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pPALETTE2D[temp1].total_colors; temp3++)
 {
  slDMACopy((void*)&pPALETTE2D[temp1].palette_data[temp3], (void*)temp2, sizeof(Uint16));
  temp2 += sizeof(Uint16);
 }
 return(temp2);
}
// --------------------------------------------------
e2_PALETTE2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the palette into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pPALETTE2D[temp1].total_colors, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pPALETTE2D[temp1].total_colors; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pPALETTE2D[temp1].palette_data, sizeof(Uint16));
  temp2 += sizeof(Uint16);
 }
 return(temp2);
}
// ==================================================
//	[IMAGE2D]            :  <<IMAGE2D>>
// --------------------------------------------------
void e2_IMAGE2D_system_setup(PICTURE*temp1, TEXTURE*temp2, Uint32 NbPicture)
{
 /*
    temp1     = The name of your picture image table.
                This value will usually be IMAGE2D_picture unless you create your own.
    temp2     = The name of your texture image table.
                This value will usually be IMAGE2D_texture unless you create your own.
    NbPicture = The total number of 2D images and textures (this includes both pal and 32k images).
 */
 TEXTURE*temp3;
 for(;NbPicture-->0;temp1++)
 {
  temp3 = temp2 + temp1->texno;
  slDMACopy((void*)temp1->pcsrc,
  (void*)(SpriteVRAM+((temp3->CGadr)<<3)),
  (Uint32)((temp3->Hsize * temp3->Vsize * 4>>(temp1->cmode))));
 }
 return;
}
// --------------------------------------------------
e2_IMAGE2D_setup(int temp1)
{
 /*
    temp1 = The total number of 2D images and textures (this includes both pal and 32k images).
 */
 e2_IMAGE2D_system_setup(IMAGE2D_picture, IMAGE2D_texture, temp1);
 return;
}
// ==================================================
//	[IMAGE2D_PAL]        :  <<IMAGE2D_PAL>>
// --------------------------------------------------
e2_IMAGE2D_PAL_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of image slots.
    temp2 = The desired number of image slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pIMAGE2D_PAL = (IMAGE2D_PAL*)realloc(pIMAGE2D_PAL, temp2 * sizeof(IMAGE2D_PAL));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pIMAGE2D_PAL[temp3].image_data);
  }
  pIMAGE2D_PAL = (IMAGE2D_PAL*)realloc(pIMAGE2D_PAL, temp2 * sizeof(IMAGE2D_PAL));
 }
 return;
}
// --------------------------------------------------
e2_IMAGE2D_PAL_reallocate_horizontal_x_vertical_size(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the image to edit.
    temp2 = The Horizontal * Vertical size of the image.
 */
 pIMAGE2D_PAL[temp1].image_data = (unsigned char*)realloc(pIMAGE2D_PAL[temp1].image_data, temp2 * sizeof(unsigned char));
 return;
}
// --------------------------------------------------
e2_IMAGE2D_PAL_load_into_SPRITEVRAM(int temp1, Uint32 temp2, Uint32 temp3)
{
 /*
    temp1 = The slot number of the image to save into the spritevram.
    temp2 = The spritevram address to begin saving at.
    temp3 = The user defined memory address jitter correction value (Usually set at 0).
 */
 TEXTURE  temp_IMAGE2D_texture[]={TEXDEF(pIMAGE2D_PAL[temp1].horizontal_size, pIMAGE2D_PAL[temp1].vertical_size, (temp2 + temp3))};

 PICTURE  temp_IMAGE2D_picture[]={PICDEF(temp1, COL_16,  pIMAGE2D_PAL[temp1].image_data),
                                  PICDEF(temp1, COL_64,  pIMAGE2D_PAL[temp1].image_data),
                                  PICDEF(temp1, COL_128, pIMAGE2D_PAL[temp1].image_data),
                                  PICDEF(temp1, COL_256, pIMAGE2D_PAL[temp1].image_data)};

 IMAGE2D_texture[temp1] = temp_IMAGE2D_texture[0];

 switch(pIMAGE2D_PAL[temp1].total_colors)
 {
  case 16:
   IMAGE2D_picture[temp1] = temp_IMAGE2D_picture[0];
   break;

  case 64:
   IMAGE2D_picture[temp1] = temp_IMAGE2D_picture[1];
   break;

  case 128:
   IMAGE2D_picture[temp1] = temp_IMAGE2D_picture[2];
   break;

  case 256:
   IMAGE2D_picture[temp1] = temp_IMAGE2D_picture[3];
   break;
 }
 IMAGE2D_memory_address += (pIMAGE2D_PAL[temp1].horizontal_size * pIMAGE2D_PAL[temp1].vertical_size) + temp3;
 return;
}
// --------------------------------------------------
e2_IMAGE2D_PAL_offset_colors(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the image to start the process at.
    temp2 = The slot number of the image to stop the process at.
    temp3 = The value to offset all colors by.
 */
 int temp4 = 0, temp5 = 0;

 for(temp4 = temp1; temp4 != temp2; temp4++)
 {
  for(temp5 = 0; temp5 != (pIMAGE2D_PAL[temp4].horizontal_size * pIMAGE2D_PAL[temp4].vertical_size); temp5++)
   pIMAGE2D_PAL[temp4].image_data[temp5] += temp3;
 }
 return;
}
// --------------------------------------------------
e2_IMAGE2D_PAL_set_transparent_color(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the image to edit.
    temp2 = The number of the palette color to change to transparent.
 */

 int temp3 = 0;

 for(temp3 = 0; temp3 != (pIMAGE2D_PAL[temp1].horizontal_size * pIMAGE2D_PAL[temp1].vertical_size); temp3++)
 {
  if(pIMAGE2D_PAL[temp1].image_data[temp3] == temp2)
   pIMAGE2D_PAL[temp1].image_data[temp3] = 0;
 }
 return;
}
// --------------------------------------------------
e2_IMAGE2D_PAL_load_from_CDROM(int image2D_number, char image2D_sheet_filename[])
{
 /*
    image2D_number         = The starting slot number of the image to begin loading into.
    image2D_sheet_filename = The file name of the images to load.
 */
 int number_of_2D_images, temp_image_data[max_CDROM_load][3], temp1 = 0, temp2 = 0, temp3 = 0;

 e2_CDROM_load_file(image2D_sheet_filename);
 number_of_2D_images = e2_CDROM_read_number(4);
 e2_IMAGE2D_PAL_reallocate(image2D_number, image2D_number + number_of_2D_images);
 for(temp1 = 0; temp1 != number_of_2D_images; temp1++)
 {
  temp_image_data[temp1][0] = e2_CDROM_read_number(3);	// image's total_colors.
  temp_image_data[temp1][1] = e2_CDROM_read_number(4);	// image's horizontal_size.
  temp_image_data[temp1][2] = e2_CDROM_read_number(3);	// image's vertical_size.
  e2_IMAGE2D_PAL_reallocate_horizontal_x_vertical_size((image2D_number + temp1), (temp_image_data[temp1][1] * temp_image_data[temp1][2]));
 }
 for(temp1 = 0; temp1 != number_of_2D_images; temp1++)
 {
  pIMAGE2D_PAL[(image2D_number + temp1)].total_colors = temp_image_data[temp1][0];
  pIMAGE2D_PAL[(image2D_number + temp1)].horizontal_size = temp_image_data[temp1][1];
  pIMAGE2D_PAL[(image2D_number + temp1)].vertical_size = temp_image_data[temp1][2];
 }
 for(temp1 = 0; temp1 != number_of_2D_images; temp1++)
 {
  for(temp2 = 0; temp2 != (temp_image_data[temp1][1] * temp_image_data[temp1][2]); temp2++)
   pIMAGE2D_PAL[(image2D_number + temp1)].image_data[temp2] = (unsigned char)e2_CDROM_read_number(3);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_IMAGE2D_PAL_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the image to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3 = 0, temp4 = 0;

 slDMACopy((void*)&pIMAGE2D_PAL[temp1].horizontal_size, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pIMAGE2D_PAL[temp1].vertical_size, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pIMAGE2D_PAL[temp1].total_colors, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 for(temp3 = 0; temp3 != (pIMAGE2D_PAL[temp1].horizontal_size * pIMAGE2D_PAL[temp1].vertical_size); temp3++)
 {
  slDMACopy((void*)&pIMAGE2D_PAL[temp1].image_data[temp3], (void*)temp2, sizeof(unsigned char));
  temp2 += sizeof(unsigned char);
 }
 return(temp2);
}
// --------------------------------------------------
e2_IMAGE2D_PAL_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the image into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3 = 0, temp4 = 0;

 slDMACopy((void*)temp2, (void*)&pIMAGE2D_PAL[temp1].horizontal_size, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pIMAGE2D_PAL[temp1].vertical_size, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pIMAGE2D_PAL[temp1].total_colors, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != (pIMAGE2D_PAL[temp1].horizontal_size * pIMAGE2D_PAL[temp1].vertical_size); temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pIMAGE2D_PAL[temp1].image_data[temp3], sizeof(unsigned char));
  temp2 += sizeof(unsigned char);
 }
 return(temp2);
}
// ==================================================
//	[IMAGE2D_32K]        :  <<IMAGE2D_32K>>
// --------------------------------------------------
e2_IMAGE2D_32K_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of image slots.
    temp2 = The desired number of image slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pIMAGE2D_32K = (IMAGE2D_32K*)realloc(pIMAGE2D_32K, temp2 * sizeof(IMAGE2D_32K));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pIMAGE2D_32K[temp3].image_data);
  }
  pIMAGE2D_32K = (IMAGE2D_32K*)realloc(pIMAGE2D_32K, temp2 * sizeof(IMAGE2D_32K));
 }
 return;
}
// --------------------------------------------------
e2_IMAGE2D_32K_reallocate_horizontal_x_vertical_size(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the image to edit.
    temp2 = The Horizontal * Vertical size of the image.
 */
 pIMAGE2D_32K[temp1].image_data = (unsigned short*)realloc(pIMAGE2D_32K[temp1].image_data, temp2 * sizeof(unsigned short));
 return;
}
// --------------------------------------------------
e2_IMAGE2D_32K_load_into_SPRITEVRAM(int temp1, Uint32 temp2, Uint32 temp3)
{
 /*
    temp1 = The slot number of the image to save into the spritevram.
    temp2 = The spritevram address to begin saving at.
    temp3 = The user defined memory address jitter correction value (Usually set at 0).
 */
 TEXTURE  temp_IMAGE2D_texture[]={TEXDEF(pIMAGE2D_32K[temp1].horizontal_size, pIMAGE2D_32K[temp1].vertical_size, (temp2 + temp3))};
 PICTURE  temp_IMAGE2D_picture[]={PICDEF(temp1, COL_32K, pIMAGE2D_32K[temp1].image_data)};

 IMAGE2D_texture[temp1] = temp_IMAGE2D_texture[0];
 IMAGE2D_picture[temp1] = temp_IMAGE2D_picture[0];
 IMAGE2D_memory_address += (pIMAGE2D_32K[temp1].horizontal_size * pIMAGE2D_32K[temp1].vertical_size) + temp3;
 return;
}
// --------------------------------------------------
e2_IMAGE2D_32K_load_from_CDROM(int image2D_number, char image2D_sheet_filename[])
{
 /*
    image2D_number         = The starting slot number of the image to begin loading into.
    image2D_sheet_filename = The file name of the images to load.
 */
 int number_of_2D_images, temp_image_data[max_CDROM_load][XY], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(image2D_sheet_filename);
 number_of_2D_images = e2_CDROM_read_number(4);
 e2_IMAGE2D_32K_reallocate(image2D_number, image2D_number + number_of_2D_images);
 for(temp1 = 0; temp1 != number_of_2D_images; temp1++)
 {
  temp_image_data[temp1][X] = e2_CDROM_read_number(3);	// image's horizontal_size.
  temp_image_data[temp1][Y] = e2_CDROM_read_number(3);	// image's vertical_size
  e2_IMAGE2D_32K_reallocate_horizontal_x_vertical_size((image2D_number + temp1), (temp_image_data[temp1][X] * temp_image_data[temp1][Y]));
 }
 for(temp1 = 0; temp1 != number_of_2D_images; temp1++)
 {
  pIMAGE2D_32K[(image2D_number + temp1)].horizontal_size = temp_image_data[temp1][X];
  pIMAGE2D_32K[(image2D_number + temp1)].vertical_size = temp_image_data[temp1][Y];
 }
 for(temp1 = 0; temp1 != number_of_2D_images; temp1++)
 {
  for(temp2 = 0; temp2 != (temp_image_data[temp1][X] * temp_image_data[temp1][Y]); temp2++)
   pIMAGE2D_32K[(image2D_number + temp1)].image_data[temp2] = (unsigned short)e2_CDROM_read_number(5);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_IMAGE2D_32K_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the image to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3 = 0;

 slDMACopy((void*)&pIMAGE2D_32K[temp1].horizontal_size, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pIMAGE2D_32K[temp1].vertical_size, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 for(temp3 = 0; temp3 != (pIMAGE2D_32K[temp1].horizontal_size * pIMAGE2D_32K[temp1].vertical_size); temp3++)
 {
  slDMACopy((void*)&pIMAGE2D_32K[temp1].image_data[temp3], (void*)temp2, sizeof(unsigned short));
  temp2 += sizeof(unsigned short);
 }
 return(temp2);
}
// --------------------------------------------------
e2_IMAGE2D_32K_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the image into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3 = 0;

 slDMACopy((void*)temp2, (void*)&pIMAGE2D_32K[temp1].horizontal_size, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pIMAGE2D_32K[temp1].vertical_size, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != (pIMAGE2D_32K[temp1].horizontal_size * pIMAGE2D_32K[temp1].vertical_size); temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pIMAGE2D_32K[temp1].image_data[temp3], sizeof(unsigned short));
  temp2 += sizeof(unsigned short);
 }
 return(temp2);
}
// ==================================================
//	[SPRITE2D_ANIMATION_FRAME] :  <<SPRITE2D_ANIMATION_FRAME>>
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_FRAME_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE2D_ANIMATION_FRAME = (SPRITE2D_ANIMATION_FRAME*)realloc(pSPRITE2D_ANIMATION_FRAME, temp2 * sizeof(SPRITE2D_ANIMATION_FRAME));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE2D_ANIMATION_FRAME[temp3].image2D_number);
   free(pSPRITE2D_ANIMATION_FRAME[temp3].frame_target);
   free(pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset);
  }
  pSPRITE2D_ANIMATION_FRAME = (SPRITE2D_ANIMATION_FRAME*)realloc(pSPRITE2D_ANIMATION_FRAME, temp2 * sizeof(SPRITE2D_ANIMATION_FRAME));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_FRAME_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE2D_ANIMATION_FRAME[temp1].total_frames = temp2;
 pSPRITE2D_ANIMATION_FRAME[temp1].image2D_number = (int*)realloc(pSPRITE2D_ANIMATION_FRAME[temp1].image2D_number, temp2 * sizeof(int));
 pSPRITE2D_ANIMATION_FRAME[temp1].frame_target   = (int*)realloc(pSPRITE2D_ANIMATION_FRAME[temp1].frame_target, temp2 * sizeof(int));
 pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset = (FIXED(*)[3])realloc(pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset, temp2 * sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_FRAME_setup(int temp1, int temp2, int temp3, int temp4, FIXED temp5, FIXED temp6, FIXED temp7)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The slot number of the image to display.
    temp4 = The delay value of this frame.
    temp5 = The X offset to use for frame display.
    temp6 = The Y offset to use for frame display.
    temp7 = The Z offset to use for frame display.
 */
 pSPRITE2D_ANIMATION_FRAME[temp1].image2D_number[temp2] = temp3;
 pSPRITE2D_ANIMATION_FRAME[temp1].frame_target[temp2] = temp4;
 pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp2][X] = temp5;
 pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp2][Y] = temp6;
 pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp2][Z] = temp7;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_FRAME_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE2D_ANIMATION_FRAME_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE2D_ANIMATION_FRAME_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE2D_ANIMATION_FRAME[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE2D_ANIMATION_FRAME[animation_number + temp1].image2D_number[temp2] = e2_CDROM_read_number(4);

   pSPRITE2D_ANIMATION_FRAME[animation_number + temp1].frame_target[temp2] = e2_CDROM_read_number(4);

   pSPRITE2D_ANIMATION_FRAME[animation_number + temp1].frame_position_offset[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE2D_ANIMATION_FRAME[animation_number + temp1].frame_position_offset[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE2D_ANIMATION_FRAME[animation_number + temp1].frame_position_offset[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_FRAME_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSPRITE2D_ANIMATION_FRAME[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_FRAME[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE2D_ANIMATION_FRAME[temp1].image2D_number[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));  

  slDMACopy((void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_target[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
 }
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_FRAME_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_FRAME[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_FRAME[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_FRAME[temp1].image2D_number[temp3], sizeof(int));
  temp2 += (sizeof(int));  

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_target[temp3], sizeof(int));
  temp2 += (sizeof(int));

   slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

   slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

   slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_FRAME[temp1].frame_position_offset[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
 }
 return(temp2);
}
// ==================================================
//	[SPRITE2D_ANIMATION_MOVEMENT] :  <<SPRITE2D_ANIMATION_MOVEMENT>>
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE2D_ANIMATION_MOVEMENT = (SPRITE2D_ANIMATION_MOVEMENT*)realloc(pSPRITE2D_ANIMATION_MOVEMENT, temp2 * sizeof(SPRITE2D_ANIMATION_MOVEMENT));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE2D_ANIMATION_MOVEMENT[temp3].movement_target);
   free(pSPRITE2D_ANIMATION_MOVEMENT[temp3].movement_increment);
  }
  pSPRITE2D_ANIMATION_MOVEMENT = (SPRITE2D_ANIMATION_MOVEMENT*)realloc(pSPRITE2D_ANIMATION_MOVEMENT, temp2 * sizeof(SPRITE2D_ANIMATION_MOVEMENT));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].total_frames = temp2;
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target = (int(*)[3])realloc(pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target, temp2*sizeof(int * [3]));
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment = (FIXED(*)[3])realloc(pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment, temp2*sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_setup(int temp1, int temp2, int temp3, int temp4, int temp5, FIXED temp6, FIXED temp7, FIXED temp8)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The number of times to repeat the X per-frame-increment.
    temp4 = The number of times to repeat the Y per-frame-increment.
    temp5 = The number of times to repeat the Z per-frame-increment.
    temp6 = The X per-frame-increment.
    temp7 = The Y per-frame-increment.
    temp8 = The Z per-frame-increment.
 */
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][0] = temp3;
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][1] = temp4;
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][2] = temp5;
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][0] = temp6;
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][1] = temp7;
 pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][2] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_setup_interpolated(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, FIXED temp7, FIXED temp8, FIXED temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting position.
    temp5 = The Y starting position.
    temp6 = The Z starting position.
    temp7 = The X desired ending position.
    temp8 = The Y desired ending position.
    temp9 = The Z desired ending position.
 */
 int temp10 = 0;
 FIXED chk_val[XYZ] = {(temp7 - temp4), (temp8 - temp5), (temp9 - temp6)};

 for(temp10 = 0; temp10 != 3; temp10++) if(chk_val[temp10] <= 0) chk_val[temp10] *= -1;

 if(chk_val[X] >= chk_val[Y] && chk_val[X] >= chk_val[Z])
 {
  if(chk_val[X] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = toFIXED(temp3); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = (temp7 - temp4) / toFIXED(temp3);}
  if(chk_val[Y] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp7 - temp4) / toFIXED(temp3)); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
  if(chk_val[Z] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp7 - temp4) / toFIXED(temp3)); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
 }

 if(chk_val[Y] >= chk_val[X] && chk_val[Y] >= chk_val[Z])
 {
  if(chk_val[Y] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = toFIXED(temp3); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = (temp8 - temp5) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp8 - temp5) / toFIXED(temp3)); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
  if(chk_val[Z] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp8 - temp5) / toFIXED(temp3)); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
 }

 if(chk_val[Z] >= chk_val[X] && chk_val[Z] >= chk_val[Y])
 {
  if(chk_val[Z] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = toFIXED(temp3); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = (temp9 - temp6) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp9 - temp6) / toFIXED(temp3)); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
  if(chk_val[Y] >= toFIXED(0.0)){pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp9 - temp6) / toFIXED(temp3)); pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
 }

 for(temp10 = 0; temp10 != 3; temp10++) if(pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] <= 0)
 {
  pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] *= -1;
  pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][temp10] *= -1;
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE2D_ANIMATION_MOVEMENT_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][X] = e2_CDROM_read_number(4);
   pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Y] = e2_CDROM_read_number(4);
   pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Z] = e2_CDROM_read_number(4);
   pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE2D_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
 }
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_MOVEMENT_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
 }
 return(temp2);
}
// ==================================================
//	[SPRITE2D_ANIMATION_ROTATION] :  <<SPRITE2D_ANIMATION_ROTATION>>
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_ROTATION_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE2D_ANIMATION_ROTATION = (SPRITE2D_ANIMATION_ROTATION*)realloc(pSPRITE2D_ANIMATION_ROTATION, temp2 * sizeof(SPRITE2D_ANIMATION_ROTATION));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE2D_ANIMATION_ROTATION[temp3].rotation_target);
   free(pSPRITE2D_ANIMATION_ROTATION[temp3].rotation_increment);
  }
  pSPRITE2D_ANIMATION_ROTATION = (SPRITE2D_ANIMATION_ROTATION*)realloc(pSPRITE2D_ANIMATION_ROTATION, temp2 * sizeof(SPRITE2D_ANIMATION_ROTATION));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_ROTATION_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE2D_ANIMATION_ROTATION[temp1].total_frames = temp2;
 pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_target = (int(*))realloc(pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_target, temp2 * sizeof(int));
 pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_increment = (ANGLE(*))realloc(pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_increment, temp2 * sizeof(ANGLE));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_ROTATION_setup(int temp1, int temp2, int temp3, ANGLE temp4)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The number of times to repeat the per-frame-increment.
    temp4 = The per-frame-increment.
 */
 pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_target[temp2] = temp3;
 pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_increment[temp2] = temp4;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_ROTATION_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE2D_ANIMATION_ROTATION_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE2D_ANIMATION_ROTATION_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE2D_ANIMATION_ROTATION[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE2D_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2] = e2_CDROM_read_number(4);
   pSPRITE2D_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_ROTATION_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSPRITE2D_ANIMATION_ROTATION[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_target[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_increment[temp3], (void*)temp2, sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
 }
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_ROTATION_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_ROTATION[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_target[temp3], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_ROTATION[temp1].rotation_increment[temp3], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
 }
 return(temp2);
}
// ==================================================
//	[SPRITE2D_ANIMATION_SCALING] :  <<SPRITE2D_ANIMATION_SCALING>>
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_SCALING_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE2D_ANIMATION_SCALING = (SPRITE2D_ANIMATION_SCALING*)realloc(pSPRITE2D_ANIMATION_SCALING, temp2 * sizeof(SPRITE2D_ANIMATION_SCALING));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE2D_ANIMATION_SCALING[temp3].scaling_target);
   free(pSPRITE2D_ANIMATION_SCALING[temp3].scaling_increment);
  }
  pSPRITE2D_ANIMATION_SCALING = (SPRITE2D_ANIMATION_SCALING*)realloc(pSPRITE2D_ANIMATION_SCALING, temp2 * sizeof(SPRITE2D_ANIMATION_SCALING));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_SCALING_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE2D_ANIMATION_SCALING[temp1].total_frames = temp2;
 pSPRITE2D_ANIMATION_SCALING[temp1].scaling_target = (int(*))realloc(pSPRITE2D_ANIMATION_SCALING[temp1].scaling_target, temp2 * sizeof(int));
 pSPRITE2D_ANIMATION_SCALING[temp1].scaling_increment = (FIXED(*))realloc(pSPRITE2D_ANIMATION_SCALING[temp1].scaling_increment, temp2 * sizeof(FIXED));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_SCALING_setup(int temp1, int temp2, int temp3, FIXED temp4)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The number of times to repeat the per-frame-increment.
    temp4 = The per-frame-increment.
 */
 pSPRITE2D_ANIMATION_SCALING[temp1].scaling_target[temp2] = temp3;
 pSPRITE2D_ANIMATION_SCALING[temp1].scaling_increment[temp2] = temp4;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_SCALING_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE2D_ANIMATION_SCALING_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE2D_ANIMATION_SCALING_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE2D_ANIMATION_SCALING[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE2D_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2] = e2_CDROM_read_number(4);
   pSPRITE2D_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_SCALING_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSPRITE2D_ANIMATION_SCALING[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_SCALING[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE2D_ANIMATION_SCALING[temp1].scaling_target[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSPRITE2D_ANIMATION_SCALING[temp1].scaling_increment[temp3], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_ANIMATION_SCALING_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_SCALING[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE2D_ANIMATION_SCALING[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_SCALING[temp1].scaling_target[temp3], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE2D_ANIMATION_SCALING[temp1].scaling_increment[temp3], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return(temp2);
}
// ==================================================
//	[SPRITE2D_PAL_BASIC]  :  <<SPRITE2D_PAL_BASIC>>
// --------------------------------------------------
e2_SPRITE2D_PAL_BASIC_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE2D_PAL_BASIC = (SPRITE2D_PAL_BASIC*)realloc(pSPRITE2D_PAL_BASIC, temp1 * sizeof(SPRITE2D_PAL_BASIC));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_BASIC_setup(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, ANGLE temp7, FIXED temp8, int temp9, int temp10, FIXED temp11, FIXED temp12, FIXED temp13, FIXED temp14, FIXED temp15, FIXED temp16, Uint16 temp17, int temp18)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The slot number of the image to display.
    temp4  = The X position of the sprite.
    temp5  = The Y position of the sprite.
    temp6  = The Z position of the sprite.
    temp7  = The Z angle of the sprite.
    temp8  = The scale of the sprite.
    temp9  = Whether the size of the sprite is affected by the Z distance or not.
             Specify either YES or NO.
    temp10 = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp11 = The left clipping boundary.
    temp12 = The right clipping boundary.
    temp13 = The top clipping boundary.
    temp14 = The bottom clipping boundary.
    temp15 = The front clipping boundary.
    temp16 = The back clipping boundary.
    temp17 = The memory address of the sprite's palette in the colorram (pal sprites use the first slot of 256 in the colorram).
    temp18 = The amount of colors in the sprite's palette.
             Specify palette_16_colors, palette_64_colors, palette_128_colors, or palette_256_colors.
 */
 pSPRITE2D_PAL_BASIC[temp1].show_sprite = temp2;
 pSPRITE2D_PAL_BASIC[temp1].image2D_number = temp3;
 pSPRITE2D_PAL_BASIC[temp1].position[X] = temp4;
 pSPRITE2D_PAL_BASIC[temp1].position[Y] = temp5;
 pSPRITE2D_PAL_BASIC[temp1].position[Z] = temp6;
 pSPRITE2D_PAL_BASIC[temp1].angle = temp7;
 pSPRITE2D_PAL_BASIC[temp1].scale = temp8;
 pSPRITE2D_PAL_BASIC[temp1].z_distance_affect = temp9;
 pSPRITE2D_PAL_BASIC[temp1].clipping_check = temp10;
 pSPRITE2D_PAL_BASIC[temp1].clipping_left_boundary = temp11;
 pSPRITE2D_PAL_BASIC[temp1].clipping_right_boundary = temp12;
 pSPRITE2D_PAL_BASIC[temp1].clipping_top_boundary = temp13;
 pSPRITE2D_PAL_BASIC[temp1].clipping_bottom_boundary = temp14;
 pSPRITE2D_PAL_BASIC[temp1].clipping_front_boundary = temp15;
 pSPRITE2D_PAL_BASIC[temp1].clipping_back_boundary = temp16;
 pSPRITE2D_PAL_BASIC[temp1].palette_memory_address = temp17;
 pSPRITE2D_PAL_BASIC[temp1].palette_type = temp18;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_BASIC_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 unsigned int image2D_number = pSPRITE2D_PAL_BASIC[temp1].image2D_number;
 int   use_attr = pSPRITE2D_PAL_BASIC[temp1].palette_type;
 FIXED position[][XYZS] = {{pSPRITE2D_PAL_BASIC[temp1].position[X], pSPRITE2D_PAL_BASIC[temp1].position[Y], pSPRITE2D_PAL_BASIC[temp1].position[Z], pSPRITE2D_PAL_BASIC[temp1].scale}};

 SPR_ATTR attr[] = {SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_BASIC[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_BASIC[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_BASIC[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_BASIC[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprNoflip|_ZmCC)};

 if(use_attr != palette_16_colors)
  use_attr = (use_attr / 4);

 if(pSPRITE2D_PAL_BASIC[temp1].clipping_check == YES && position[0][X] < pSPRITE2D_PAL_BASIC[temp1].clipping_left_boundary  || pSPRITE2D_PAL_BASIC[temp1].clipping_check == YES && position[0][X] > pSPRITE2D_PAL_BASIC[temp1].clipping_right_boundary  ||
    pSPRITE2D_PAL_BASIC[temp1].clipping_check == YES && position[0][Y] < pSPRITE2D_PAL_BASIC[temp1].clipping_top_boundary   || pSPRITE2D_PAL_BASIC[temp1].clipping_check == YES && position[0][Y] > pSPRITE2D_PAL_BASIC[temp1].clipping_bottom_boundary ||
    pSPRITE2D_PAL_BASIC[temp1].clipping_check == YES && position[0][Z] < pSPRITE2D_PAL_BASIC[temp1].clipping_front_boundary || pSPRITE2D_PAL_BASIC[temp1].clipping_check == YES && position[0][Z] > pSPRITE2D_PAL_BASIC[temp1].clipping_back_boundary);
 else
 {
  if(pSPRITE2D_PAL_BASIC[temp1].z_distance_affect == YES)
   slPutSprite(position[0], (SPR_ATTR *)(&(attr[use_attr].texno)), pSPRITE2D_PAL_BASIC[temp1].angle);
  else
   slDispSprite(position[0], (SPR_ATTR *)(&(attr[use_attr].texno)), pSPRITE2D_PAL_BASIC[temp1].angle);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_BASIC_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE2D_PAL_BASIC_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].image2D_number = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].scale = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].z_distance_affect = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].palette_memory_address = (Uint16)(e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSPRITE2D_PAL_BASIC[sprite_number + temp1].palette_type = e2_CDROM_read_number(2);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_BASIC_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].image2D_number, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].scale, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].z_distance_affect, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].palette_memory_address, (void*)temp2, sizeof(Uint16));
 temp2 += sizeof(Uint16);
 slDMACopy((void*)&pSPRITE2D_PAL_BASIC[temp1].palette_type, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_PAL_BASIC_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].image2D_number, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].scale, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].z_distance_affect, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].palette_memory_address, sizeof(Uint16));
 temp2 += sizeof(Uint16);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_BASIC[temp1].palette_type, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// ==================================================
//	[SPRITE2D_PAL_EXTRA] :  <<SPRITE2D_PAL_EXTRA>>
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE2D_PAL_EXTRA = (SPRITE2D_PAL_EXTRA*)realloc(pSPRITE2D_PAL_EXTRA, temp1 * sizeof(SPRITE2D_PAL_EXTRA));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, FIXED temp7, int temp8, int temp9, FIXED temp10, FIXED temp11, FIXED temp12, FIXED temp13, FIXED temp14, FIXED temp15, int temp16, Uint16 temp17, int temp18)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The Z angle of the sprite.
    temp7  = The scale of the sprite.
    temp8  = Whether the size of the sprite is affected by the Z distance or not.
             Specify either YES or NO.
    temp9  = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp10 = The left clipping boundary.
    temp11 = The right clipping boundary.
    temp12 = The top clipping boundary.
    temp13 = The bottom clipping boundary.
    temp14 = The front clipping boundary.
    temp15 = The back clipping boundary.
    temp16 = How to flip the sprite.
             Specify sprite_NO_flip, sprite_H_flip, sprite_V_flip, or sprite_HV_flip.
    temp17 = The memory address of the sprite's palette in the colorram (pal sprites use the first slot of 256 in the colorram).
    temp18 = The amount of colors in the sprite's palette.
             Specify palette_16_colors, palette_64_colors, palette_128_colors, or palette_256_colors.
 */
 pSPRITE2D_PAL_EXTRA[temp1].show_sprite = temp2;
 pSPRITE2D_PAL_EXTRA[temp1].position[X] = temp3;
 pSPRITE2D_PAL_EXTRA[temp1].position[Y] = temp4;
 pSPRITE2D_PAL_EXTRA[temp1].position[Z] = temp5;
 pSPRITE2D_PAL_EXTRA[temp1].angle = temp6;
 pSPRITE2D_PAL_EXTRA[temp1].scale = temp7;
 pSPRITE2D_PAL_EXTRA[temp1].z_distance_affect = temp8;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_check = temp9;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_left_boundary = temp10;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_right_boundary = temp11;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_top_boundary = temp12;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_bottom_boundary = temp13;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_front_boundary = temp14;
 pSPRITE2D_PAL_EXTRA[temp1].clipping_back_boundary = temp15;
 pSPRITE2D_PAL_EXTRA[temp1].flip_sprite = temp16;
 pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address = temp17;
 pSPRITE2D_PAL_EXTRA[temp1].palette_type = temp18;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_setup_ANIMATION_FRAME(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_PAL_EXTRA[temp1].frame_animate = temp2;
 pSPRITE2D_PAL_EXTRA[temp1].frame_loop = temp3;
 pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation = temp4;
 pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame = temp5;
 pSPRITE2D_PAL_EXTRA[temp1].frame_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 unsigned int image2D_number = pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].image2D_number[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame];
 int   use_attr = pSPRITE2D_PAL_EXTRA[temp1].palette_type;
 FIXED position[][XYZS] = {{pSPRITE2D_PAL_EXTRA[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_PAL_EXTRA[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_PAL_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_PAL_EXTRA[temp1].scale},
			   {pSPRITE2D_PAL_EXTRA[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_PAL_EXTRA[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_PAL_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_PAL_EXTRA[temp1].scale},
			   {pSPRITE2D_PAL_EXTRA[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_PAL_EXTRA[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_PAL_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_PAL_EXTRA[temp1].scale},
			   {pSPRITE2D_PAL_EXTRA[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_PAL_EXTRA[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_PAL_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_PAL_EXTRA[temp1].scale}};

 SPR_ATTR attr[] = {SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprHVflip|_ZmCC),

                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprHVflip|_ZmCC),

                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprHVflip|_ZmCC),

                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprHVflip|_ZmCC)};

 if(pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation != NONE)
 {
  if(pSPRITE2D_PAL_EXTRA[temp1].frame_animate == YES)
   if(pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame != pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_EXTRA[temp1].frame_timer < pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].frame_target[pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame])
    {
     pSPRITE2D_PAL_EXTRA[temp1].frame_timer++;
    }
    else
    {
     pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame++;
     pSPRITE2D_PAL_EXTRA[temp1].frame_timer = 0;
     if(pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame >= pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation].total_frames)
     {
      if(pSPRITE2D_PAL_EXTRA[temp1].frame_loop == YES)
       pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame = 0;
      else
       {pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame--; pSPRITE2D_PAL_EXTRA[temp1].frame_animate = NO;}
     }
    }
   }
  if(pSPRITE2D_PAL_EXTRA[temp1].show_sprite == YES)
  {
    if(pSPRITE2D_PAL_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite][X] < pSPRITE2D_PAL_EXTRA[temp1].clipping_left_boundary  || pSPRITE2D_PAL_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite][X] > pSPRITE2D_PAL_EXTRA[temp1].clipping_right_boundary  ||
       pSPRITE2D_PAL_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite][Y] < pSPRITE2D_PAL_EXTRA[temp1].clipping_top_boundary   || pSPRITE2D_PAL_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite][Y] > pSPRITE2D_PAL_EXTRA[temp1].clipping_bottom_boundary ||
       pSPRITE2D_PAL_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite][Z] < pSPRITE2D_PAL_EXTRA[temp1].clipping_front_boundary || pSPRITE2D_PAL_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite][Z] > pSPRITE2D_PAL_EXTRA[temp1].clipping_back_boundary);
   else
   {
    if(pSPRITE2D_PAL_EXTRA[temp1].z_distance_affect == YES)
     slPutSprite(position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite], (SPR_ATTR *)(&(attr[use_attr + pSPRITE2D_PAL_EXTRA[temp1].flip_sprite].texno)), pSPRITE2D_PAL_EXTRA[temp1].angle);
    else
     slDispSprite(position[pSPRITE2D_PAL_EXTRA[temp1].flip_sprite], (SPR_ATTR *)(&(attr[use_attr + pSPRITE2D_PAL_EXTRA[temp1].flip_sprite].texno)), pSPRITE2D_PAL_EXTRA[temp1].angle);
   }
  }
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE2D_PAL_EXTRA_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].frame_animate = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].frame_loop = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].frame_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].frame_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].frame_timer = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].scale = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].z_distance_affect = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].flip_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].palette_memory_address = (Uint16)(e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSPRITE2D_PAL_EXTRA[sprite_number + temp1].palette_type = e2_CDROM_read_number(2);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].scale, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].z_distance_affect, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].flip_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, (void*)temp2, sizeof(Uint16));
 temp2 += sizeof(Uint16);
 slDMACopy((void*)&pSPRITE2D_PAL_EXTRA[temp1].palette_type, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_PAL_EXTRA_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].frame_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].scale, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].z_distance_affect, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].flip_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].palette_memory_address, sizeof(Uint16));
 temp2 += sizeof(Uint16);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_EXTRA[temp1].palette_type, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// ==================================================
//	[SPRITE2D_PAL_ADVANCED] :  <<SPRITE2D_PAL_ADVANCED>>
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE2D_PAL_ADVANCED = (SPRITE2D_PAL_ADVANCED*)realloc(pSPRITE2D_PAL_ADVANCED, temp1 * sizeof(SPRITE2D_PAL_ADVANCED));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, FIXED temp7, int temp8, int temp9, FIXED temp10, FIXED temp11, FIXED temp12, FIXED temp13, FIXED temp14, FIXED temp15, int temp16, Uint16 temp17, int temp18)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The Z angle of the sprite.
    temp7  = The scale of the sprite.
    temp8  = Whether the size of the sprite is affected by the Z distance or not.
             Specify either YES or NO.
    temp9  = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp10 = The left clipping boundary.
    temp11 = The right clipping boundary.
    temp12 = The top clipping boundary.
    temp13 = The bottom clipping boundary.
    temp14 = The front clipping boundary.
    temp15 = The back clipping boundary.
    temp16 = How to flip the sprite.
             Specify sprite_NO_flip, sprite_H_flip, sprite_V_flip, or sprite_HV_flip.
    temp17 = The memory address of the sprite's palette in the colorram (pal sprites use the first slot of 256 in the colorram).
    temp18 = The amount of colors in the sprite's palette.
             Specify palette_16_colors, palette_64_colors, palette_128_colors, or palette_256_colors.
 */
 pSPRITE2D_PAL_ADVANCED[temp1].show_sprite = temp2;
 pSPRITE2D_PAL_ADVANCED[temp1].position[X] = temp3;
 pSPRITE2D_PAL_ADVANCED[temp1].position[Y] = temp4;
 pSPRITE2D_PAL_ADVANCED[temp1].position[Z] = temp5;
 pSPRITE2D_PAL_ADVANCED[temp1].angle = temp6;
 pSPRITE2D_PAL_ADVANCED[temp1].scale = temp7;
 pSPRITE2D_PAL_ADVANCED[temp1].z_distance_affect = temp8;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_check = temp9;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_left_boundary = temp10;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_right_boundary = temp11;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_top_boundary = temp12;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_bottom_boundary = temp13;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_front_boundary = temp14;
 pSPRITE2D_PAL_ADVANCED[temp1].clipping_back_boundary = temp15;
 pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite = temp16;
 pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address = temp17;
 pSPRITE2D_PAL_ADVANCED[temp1].palette_type = temp18;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_FRAME(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_PAL_ADVANCED[temp1].frame_animate = temp2;
 pSPRITE2D_PAL_ADVANCED[temp1].frame_loop = temp3;
 pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation = temp4;
 pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame = temp5;
 pSPRITE2D_PAL_ADVANCED[temp1].frame_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_PAL_ADVANCED[temp1].movement_animate = temp2;
 pSPRITE2D_PAL_ADVANCED[temp1].movement_loop = temp3;
 pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation = temp4;
 pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame = temp5;
 pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[X] = temp6;
 pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Y] = temp7;
 pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_PAL_ADVANCED[temp1].rotation_animate = temp2;
 pSPRITE2D_PAL_ADVANCED[temp1].rotation_loop = temp3;
 pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation = temp4;
 pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame = temp5;
 pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_setup_ANIMATION_SCALING(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_PAL_ADVANCED[temp1].scaling_animate = temp2;
 pSPRITE2D_PAL_ADVANCED[temp1].scaling_loop = temp3;
 pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation = temp4;
 pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame = temp5;
 pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 unsigned int image2D_number = pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].image2D_number[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame];
 int use_attr = pSPRITE2D_PAL_ADVANCED[temp1].palette_type;
 int temp2;
 FIXED position[][XYZS] = {
               {pSPRITE2D_PAL_ADVANCED[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_PAL_ADVANCED[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_PAL_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_PAL_ADVANCED[temp1].scale},
			   {pSPRITE2D_PAL_ADVANCED[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_PAL_ADVANCED[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_PAL_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_PAL_ADVANCED[temp1].scale},
			   {pSPRITE2D_PAL_ADVANCED[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_PAL_ADVANCED[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_PAL_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_PAL_ADVANCED[temp1].scale},
			   {pSPRITE2D_PAL_ADVANCED[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_PAL_ADVANCED[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_PAL_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_PAL_ADVANCED[temp1].scale}};

 SPR_ATTR attr[] = {SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL16Bnk|ECdis, sprHVflip|_ZmCC),

                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL64Bnk|ECdis, sprHVflip|_ZmCC),

                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL128Bnk|ECdis, sprHVflip|_ZmCC),

                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, No_Gouraud, CL256Bnk|ECdis, sprHVflip|_ZmCC)};

 if(pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation != NONE)
 {
  if(pSPRITE2D_PAL_ADVANCED[temp1].frame_animate == YES)
   if(pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame != pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].frame_timer != pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].frame_target[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame])
    {
     pSPRITE2D_PAL_ADVANCED[temp1].frame_timer++;
    }
    else
    {
     pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame++;
     pSPRITE2D_PAL_ADVANCED[temp1].frame_timer = 0;
     if(pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame >= pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation].total_frames)
     {
      if(pSPRITE2D_PAL_ADVANCED[temp1].frame_loop == YES)
       pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame = 0;
      else
       {pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame--; pSPRITE2D_PAL_ADVANCED[temp1].frame_animate = NO;}
     }
    }
   }
  if(pSPRITE2D_PAL_ADVANCED[temp1].show_sprite == YES)
  {
    if(pSPRITE2D_PAL_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite][X] < pSPRITE2D_PAL_ADVANCED[temp1].clipping_left_boundary  || pSPRITE2D_PAL_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite][X] > pSPRITE2D_PAL_ADVANCED[temp1].clipping_right_boundary  ||
       pSPRITE2D_PAL_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite][Y] < pSPRITE2D_PAL_ADVANCED[temp1].clipping_top_boundary   || pSPRITE2D_PAL_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite][Y] > pSPRITE2D_PAL_ADVANCED[temp1].clipping_bottom_boundary ||
       pSPRITE2D_PAL_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite][Z] < pSPRITE2D_PAL_ADVANCED[temp1].clipping_front_boundary || pSPRITE2D_PAL_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite][Z] > pSPRITE2D_PAL_ADVANCED[temp1].clipping_back_boundary);
   else
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].z_distance_affect == YES)
     slPutSprite(position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite], (SPR_ATTR *)(&(attr[use_attr + pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite].texno)), pSPRITE2D_PAL_ADVANCED[temp1].angle);
    else
     slDispSprite(position[pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite], (SPR_ATTR *)(&(attr[use_attr + pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite].texno)), pSPRITE2D_PAL_ADVANCED[temp1].angle);
   }
  }
 }
 if(pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation != NONE)
 {
  if(pSPRITE2D_PAL_ADVANCED[temp1].movement_animate == YES)
  {
   if(pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame != pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[temp2] != pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame][temp2])
     {
      pSPRITE2D_PAL_ADVANCED[temp1].position[temp2] += pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].movement_increment[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame][temp2];
      pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[temp2]++;
     }
    }
    if(pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[X] == pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame][X] && pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Y] == pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame][Y] && pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Z] == pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame][Z])
    {
     pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame++;
     pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[X] = pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Y] = pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Z] = 0;
    }
   }
   if(pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame >= pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].movement_loop == YES)
     pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame = 0;
    else
     pSPRITE2D_PAL_ADVANCED[temp1].movement_animate = NO;
   }
  }
 }
 if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation != NONE)
 {
  if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_animate == YES)
  {
   if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame != pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer != pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation].rotation_target[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame])
    {
     pSPRITE2D_PAL_ADVANCED[temp1].angle += pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation].rotation_increment[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame];
     pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer++;
    }
    if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer == pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation].rotation_target[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame])
    {
     pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame++;
     pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer = 0;
    }
   }
   if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame >= pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].rotation_loop == YES)
     pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame = 0;
    else
     pSPRITE2D_PAL_ADVANCED[temp1].rotation_animate = NO;
   }
  }
 }
 if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation != NONE)
 {
  if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_animate == YES)
  {
   if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame != pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer != pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation].scaling_target[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame])
    {
     pSPRITE2D_PAL_ADVANCED[temp1].scale += pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation].scaling_increment[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame];
     pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer++;
    }
    if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer == pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation].scaling_target[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame])
    {
     pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame++;
     pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer = 0;
    }
   }
   if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame >= pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation].total_frames)
   {
    if(pSPRITE2D_PAL_ADVANCED[temp1].scaling_loop == YES)
     pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame = 0;
    else
     pSPRITE2D_PAL_ADVANCED[temp1].scaling_animate = NO;
   }
  }
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE2D_PAL_ADVANCED_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].frame_animate = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].frame_loop = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].frame_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].frame_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].frame_timer = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_animate = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_loop = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_timer[X] = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_timer[Y] = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].movement_timer[Z] = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].rotation_animate = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].rotation_loop = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].rotation_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].rotation_timer = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].scaling_animate = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].scaling_loop = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].scaling_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].scaling_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].scaling_timer = e2_CDROM_read_number(4);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].scale = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].z_distance_affect = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].flip_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].palette_memory_address = (Uint16)(e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSPRITE2D_PAL_ADVANCED[sprite_number + temp1].palette_type = e2_CDROM_read_number(2);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Z], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].scale, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].z_distance_affect, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, (void*)temp2, sizeof(Uint16));
 temp2 += sizeof(Uint16);
 slDMACopy((void*)&pSPRITE2D_PAL_ADVANCED[temp1].palette_type, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_PAL_ADVANCED_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].frame_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].movement_timer[Z], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].rotation_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].scaling_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].scale, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].z_distance_affect, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].flip_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].palette_memory_address, sizeof(Uint16));
 temp2 += sizeof(Uint16);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_PAL_ADVANCED[temp1].palette_type, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// ==================================================
//	[SPRITE2D_32K_BASIC]  :  <<SPRITE2D_32K_BASIC>>
// --------------------------------------------------
e2_SPRITE2D_32K_BASIC_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE2D_32K_BASIC = (SPRITE2D_32K_BASIC*)realloc(pSPRITE2D_32K_BASIC, temp1 * sizeof(SPRITE2D_32K_BASIC));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_BASIC_setup(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, ANGLE temp7, FIXED temp8, int temp9, int temp10, FIXED temp11, FIXED temp12, FIXED temp13, FIXED temp14, FIXED temp15, FIXED temp16)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The slot number of the image to display.
    temp4  = The X position of the sprite.
    temp5  = The Y position of the sprite.
    temp6  = The Z position of the sprite.
    temp7  = The Z angle of the sprite.
    temp8  = The scale of the sprite.
    temp9  = Whether the size of the sprite is affected by the Z distance or not.
             Specify either YES or NO.
    temp10 = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp11 = The left clipping boundary.
    temp12 = The right clipping boundary.
    temp13 = The top clipping boundary.
    temp14 = The bottom clipping boundary.
    temp15 = The front clipping boundary.
    temp16 = The back clipping boundary.
 */
 pSPRITE2D_32K_BASIC[temp1].show_sprite = temp2;
 pSPRITE2D_32K_BASIC[temp1].image2D_number = temp3;
 pSPRITE2D_32K_BASIC[temp1].position[X] = temp4;
 pSPRITE2D_32K_BASIC[temp1].position[Y] = temp5;
 pSPRITE2D_32K_BASIC[temp1].position[Z] = temp6;
 pSPRITE2D_32K_BASIC[temp1].angle = temp7;
 pSPRITE2D_32K_BASIC[temp1].scale = temp8;
 pSPRITE2D_32K_BASIC[temp1].z_distance_affect = temp9;
 pSPRITE2D_32K_BASIC[temp1].clipping_check = temp10;
 pSPRITE2D_32K_BASIC[temp1].clipping_left_boundary = temp11;
 pSPRITE2D_32K_BASIC[temp1].clipping_right_boundary = temp12;
 pSPRITE2D_32K_BASIC[temp1].clipping_top_boundary = temp13;
 pSPRITE2D_32K_BASIC[temp1].clipping_bottom_boundary = temp14;
 pSPRITE2D_32K_BASIC[temp1].clipping_front_boundary = temp15;
 pSPRITE2D_32K_BASIC[temp1].clipping_back_boundary = temp16;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_BASIC_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 unsigned int image2D_number = pSPRITE2D_32K_BASIC[temp1].image2D_number;
 FIXED position[][XYZS] = {{pSPRITE2D_32K_BASIC[temp1].position[X], pSPRITE2D_32K_BASIC[temp1].position[Y], pSPRITE2D_32K_BASIC[temp1].position[Z], pSPRITE2D_32K_BASIC[temp1].scale}};
 SPR_ATTR attr[] = {SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprNoflip|_ZmCC)};

 if(pSPRITE2D_32K_BASIC[temp1].clipping_check == YES && position[0][X] < pSPRITE2D_32K_BASIC[temp1].clipping_left_boundary  || pSPRITE2D_32K_BASIC[temp1].clipping_check == YES && position[0][X] > pSPRITE2D_32K_BASIC[temp1].clipping_right_boundary  ||
    pSPRITE2D_32K_BASIC[temp1].clipping_check == YES && position[0][Y] < pSPRITE2D_32K_BASIC[temp1].clipping_top_boundary   || pSPRITE2D_32K_BASIC[temp1].clipping_check == YES && position[0][Y] > pSPRITE2D_32K_BASIC[temp1].clipping_bottom_boundary ||
    pSPRITE2D_32K_BASIC[temp1].clipping_check == YES && position[0][Z] < pSPRITE2D_32K_BASIC[temp1].clipping_front_boundary || pSPRITE2D_32K_BASIC[temp1].clipping_check == YES && position[0][Z] > pSPRITE2D_32K_BASIC[temp1].clipping_back_boundary);
 else
 {
  if(pSPRITE2D_32K_BASIC[temp1].z_distance_affect == YES)
   slPutSprite(position[0], (SPR_ATTR *)(&(attr[0].texno)), pSPRITE2D_32K_BASIC[temp1].angle);
  else
   slDispSprite(position[0], (SPR_ATTR *)(&(attr[0].texno)), pSPRITE2D_32K_BASIC[temp1].angle);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_BASIC_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE2D_32K_BASIC_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE2D_32K_BASIC[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].image2D_number = e2_CDROM_read_number(4);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].scale = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].z_distance_affect = e2_CDROM_read_number(1);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_BASIC[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_BASIC_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].image2D_number, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].scale, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].z_distance_affect, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_BASIC[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_32K_BASIC_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].image2D_number, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].scale, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].z_distance_affect, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_BASIC[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return(temp2);
}
// ==================================================
//	[SPRITE2D_32K_EXTRA] :  <<SPRITE2D_32K_EXTRA>>
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE2D_32K_EXTRA = (SPRITE2D_32K_EXTRA*)realloc(pSPRITE2D_32K_EXTRA, temp1 * sizeof(SPRITE2D_32K_EXTRA));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, FIXED temp7, int temp8, int temp9, FIXED temp10, FIXED temp11, FIXED temp12, FIXED temp13, FIXED temp14, FIXED temp15, int temp16)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The Z angle of the sprite.
    temp7  = The scale of the sprite.
    temp8  = Whether the size of the sprite is affected by the Z distance or not.
             Specify either YES or NO.
    temp9  = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp10 = The left clipping boundary.
    temp11 = The right clipping boundary.
    temp12 = The top clipping boundary.
    temp13 = The bottom clipping boundary.
    temp14 = The front clipping boundary.
    temp15 = The back clipping boundary.
    temp16 = How to flip the sprite.
             Specify sprite_NO_flip, sprite_H_flip, sprite_V_flip, or sprite_HV_flip.
 */
 pSPRITE2D_32K_EXTRA[temp1].show_sprite = temp2;
 pSPRITE2D_32K_EXTRA[temp1].position[X] = temp3;
 pSPRITE2D_32K_EXTRA[temp1].position[Y] = temp4;
 pSPRITE2D_32K_EXTRA[temp1].position[Z] = temp5;
 pSPRITE2D_32K_EXTRA[temp1].angle = temp6;
 pSPRITE2D_32K_EXTRA[temp1].scale = temp7;
 pSPRITE2D_32K_EXTRA[temp1].z_distance_affect = temp8;
 pSPRITE2D_32K_EXTRA[temp1].clipping_check = temp9;
 pSPRITE2D_32K_EXTRA[temp1].clipping_left_boundary = temp10;
 pSPRITE2D_32K_EXTRA[temp1].clipping_right_boundary = temp11;
 pSPRITE2D_32K_EXTRA[temp1].clipping_top_boundary = temp12;
 pSPRITE2D_32K_EXTRA[temp1].clipping_bottom_boundary = temp13;
 pSPRITE2D_32K_EXTRA[temp1].clipping_front_boundary = temp14;
 pSPRITE2D_32K_EXTRA[temp1].clipping_back_boundary = temp15;
 pSPRITE2D_32K_EXTRA[temp1].flip_sprite = temp16;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_setup_ANIMATION_FRAME(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_32K_EXTRA[temp1].frame_animate = temp2;
 pSPRITE2D_32K_EXTRA[temp1].frame_loop = temp3;
 pSPRITE2D_32K_EXTRA[temp1].frame_current_animation = temp4;
 pSPRITE2D_32K_EXTRA[temp1].frame_current_frame = temp5;
 pSPRITE2D_32K_EXTRA[temp1].frame_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 unsigned int image2D_number = pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].image2D_number[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame];
 FIXED position[][XYZS] = {{pSPRITE2D_32K_EXTRA[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_32K_EXTRA[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_32K_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_32K_EXTRA[temp1].scale},
			   {pSPRITE2D_32K_EXTRA[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_32K_EXTRA[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_32K_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_32K_EXTRA[temp1].scale},
			   {pSPRITE2D_32K_EXTRA[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_32K_EXTRA[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_32K_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_32K_EXTRA[temp1].scale},
			   {pSPRITE2D_32K_EXTRA[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][X], pSPRITE2D_32K_EXTRA[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Y], pSPRITE2D_32K_EXTRA[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame][Z], pSPRITE2D_32K_EXTRA[temp1].scale}};
 SPR_ATTR attr[] = {SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprHVflip|_ZmCC)};

 if(pSPRITE2D_32K_EXTRA[temp1].frame_current_animation != NONE)
 {
  if(pSPRITE2D_32K_EXTRA[temp1].frame_animate == YES)
   if(pSPRITE2D_32K_EXTRA[temp1].frame_current_frame != pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_EXTRA[temp1].frame_timer < pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].frame_target[pSPRITE2D_32K_EXTRA[temp1].frame_current_frame])
    {
     pSPRITE2D_32K_EXTRA[temp1].frame_timer++;
    }
    else
    {
     pSPRITE2D_32K_EXTRA[temp1].frame_current_frame++;
     pSPRITE2D_32K_EXTRA[temp1].frame_timer = 0;
     if(pSPRITE2D_32K_EXTRA[temp1].frame_current_frame >= pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_EXTRA[temp1].frame_current_animation].total_frames)
     {
      if(pSPRITE2D_32K_EXTRA[temp1].frame_loop == YES)
       pSPRITE2D_32K_EXTRA[temp1].frame_current_frame = 0;
      else
       {pSPRITE2D_32K_EXTRA[temp1].frame_current_frame--; pSPRITE2D_32K_EXTRA[temp1].frame_animate = NO;}
     }
    }
   }
  if(pSPRITE2D_32K_EXTRA[temp1].show_sprite == YES)
  {
   if(pSPRITE2D_32K_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite][X] < pSPRITE2D_32K_EXTRA[temp1].clipping_left_boundary  || pSPRITE2D_32K_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite][X] > pSPRITE2D_32K_EXTRA[temp1].clipping_right_boundary  ||
      pSPRITE2D_32K_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite][Y] < pSPRITE2D_32K_EXTRA[temp1].clipping_top_boundary   || pSPRITE2D_32K_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite][Y] > pSPRITE2D_32K_EXTRA[temp1].clipping_bottom_boundary ||
      pSPRITE2D_32K_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite][Z] < pSPRITE2D_32K_EXTRA[temp1].clipping_front_boundary || pSPRITE2D_32K_EXTRA[temp1].clipping_check == YES && position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite][Z] > pSPRITE2D_32K_EXTRA[temp1].clipping_back_boundary);
   else
   {
    if(pSPRITE2D_32K_EXTRA[temp1].z_distance_affect == YES)
     slPutSprite(position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite], (SPR_ATTR *)(&(attr[pSPRITE2D_32K_EXTRA[temp1].flip_sprite].texno)), pSPRITE2D_32K_EXTRA[temp1].angle);
    else
     slDispSprite(position[pSPRITE2D_32K_EXTRA[temp1].flip_sprite], (SPR_ATTR *)(&(attr[pSPRITE2D_32K_EXTRA[temp1].flip_sprite].texno)), pSPRITE2D_32K_EXTRA[temp1].angle);
   }
  }
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE2D_32K_EXTRA_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].frame_animate = e2_CDROM_read_number(1);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].frame_loop = e2_CDROM_read_number(1);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].frame_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].frame_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].frame_timer = e2_CDROM_read_number(4);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].scale = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].z_distance_affect = e2_CDROM_read_number(1);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_EXTRA[sprite_number + temp1].flip_sprite = e2_CDROM_read_number(1);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].frame_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].frame_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].frame_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].frame_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].frame_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].scale, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].z_distance_affect, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_EXTRA[temp1].flip_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_32K_EXTRA_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].frame_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].frame_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].frame_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].frame_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].frame_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].scale, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].z_distance_affect, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_EXTRA[temp1].flip_sprite, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// ==================================================
//	[SPRITE2D_32K_ADVANCED] :  <<SPRITE2D_32K_ADVANCED>>
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE2D_32K_ADVANCED = (SPRITE2D_32K_ADVANCED*)realloc(pSPRITE2D_32K_ADVANCED, temp1 * sizeof(SPRITE2D_32K_ADVANCED));
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, FIXED temp7, int temp8, int temp9, FIXED temp10, FIXED temp11, FIXED temp12, FIXED temp13, FIXED temp14, FIXED temp15, int temp16)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The Z angle of the sprite.
    temp7  = The scale of the sprite.
    temp8  = Whether the size of the sprite is affected by the Z distance or not.
             Specify either YES or NO.
    temp9  = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp10 = The left clipping boundary.
    temp11 = The right clipping boundary.
    temp12 = The top clipping boundary.
    temp13 = The bottom clipping boundary.
    temp14 = The front clipping boundary.
    temp15 = The back clipping boundary.
    temp16 = How to flip the sprite.
             Specify sprite_NO_flip, sprite_H_flip, sprite_V_flip, or sprite_HV_flip.
 */
 pSPRITE2D_32K_ADVANCED[temp1].show_sprite = temp2;
 pSPRITE2D_32K_ADVANCED[temp1].position[X] = temp3;
 pSPRITE2D_32K_ADVANCED[temp1].position[Y] = temp4;
 pSPRITE2D_32K_ADVANCED[temp1].position[Z] = temp5;
 pSPRITE2D_32K_ADVANCED[temp1].angle = temp6;
 pSPRITE2D_32K_ADVANCED[temp1].scale = temp7;
 pSPRITE2D_32K_ADVANCED[temp1].z_distance_affect = temp8;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_check = temp9;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_left_boundary = temp10;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_right_boundary = temp11;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_top_boundary = temp12;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_bottom_boundary = temp13;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_front_boundary = temp14;
 pSPRITE2D_32K_ADVANCED[temp1].clipping_back_boundary = temp15;
 pSPRITE2D_32K_ADVANCED[temp1].flip_sprite = temp16;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_FRAME(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the  animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_32K_ADVANCED[temp1].frame_animate = temp2;
 pSPRITE2D_32K_ADVANCED[temp1].frame_loop = temp3;
 pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation = temp4;
 pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame = temp5;
 pSPRITE2D_32K_ADVANCED[temp1].frame_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_32K_ADVANCED[temp1].movement_animate = temp2;
 pSPRITE2D_32K_ADVANCED[temp1].movement_loop = temp3;
 pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation = temp4;
 pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame = temp5;
 pSPRITE2D_32K_ADVANCED[temp1].movement_timer[X] = temp6;
 pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Y] = temp7;
 pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_32K_ADVANCED[temp1].rotation_animate = temp2;
 pSPRITE2D_32K_ADVANCED[temp1].rotation_loop = temp3;
 pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation = temp4;
 pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame = temp5;
 pSPRITE2D_32K_ADVANCED[temp1].rotation_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_setup_ANIMATION_SCALING(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE2D_32K_ADVANCED[temp1].scaling_animate = temp2;
 pSPRITE2D_32K_ADVANCED[temp1].scaling_loop = temp3;
 pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation = temp4;
 pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame = temp5;
 pSPRITE2D_32K_ADVANCED[temp1].scaling_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 unsigned int image2D_number = pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].image2D_number[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame];
 int temp2;
 FIXED position[][XYZS] = {{pSPRITE2D_32K_ADVANCED[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_32K_ADVANCED[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_32K_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_32K_ADVANCED[temp1].scale},
			   {pSPRITE2D_32K_ADVANCED[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_32K_ADVANCED[temp1].position[Y] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_32K_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_32K_ADVANCED[temp1].scale},
			   {pSPRITE2D_32K_ADVANCED[temp1].position[X] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_32K_ADVANCED[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_32K_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_32K_ADVANCED[temp1].scale},
			   {pSPRITE2D_32K_ADVANCED[temp1].position[X] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][X], pSPRITE2D_32K_ADVANCED[temp1].position[Y] - pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Y], pSPRITE2D_32K_ADVANCED[temp1].position[Z] + pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_position_offset[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame][Z], pSPRITE2D_32K_ADVANCED[temp1].scale}};

 SPR_ATTR attr[] = {SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprNoflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprHflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprVflip|_ZmCC),
                    SPR_ATTRIBUTE(image2D_number, No_Palet, No_Gouraud, CL32KRGB|ECdis, sprHVflip|_ZmCC)};

 if(pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation != NONE)
 {
  if(pSPRITE2D_32K_ADVANCED[temp1].frame_animate == YES)
   if(pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame != pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].frame_timer != pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].frame_target[pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame])
    {
     pSPRITE2D_32K_ADVANCED[temp1].frame_timer++;
    }
    else
    {
     pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame++;
     pSPRITE2D_32K_ADVANCED[temp1].frame_timer = 0;
     if(pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame >= pSPRITE2D_ANIMATION_FRAME[pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation].total_frames)
     {
      if(pSPRITE2D_32K_ADVANCED[temp1].frame_loop == YES)
       pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame = 0;
      else
       {pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame--; pSPRITE2D_32K_ADVANCED[temp1].frame_animate = NO;}
     }
    }
   }
  if(pSPRITE2D_32K_ADVANCED[temp1].show_sprite == YES)
  {
   if(pSPRITE2D_32K_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite][X] < pSPRITE2D_32K_ADVANCED[temp1].clipping_left_boundary  || pSPRITE2D_32K_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite][X] > pSPRITE2D_32K_ADVANCED[temp1].clipping_right_boundary  ||
      pSPRITE2D_32K_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite][Y] < pSPRITE2D_32K_ADVANCED[temp1].clipping_top_boundary   || pSPRITE2D_32K_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite][Y] > pSPRITE2D_32K_ADVANCED[temp1].clipping_bottom_boundary ||
      pSPRITE2D_32K_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite][Z] < pSPRITE2D_32K_ADVANCED[temp1].clipping_front_boundary || pSPRITE2D_32K_ADVANCED[temp1].clipping_check == YES && position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite][Z] > pSPRITE2D_32K_ADVANCED[temp1].clipping_back_boundary);
   else
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].z_distance_affect == YES)
     slPutSprite(position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite], (SPR_ATTR *)(&(attr[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite].texno)), pSPRITE2D_32K_ADVANCED[temp1].angle);
    else
     slDispSprite(position[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite], (SPR_ATTR *)(&(attr[pSPRITE2D_32K_ADVANCED[temp1].flip_sprite].texno)), pSPRITE2D_32K_ADVANCED[temp1].angle);
   }
  }
 }
 if(pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation != NONE)
 {
  if(pSPRITE2D_32K_ADVANCED[temp1].movement_animate == YES)
  {
   if(pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame != pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSPRITE2D_32K_ADVANCED[temp1].movement_timer[temp2] != pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame][temp2])
     {
      pSPRITE2D_32K_ADVANCED[temp1].position[temp2] += pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].movement_increment[pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame][temp2];
      pSPRITE2D_32K_ADVANCED[temp1].movement_timer[temp2]++;
     }
    }
    if(pSPRITE2D_32K_ADVANCED[temp1].movement_timer[X] == pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame][X] && pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Y] == pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame][Y] && pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Z] == pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].movement_target[pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame][Z])
    {
     pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame++;
     pSPRITE2D_32K_ADVANCED[temp1].movement_timer[X] = pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Y] = pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Z] = 0;
    }
   }
   if(pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame >= pSPRITE2D_ANIMATION_MOVEMENT[pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].movement_loop == YES)
     pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame = 0;
    else
     pSPRITE2D_32K_ADVANCED[temp1].movement_animate = NO;
   }
  }
 }
 if(pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation != NONE)
 {
  if(pSPRITE2D_32K_ADVANCED[temp1].rotation_animate == YES)
  {
   if(pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame != pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].rotation_timer != pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation].rotation_target[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame])
    {
     pSPRITE2D_32K_ADVANCED[temp1].angle += pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation].rotation_increment[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame];
     pSPRITE2D_32K_ADVANCED[temp1].rotation_timer++;
    }
    if(pSPRITE2D_32K_ADVANCED[temp1].rotation_timer == pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation].rotation_target[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame])
    {
     pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame++;
     pSPRITE2D_32K_ADVANCED[temp1].rotation_timer = 0;
    }
   }
   if(pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame >= pSPRITE2D_ANIMATION_ROTATION[pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].rotation_loop == YES)
     pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame = 0;
    else
     pSPRITE2D_32K_ADVANCED[temp1].rotation_animate = NO;
   }
  }
 }
 if(pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation != NONE)
 {
  if(pSPRITE2D_32K_ADVANCED[temp1].scaling_animate == YES)
  {
   if(pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame != pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].scaling_timer != pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation].scaling_target[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame])
    {
     pSPRITE2D_32K_ADVANCED[temp1].scale += pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation].scaling_increment[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame];
     pSPRITE2D_32K_ADVANCED[temp1].scaling_timer++;
    }
    if(pSPRITE2D_32K_ADVANCED[temp1].scaling_timer == pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation].scaling_target[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame])
    {
     pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame++;
     pSPRITE2D_32K_ADVANCED[temp1].scaling_timer = 0;
    }
   }
   if(pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame >= pSPRITE2D_ANIMATION_SCALING[pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation].total_frames)
   {
    if(pSPRITE2D_32K_ADVANCED[temp1].scaling_loop == YES)
     pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame = 0;
    else
     pSPRITE2D_32K_ADVANCED[temp1].scaling_animate = NO;
   }
  }
 }
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE2D_32K_ADVANCED_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].frame_animate = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].frame_loop = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].frame_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].frame_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].frame_timer = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_animate = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_loop = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_timer[X] = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_timer[Y] = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].movement_timer[Z] = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].rotation_animate = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].rotation_loop = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].rotation_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].rotation_timer = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].scaling_animate = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].scaling_loop = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].scaling_current_animation = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].scaling_current_frame = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].scaling_timer = e2_CDROM_read_number(4);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].scale = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].z_distance_affect = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE2D_32K_ADVANCED[sprite_number + temp1].flip_sprite = e2_CDROM_read_number(1);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Z], (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].scale, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].z_distance_affect, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pSPRITE2D_32K_ADVANCED[temp1].flip_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE2D_32K_ADVANCED_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].frame_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].movement_timer[Z], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].rotation_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].scaling_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].scale, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].z_distance_affect, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE2D_32K_ADVANCED[temp1].flip_sprite, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// ==================================================
//	[BITMAP2D]           :  <<BITMAP2D>>
// --------------------------------------------------
e2_BITMAP2D_setup(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the pal image to display.
    temp2 = The slot number of the palette in the colorram for the bitmap to use (0 - 7 [each is a block of 256]).
    temp3 = The X position of the bitmap.
    temp4 = The Y position of the bitmap.
    temp5 = The scrollplane to use for display.
            Specify either 0 for NBG0 or 1 for NBG1.
    temp6 = The size of the bitmap display plane.
            Specify 0 for 512x256, 1 for 512x512, 2 for 1024x256, or 3 for 1024x512.
    temp7 = The memory address in the videoram to use for the bitmap storage (ex:  VDP2_VRAM_A1).
 */
 switch(temp5)
 {
  case 0:
   switch(temp6)
   {
    case 0:
     slInitBitMap(bmNBG0, BM_512x256, (void *)temp7);
     break;

    case 1:
     slInitBitMap(bmNBG0, BM_512x512, (void *)temp7);
     break;

    case 2:
     slInitBitMap(bmNBG0, BM_1024x256, (void *)temp7);
     break;

    case 3:
     slInitBitMap(bmNBG0, BM_1024x512, (void *)temp7);
     break;
   }
  slBMPaletteNbg0(temp2);
  break;

  case 1:
   switch(temp6)
   {
    case 0:
     slInitBitMap(bmNBG1, BM_512x256, (void *)temp7);
     break;

    case 1:
     slInitBitMap(bmNBG1, BM_512x512, (void *)temp7);
     break;

    case 2:
     slInitBitMap(bmNBG1, BM_1024x256, (void *)temp7);
     break;

    case 3:
     slInitBitMap(bmNBG1, BM_1024x512, (void *)temp7);
     break;
   }
  slBMPaletteNbg1(temp2);
  break;
 }
 slBMPut(temp3 - (pIMAGE2D_PAL[temp1].horizontal_size / 2),
         temp4 - (pIMAGE2D_PAL[temp1].vertical_size   / 2),
         temp3 +((pIMAGE2D_PAL[temp1].horizontal_size / 2) - 1),
         temp4 +((pIMAGE2D_PAL[temp1].vertical_size   / 2) - 1),
         &pIMAGE2D_PAL[temp1].image_data[0]);
 return;
}
// --------------------------------------------------
e2_BITMAP2D_load_from_CDROM(int scrollplane_number, char sprite_filename[])
{
 /*
    scrollplane_number = The scrollplane to use for bitmap display.
                         Specify 0 for NBG0, 1 for NBG1, or NONE to use the sprite's current scrollplane.
    sprite_filename    = The file name of the sprite to load.
    [Note]:
     This routine will load a BITMAP2D sprite from the CDROM and automatically display it onscreen.
 */
 int temp1, temp2, temp3, temp4, temp5, temp6, temp7;

 e2_CDROM_load_file(sprite_filename);

 temp1 = e2_CDROM_read_number(4);
 temp2 = e2_CDROM_read_number(1);
 temp3 = e2_CDROM_read_number(4);
 temp4 = e2_CDROM_read_number(4);
 temp5 = e2_CDROM_read_number(1);
 temp6 = e2_CDROM_read_number(1);
 temp7 = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));

 if(scrollplane_number != NONE) temp5 = scrollplane_number;

 e2_BITMAP2D_setup(temp1, temp2, temp3, temp4, temp5, temp6, temp7);

 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_BITMAP2D_save_to_RAMCART(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, Uint32 temp8)
{
 /*
    temp1 = The slot number of the pal image to display.
    temp2 = The slot number of the palette in the colorram for the bitmap to use (0 - 7 [each is a block of 256]).
    temp3 = The X position of the bitmap.
    temp4 = The Y position of the bitmap.
    temp5 = The scrollplane to use for display.
            Specify either 0 for NBG0 or 1 for NBG1.
    temp6 = The size of the bitmap display plane.
            Specify 0 for 512x256, 1 for 512x512, 2 for 1024x256, or 3 for 1024x512.
    temp7 = The memory address in the videoram to use for the bitmap storage (ex:  VDP2_VRAM_A1).
    temp8 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&temp1, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&temp2, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&temp3, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&temp4, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&temp5, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&temp6, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&temp7, (void*)temp8, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_BITMAP2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The scrollplane to use for bitmap display.
            Specify 0 for NBG0, 1 for NBG1, or NONE to use the sprite's current scrollplane.
    temp2 = The ramcart address to begin loading from.
    [Note]:
     This routine will load a BITMAP2D sprite from the RAMCART and automatically display it onscreen.
 */
 int temp3, temp4, temp5, temp6, temp7, temp8, temp9;

 slDMACopy((void*)temp2, (void*)&temp3, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&temp4, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&temp5, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&temp6, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&temp7, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&temp8, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&temp9, sizeof(int));
 temp2 += sizeof(int);

 if(temp1 != NONE) temp7 = temp1;

 e2_BITMAP2D_setup(temp3, temp4, temp5, temp6, temp7, temp8, temp9);
 return(temp2);
}
// ==================================================
//	[COLLISION_BOX]      :  <<COLLISION_BOX>>
// --------------------------------------------------
e2_COLLISION_BOX_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pCOLLISION_BOX = (COLLISION_BOX*)realloc(pCOLLISION_BOX, temp1 * sizeof(COLLISION_BOX));
 return;
}
// --------------------------------------------------
e2_COLLISION_BOX_setup(int temp1, FIXED temp2, FIXED temp3, FIXED temp4, FIXED temp5, FIXED temp6, FIXED temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = The left collision boundary.
    temp3 = The right collision boundary.
    temp4 = The top collision boundary.
    temp5 = The bottom collision boundary.
    temp6 = The front collision boundary.
    temp7 = The back collision boundary.
 */
 pCOLLISION_BOX[temp1].collision_left_boundary   = temp2;
 pCOLLISION_BOX[temp1].collision_right_boundary  = temp3;
 pCOLLISION_BOX[temp1].collision_top_boundary    = temp4;
 pCOLLISION_BOX[temp1].collision_bottom_boundary = temp5;
 pCOLLISION_BOX[temp1].collision_front_boundary  = temp6;
 pCOLLISION_BOX[temp1].collision_back_boundary   = temp7;
 return;
}
// --------------------------------------------------
e2_COLLISION_BOX_check(FIXED object_1_position[XYZ], int object_1_collision_box, FIXED object_2_position[XYZ], int object_2_collision_box)
{
 /*
    object_1_position[XYZ] = The [XYZ] position coordinates of the first object to check for collision on.
    object_1_collision_box = The slot number of the sprite to use for the first object.
    object_2_position[XYZ] = The [XYZ] position coordinates of the second object to check for collision on.
    object_2_collision_box = The slot number of the sprite to use for the second object.
 */
 int collision = NO, X_collision = NO, Y_collision = NO, Z_collision = NO;
 FIXED check_box[2][6];

 check_box[0][X] = object_1_position[X] + pCOLLISION_BOX[object_1_collision_box].collision_left_boundary;
 check_box[0][Y] = object_1_position[Y] + pCOLLISION_BOX[object_1_collision_box].collision_top_boundary;
 check_box[0][Z] = object_1_position[Z] + pCOLLISION_BOX[object_1_collision_box].collision_front_boundary;
 check_box[0][3] = object_1_position[X] + pCOLLISION_BOX[object_1_collision_box].collision_right_boundary;
 check_box[0][4] = object_1_position[Y] + pCOLLISION_BOX[object_1_collision_box].collision_bottom_boundary;
 check_box[0][5] = object_1_position[Z] + pCOLLISION_BOX[object_1_collision_box].collision_back_boundary;

 check_box[1][X] = object_2_position[X] + pCOLLISION_BOX[object_2_collision_box].collision_left_boundary;
 check_box[1][Y] = object_2_position[Y] + pCOLLISION_BOX[object_2_collision_box].collision_top_boundary;
 check_box[1][Z] = object_2_position[Z] + pCOLLISION_BOX[object_2_collision_box].collision_front_boundary;
 check_box[1][3] = object_2_position[X] + pCOLLISION_BOX[object_2_collision_box].collision_right_boundary;
 check_box[1][4] = object_2_position[Y] + pCOLLISION_BOX[object_2_collision_box].collision_bottom_boundary;
 check_box[1][5] = object_2_position[Z] + pCOLLISION_BOX[object_2_collision_box].collision_back_boundary;

 if((check_box[0][X] >= check_box[1][X] && check_box[0][X] <= check_box[1][3]) ||
    (check_box[0][3] >= check_box[1][X] && check_box[0][3] <= check_box[1][3]) ||
    (check_box[1][X] >= check_box[0][X] && check_box[1][X] <= check_box[0][3]) ||
    (check_box[1][3] >= check_box[0][X] && check_box[1][3] <= check_box[0][3]))
  X_collision = YES;

 if((check_box[0][Y] >= check_box[1][Y] && check_box[0][Y] <= check_box[1][4]) ||
    (check_box[0][4] >= check_box[1][Y] && check_box[0][4] <= check_box[1][4]) ||
    (check_box[1][Y] >= check_box[0][Y] && check_box[1][Y] <= check_box[0][4]) ||
    (check_box[1][4] >= check_box[0][Y] && check_box[1][4] <= check_box[0][4]))
  Y_collision = YES;

 if((check_box[0][Z] >= check_box[1][Z] && check_box[0][Z] <= check_box[1][5]) ||
    (check_box[0][5] >= check_box[1][Z] && check_box[0][5] <= check_box[1][5]) ||
    (check_box[1][Z] >= check_box[0][Z] && check_box[1][Z] <= check_box[0][5]) ||
    (check_box[1][5] >= check_box[0][Z] && check_box[1][5] <= check_box[0][5]))
  Z_collision = YES;

 if(X_collision == YES && Y_collision == YES && Z_collision == YES)
  collision = YES;
 return(collision);
}
// --------------------------------------------------
e2_COLLISION_BOX_load_from_CDROM(int collision_box_number, char collision_box_filename[])
{
 /*
    collision_box_number   = The starting slot number of the sprite to begin loading into.
    collision_box_filename = The file name of the sprites to load.
 */
 int number_of_collision_boxes, temp1, temp2;

 e2_CDROM_load_file(collision_box_filename);
 number_of_collision_boxes = e2_CDROM_read_number(4);
 e2_COLLISION_BOX_reallocate(collision_box_number + number_of_collision_boxes);
 for(temp1 = 0; temp1 != number_of_collision_boxes; temp1++)
 {
  pCOLLISION_BOX[collision_box_number + temp1].collision_left_boundary   = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCOLLISION_BOX[collision_box_number + temp1].collision_right_boundary  = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCOLLISION_BOX[collision_box_number + temp1].collision_top_boundary    = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCOLLISION_BOX[collision_box_number + temp1].collision_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCOLLISION_BOX[collision_box_number + temp1].collision_front_boundary  = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCOLLISION_BOX[collision_box_number + temp1].collision_back_boundary   = toFIXED(e2_CDROM_read_number(9) * 0.0001);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_COLLISION_BOX_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pCOLLISION_BOX[temp1].collision_left_boundary,   (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pCOLLISION_BOX[temp1].collision_right_boundary,  (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pCOLLISION_BOX[temp1].collision_top_boundary,    (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pCOLLISION_BOX[temp1].collision_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pCOLLISION_BOX[temp1].collision_front_boundary,  (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)&pCOLLISION_BOX[temp1].collision_back_boundary,   (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return(temp2);
}
// --------------------------------------------------
e2_COLLISION_BOX_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pCOLLISION_BOX[temp1].collision_left_boundary,   sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCOLLISION_BOX[temp1].collision_right_boundary,  sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCOLLISION_BOX[temp1].collision_top_boundary,    sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCOLLISION_BOX[temp1].collision_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCOLLISION_BOX[temp1].collision_front_boundary,  sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCOLLISION_BOX[temp1].collision_back_boundary,   sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return(temp2);
}
// ==================================================
//	[MAP2D]              :  <<MAP2D>>
// --------------------------------------------------
e2_MAP2D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of map slots.
    temp2 = The desired number of map slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pMAP2D = (MAP2D*)realloc(pMAP2D, temp2 * sizeof(MAP2D));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pMAP2D[temp3].map_data);
  }
  pMAP2D = (MAP2D*)realloc(pMAP2D, temp2 * sizeof(MAP2D));
 }
 return;
}
// --------------------------------------------------
e2_MAP2D_size(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the map to edit.
    temp2 = The number of entries in the map's data.
 */
 pMAP2D[temp1].map_data = (Uint16(*)[8])realloc(pMAP2D[temp1].map_data, temp2 * sizeof(Uint16 * [8]));
 return;
}
// --------------------------------------------------
void e2_MAP2D_system_load_into_VIDEORAM_1x1(Uint16 *Map_Data, void *Map_Adr, Uint16 palnum)
{
 /*
    Map_Data = The slot number of the map to load into the videoram (ex: pMAP2D[0].map_data[0]).
    Map_Adr  = The videoram address to begin saving at (ex:  (void *)NBG1_MAP_ADR).
    palnum   = The slot number of the palette in the colorram for the map to use (0 - 7 [each is a block of 256]).
 */
 Uint16 i, j, suuj = 32, suui = 32;
 Uint16 paloff;
 Uint16 *VRAM;
 Uint32 mapoff = 0;
 paloff= palnum << 12;
 VRAM = (Uint16 *)Map_Adr;
 for( i = 0; i < suui; i++ ) {
  for( j = 0; j < suuj; j++ ) {
   *VRAM++ = (*Map_Data | paloff) + mapoff;
   Map_Data++;
  }
  VRAM += (32 - suuj);
 }
 return;
}
// --------------------------------------------------
void e2_MAP2D_load_into_VIDEORAM_1x1(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the map to load into the videoram.
    temp2 = The videoram address to begin saving at.
    temp3 = The slot number of the palette in the colorram for the map to use (0 - 7 [each is a block of 256]).
 */
 e2_MAP2D_system_load_into_VIDEORAM_1x1(pMAP2D[temp1].map_data[0], (void *)temp2, temp3);
 return;
}
// --------------------------------------------------
void e2_MAP2D_system_load_into_VIDEORAM_2x1(Uint16 *Map_Data, void *Map_Adr, Uint16 palnum)
{
 /*
    Map_Data = The slot number of the map to load into the videoram (ex: pMAP2D[0].map_data[0]).
    Map_Adr  = The videoram address to begin saving at (ex:  (void *)NBG1_MAP_ADR).
    palnum   = The slot number of the palette in the colorram for the map to use (0 - 7 [each is a block of 256]).
 */
 Uint16 i, j, suuj = 64, suui = 32;
 Uint16 paloff;
 Uint16 *VRAM;
 Uint32 mapoff = 0;
 paloff= palnum << 12;
 VRAM = (Uint16 *)Map_Adr;
 for( i = 0; i < suui; i++ ) {
  for( j = 0; j < suuj; j++ ) {
   *VRAM++ = (*Map_Data | paloff) + mapoff;
   Map_Data++;
  }
  VRAM += (64 - suuj);
 }
 return;
}
// --------------------------------------------------
void e2_MAP2D_load_into_VIDEORAM_2x1(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the map to load into the videoram.
    temp2 = The videoram address to begin saving at.
    temp3 = The slot number of the palette in the colorram for the map to use (0 - 7 [each is a block of 256]).
 */
 e2_MAP2D_system_load_into_VIDEORAM_2x1(pMAP2D[temp1].map_data[0], (void *)temp2, temp3);
 return;
}
// --------------------------------------------------
void e2_MAP2D_system_load_into_VIDEORAM_2x2(Uint16 *Map_Data, void *Map_Adr, Uint16 palnum)
{
 /*
    Map_Data = The slot number of the map to load into the videoram (ex: pMAP2D[0].map_data[0]).
    Map_Adr  = The videoram address to begin saving at (ex:  (void *)NBG1_MAP_ADR).
    palnum   = The slot number of the palette in the colorram for the map to use (0 - 7 [each is a block of 256]).
 */
 Uint16 i , j, suuj = 64, suui = 64;
 Uint16 paloff;
 Uint16 *VRAM;
 Uint32 mapoff = 0;
 paloff= palnum << 12;
 VRAM = (Uint16 *)Map_Adr;
 for( i = 0; i < suui; i++ ) {
  for( j = 0; j < suuj; j++ ) {
   *VRAM++ = (*Map_Data | paloff) + mapoff;
   Map_Data++;
  }
  VRAM += (64 - suuj);
 }
 return;
}
// --------------------------------------------------
void e2_MAP2D_load_into_VIDEORAM_2x2(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the map to load into the videoram.
    temp2 = The videoram address to begin saving at.
    temp3 = The slot number of the palette in the colorram for the map to use (0 - 7 [each is a block of 256]).
 */
 e2_MAP2D_system_load_into_VIDEORAM_2x2(pMAP2D[temp1].map_data[0], (void *)temp2, temp3);
 return;
}
// --------------------------------------------------
e2_MAP2D_load_from_CDROM(int map2D_number, char map2D_sheet_filename[])
{
 /*
    map2D_number         = The starting slot number of the map to begin loading into.
    map2D_sheet_filename = The file name of the maps to load.
 */
 int total_maps, map_data[max_CDROM_load], temp1 = 0, temp2 = 0, temp3 = 0;

 e2_CDROM_load_file(map2D_sheet_filename);
 total_maps = e2_CDROM_read_number(4);
 e2_MAP2D_reallocate(map2D_number, map2D_number + total_maps);
 for(temp1 = 0; temp1 != total_maps; temp1++)
 {
  map_data[temp1] = (e2_CDROM_read_number(4) * 8);
  e2_MAP2D_size((map2D_number + temp1), map_data[temp1]);
  pMAP2D[map2D_number + temp1].map_size = map_data[temp1];
 }
 for(temp1 = 0; temp1 != total_maps; temp1++)
 {
  for(temp2 = 0; temp2 != (map_data[temp1] / 8); temp2++)
  {
   for(temp3 = 0; temp3 != 8; temp3++)
   {
    pMAP2D[(map2D_number + temp1)].map_data[temp2][temp3] = e2_CDROM_read_number(4);
   }
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_MAP2D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the map to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3, temp4;

 slDMACopy((void*)&pMAP2D[temp1].map_size, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != (pMAP2D[temp1].map_size / 8); temp3++)
 {
  for(temp4 = 0; temp4 != 8; temp4++)
  {
   slDMACopy((void*)&pMAP2D[temp1].map_data[temp3][temp4], (void*)temp2, sizeof(Uint16));
   temp2 += sizeof(Uint16);
  }
 }
 return(temp2);
}
// --------------------------------------------------
e2_MAP2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the map into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3, temp4;

 slDMACopy((void*)temp2, (void*)&pMAP2D[temp1].map_size, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != (pMAP2D[temp1].map_size / 8); temp3++)
 {
  for(temp4 = 0; temp4 != 8; temp4++)
  {
   slDMACopy((void*)temp2, (void*)&pMAP2D[temp1].map_data[temp3][temp4], sizeof(Uint16));
   temp2 += sizeof(Uint16);
  }
 }
 return(temp2);
}
// ==================================================
//	[CEL2D]              :  <<CEL2D>>
// --------------------------------------------------
e2_CEL2D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of cel slots.
    temp2 = The desired number of cel slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pCEL2D = (CEL2D*)realloc(pCEL2D, temp2 * sizeof(CEL2D));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pCEL2D[temp3].cel_data);
  }
  pCEL2D = (CEL2D*)realloc(pCEL2D, temp2 * sizeof(CEL2D));
 }
 return;
}
// --------------------------------------------------
e2_CEL2D_size(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the cel to edit.
    temp2 = The number of entries in the cel's data.
 */
 pCEL2D[temp1].cel_data = (Uint8(*)[8])realloc(pCEL2D[temp1].cel_data, temp2 * sizeof(Uint8 * [8]));
 return;
}
// --------------------------------------------------
void e2_CEL2D_system_load_into_VIDEORAM(Uint8 *Cel_Data , void *Cell_Adr , Uint32 suu)
{
 /*
    Cel_Data = The slot number of the cel to load into the videoram (ex:  pCEL2D[0].cel_data[0]).
    Cell_Adr = The videoram address to begin saving at (ex:  (void *)NBG1_CEL_ADR).
    suu      = The number of entries in the cel's data (ex:  pCEL2D[0].cel_size).
 */
 Uint32 i;
 Uint8 *VRAM;
 VRAM = (Uint8 *)Cell_Adr;
 for( i = 0; i < suu; i++ )
  *(VRAM++) = *(Cel_Data++);
 return;
}
// --------------------------------------------------
void e2_CEL2D_load_into_VIDEORAM(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the cel to load into the videoram.
    temp2 = The videoram address to begin saving at.
 */
 e2_CEL2D_system_load_into_VIDEORAM(pCEL2D[temp1].cel_data[0], (void *)temp2, pCEL2D[temp1].cel_size);
 return;
}
// --------------------------------------------------
e2_CEL2D_load_from_CDROM(int cel2D_number, char cel2D_sheet_filename[])
{
 /*
    cel2D_number         = The starting slot number of the cel to begin loading into.
    cel2D_sheet_filename = The file name of the cels to load.
 */
 int number_of_cels, cel_data[max_CDROM_load], temp1 = 0, temp2 = 0, temp3 = 0;

 e2_CDROM_load_file(cel2D_sheet_filename);
 number_of_cels = e2_CDROM_read_number(4);
 e2_CEL2D_reallocate(cel2D_number, cel2D_number + number_of_cels);
 for(temp1 = 0; temp1 != number_of_cels; temp1++)
 {
  cel_data[temp1] = (e2_CDROM_read_number(4) * 256);
  e2_CEL2D_size((cel2D_number + temp1), cel_data[temp1]);
  pCEL2D[cel2D_number + temp1].cel_size = cel_data[temp1];
 }
 for(temp1 = 0; temp1 != number_of_cels; temp1++)
 {
  for(temp2 = 0; temp2 != (cel_data[temp1] / 8); temp2++)
  {
   for(temp3 = 0; temp3 != 8; temp3++)
   {
    pCEL2D[(cel2D_number + temp1)].cel_data[temp2][temp3] = e2_CDROM_read_number(3);
   }
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_CEL2D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the cel to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3, temp4;

 slDMACopy((void*)&pCEL2D[temp1].cel_size, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != (pCEL2D[temp1].cel_size / 8); temp3++)
 {
  for(temp4 = 0; temp4 != 8; temp4++)
  {
   slDMACopy((void*)&pCEL2D[temp1].cel_data[temp3][temp4], (void*)temp2, sizeof(Uint8));
   temp2 += sizeof(Uint8);
  }
 }
 return(temp2);
}
// --------------------------------------------------
e2_CEL2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the cel into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3, temp4;

 slDMACopy((void*)temp2, (void*)&pCEL2D[temp1].cel_size, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != (pCEL2D[temp1].cel_size / 8); temp3++)
 {
  for(temp4 = 0; temp4 != 8; temp4++)
  {
   slDMACopy((void*)temp2, (void*)&pCEL2D[temp1].cel_data[temp3][temp4], sizeof(Uint8));
   temp2 += sizeof(Uint8);
  }
 }
 return(temp2);
}
// ==================================================
//	[SCROLLPLANE_ANIMATION_MAP2D] :  <<SCROLLPLANE_ANIMATION_MAP2D>>
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MAP2D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSCROLLPLANE_ANIMATION_MAP2D = (SCROLLPLANE_ANIMATION_MAP2D*)realloc(pSCROLLPLANE_ANIMATION_MAP2D, temp2 * sizeof(SCROLLPLANE_ANIMATION_MAP2D));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSCROLLPLANE_ANIMATION_MAP2D[temp3].map2D_number);
   free(pSCROLLPLANE_ANIMATION_MAP2D[temp3].map_target);
  }
  pSCROLLPLANE_ANIMATION_MAP2D = (SCROLLPLANE_ANIMATION_MAP2D*)realloc(pSCROLLPLANE_ANIMATION_MAP2D, temp2 * sizeof(SCROLLPLANE_ANIMATION_MAP2D));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MAP2D_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSCROLLPLANE_ANIMATION_MAP2D[temp1].total_frames  = temp2;
 pSCROLLPLANE_ANIMATION_MAP2D[temp1].map2D_number  = (int*)realloc(pSCROLLPLANE_ANIMATION_MAP2D[temp1].map2D_number, temp2 * sizeof(int));
 pSCROLLPLANE_ANIMATION_MAP2D[temp1].map_target    = (int*)realloc(pSCROLLPLANE_ANIMATION_MAP2D[temp1].map_target, temp2 * sizeof(int));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MAP2D_setup(int temp1, int temp2, int temp3, int temp4)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The slot number of the map to display.
    temp4 = The delay value of this frame.
 */
 pSCROLLPLANE_ANIMATION_MAP2D[temp1].map2D_number[temp2] = temp3;
 pSCROLLPLANE_ANIMATION_MAP2D[temp1].map_target[temp2]   = temp4;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MAP2D_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ANIMATION_MAP2D_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SCROLLPLANE_ANIMATION_MAP2D_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSCROLLPLANE_ANIMATION_MAP2D[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSCROLLPLANE_ANIMATION_MAP2D[animation_number + temp1].map2D_number[temp2] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_MAP2D[animation_number + temp1].map_target[temp2]   = e2_CDROM_read_number(4);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MAP2D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MAP2D[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_MAP2D[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MAP2D[temp1].map2D_number[temp3],  (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));  
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MAP2D[temp1].map_target[temp3],    (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));
 }
 return(temp2);
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MAP2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MAP2D[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_MAP2D[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MAP2D[temp1].map2D_number[temp3], sizeof(int));
  temp2 += (sizeof(int));  
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MAP2D[temp1].map_target[temp3],   sizeof(int));
  temp2 += (sizeof(int));
 }
 return(temp2);
}
// ==================================================
//	[SCROLLPLANE_ANIMATION_CEL2D] :  <<SCROLLPLANE_ANIMATION_CEL2D>>
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_CEL2D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSCROLLPLANE_ANIMATION_CEL2D = (SCROLLPLANE_ANIMATION_CEL2D*)realloc(pSCROLLPLANE_ANIMATION_CEL2D, temp2 * sizeof(SCROLLPLANE_ANIMATION_CEL2D));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSCROLLPLANE_ANIMATION_CEL2D[temp3].cel2D_number);
   free(pSCROLLPLANE_ANIMATION_CEL2D[temp3].cel_target);
  }
  pSCROLLPLANE_ANIMATION_CEL2D = (SCROLLPLANE_ANIMATION_CEL2D*)realloc(pSCROLLPLANE_ANIMATION_CEL2D, temp2 * sizeof(SCROLLPLANE_ANIMATION_CEL2D));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_CEL2D_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSCROLLPLANE_ANIMATION_CEL2D[temp1].total_frames  = temp2;
 pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel2D_number  = (int*)realloc(pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel2D_number, temp2 * sizeof(int));
 pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel_target    = (int*)realloc(pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel_target, temp2 * sizeof(int));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_CEL2D_setup(int temp1, int temp2, int temp3, int temp4)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The slot number of the cel to display.
    temp4 = The delay value of this frame.
 */
 pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel2D_number[temp2] = temp3;
 pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel_target[temp2]   = temp4;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_CEL2D_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ANIMATION_CEL2D_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SCROLLPLANE_ANIMATION_CEL2D_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSCROLLPLANE_ANIMATION_CEL2D[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSCROLLPLANE_ANIMATION_CEL2D[animation_number + temp1].cel2D_number[temp2] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_CEL2D[animation_number + temp1].cel_target[temp2]   = e2_CDROM_read_number(4);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_CEL2D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSCROLLPLANE_ANIMATION_CEL2D[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_CEL2D[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel2D_number[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));  
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel_target[temp3],   (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));
 }
 return(temp2);
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_CEL2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_CEL2D[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_CEL2D[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel2D_number[temp3], sizeof(int));
  temp2 += (sizeof(int));  
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_CEL2D[temp1].cel_target[temp3],   sizeof(int));
  temp2 += (sizeof(int));
 }
 return(temp2);
}
// ==================================================
//	[SCROLLPLANE_ANIMATION_PALETTE2D] :  <<SCROLLPLANE_ANIMATION_PALETTE2D>>
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_PALETTE2D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSCROLLPLANE_ANIMATION_PALETTE2D = (SCROLLPLANE_ANIMATION_PALETTE2D*)realloc(pSCROLLPLANE_ANIMATION_PALETTE2D, temp2 * sizeof(SCROLLPLANE_ANIMATION_PALETTE2D));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSCROLLPLANE_ANIMATION_PALETTE2D[temp3].palette2D_number);
   free(pSCROLLPLANE_ANIMATION_PALETTE2D[temp3].palette_target);
  }
  pSCROLLPLANE_ANIMATION_PALETTE2D = (SCROLLPLANE_ANIMATION_PALETTE2D*)realloc(pSCROLLPLANE_ANIMATION_PALETTE2D, temp2 * sizeof(SCROLLPLANE_ANIMATION_PALETTE2D));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_PALETTE2D_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].total_frames      = temp2;
 pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette2D_number  = (int*)realloc(pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette2D_number, temp2 * sizeof(int));
 pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette_target    = (int*)realloc(pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette_target, temp2 * sizeof(int));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_PALETTE2D_setup(int temp1, int temp2, int temp3, int temp4)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The slot number of the palette to display.
    temp4 = The delay value of this frame.
 */
 pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette2D_number[temp2] = temp3;
 pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette_target[temp2]   = temp4;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_PALETTE2D_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ANIMATION_PALETTE2D_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SCROLLPLANE_ANIMATION_PALETTE2D_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSCROLLPLANE_ANIMATION_PALETTE2D[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSCROLLPLANE_ANIMATION_PALETTE2D[animation_number + temp1].palette2D_number[temp2]  = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_PALETTE2D[animation_number + temp1].palette_target[temp2]    = e2_CDROM_read_number(4);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_PALETTE2D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette2D_number[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));  
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette_target[temp3],   (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));
 }
 return(temp2);
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_PALETTE2D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette2D_number[temp3], sizeof(int));
  temp2 += (sizeof(int));  
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_PALETTE2D[temp1].palette_target[temp3],   sizeof(int));
  temp2 += (sizeof(int));
 }
 return(temp2);
}
// ==================================================
//	[SCROLLPLANE_ANIMATION_MOVEMENT] :  <<SCROLLPLANE_ANIMATION_MOVEMENT>>
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MOVEMENT_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSCROLLPLANE_ANIMATION_MOVEMENT = (SCROLLPLANE_ANIMATION_MOVEMENT*)realloc(pSCROLLPLANE_ANIMATION_MOVEMENT, temp2 * sizeof(SCROLLPLANE_ANIMATION_MOVEMENT));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSCROLLPLANE_ANIMATION_MOVEMENT[temp3].movement_target);
   free(pSCROLLPLANE_ANIMATION_MOVEMENT[temp3].movement_increment);
  }
  pSCROLLPLANE_ANIMATION_MOVEMENT = (SCROLLPLANE_ANIMATION_MOVEMENT*)realloc(pSCROLLPLANE_ANIMATION_MOVEMENT, temp2 * sizeof(SCROLLPLANE_ANIMATION_MOVEMENT));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MOVEMENT_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].total_frames = temp2;
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target = (int(*)[3])realloc(pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target, temp2 * sizeof(int * [3]));
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment = (FIXED(*)[3])realloc(pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment, temp2 * sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MOVEMENT_setup(int temp1, int temp2, int temp3, int temp4, int temp5, FIXED temp6, FIXED temp7, FIXED temp8)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The number of times to repeat the X per-frame-increment.
    temp4 = The number of times to repeat the Y per-frame-increment.
    temp5 = The number of times to repeat the Z per-frame-increment.
    temp6 = The X per-frame-increment.
    temp7 = The Y per-frame-increment.
    temp8 = The Z per-frame-increment.
 */
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][0] = temp3;
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][1] = temp4;
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][2] = temp5;

 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][0] = temp6;
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][1] = temp7;
 pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][2] = temp8;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MOVEMENT_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ANIMATION_MOVEMENT_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SCROLLPLANE_ANIMATION_MOVEMENT_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][X] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Y] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Z] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSCROLLPLANE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MOVEMENT_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
 }
 return(temp2);
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_MOVEMENT_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  
 }
 return(temp2);
}
// ==================================================
//	[SCROLLPLANE_ANIMATION_ROTATION] :  <<SCROLLPLANE_ANIMATION_ROTATION>>
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_ROTATION_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSCROLLPLANE_ANIMATION_ROTATION = (SCROLLPLANE_ANIMATION_ROTATION*)realloc(pSCROLLPLANE_ANIMATION_ROTATION, temp2 * sizeof(SCROLLPLANE_ANIMATION_ROTATION));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSCROLLPLANE_ANIMATION_ROTATION[temp3].rotation_target);
   free(pSCROLLPLANE_ANIMATION_ROTATION[temp3].rotation_increment);
  }
  pSCROLLPLANE_ANIMATION_ROTATION = (SCROLLPLANE_ANIMATION_ROTATION*)realloc(pSCROLLPLANE_ANIMATION_ROTATION, temp2 * sizeof(SCROLLPLANE_ANIMATION_ROTATION));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_ROTATION_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].total_frames = temp2;
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target = (int(*)[3])realloc(pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target, temp2 * sizeof(int * [3]));
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment = (ANGLE(*)[3])realloc(pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment, temp2 * sizeof(ANGLE * [3]));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_ROTATION_setup(int temp1, int temp2, int temp3, int temp4, int temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp2][0] = temp3;
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp2][1] = temp4;
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp2][2] = temp5;

 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][0] = temp6;
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][1] = temp7;
 pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][2] = temp8;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_ROTATION_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ANIMATION_ROTATION_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SCROLLPLANE_ANIMATION_ROTATION_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][X] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Y] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Z] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSCROLLPLANE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_ROTATION_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_ROTATION_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
 }
 return;
}
// ==================================================
//	[SCROLLPLANE_ANIMATION_SCALING] :  <<SCROLLPLANE_ANIMATION_SCALING>>
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_SCALING_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSCROLLPLANE_ANIMATION_SCALING = (SCROLLPLANE_ANIMATION_SCALING*)realloc(pSCROLLPLANE_ANIMATION_SCALING, temp2 * sizeof(SCROLLPLANE_ANIMATION_SCALING));
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSCROLLPLANE_ANIMATION_SCALING[temp3].scaling_target);
   free(pSCROLLPLANE_ANIMATION_SCALING[temp3].scaling_increment);
  }
  pSCROLLPLANE_ANIMATION_SCALING = (SCROLLPLANE_ANIMATION_SCALING*)realloc(pSCROLLPLANE_ANIMATION_SCALING, temp2 * sizeof(SCROLLPLANE_ANIMATION_SCALING));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_SCALING_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSCROLLPLANE_ANIMATION_SCALING[temp1].total_frames = temp2;
 pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target = (int(*)[2])realloc(pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target, temp2 * sizeof(int * [2]));
 pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment = (FIXED(*)[2])realloc(pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment, temp2 * sizeof(FIXED * [2]));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_SCALING_setup(int temp1, int temp2, int temp3, int temp4, FIXED temp5, FIXED temp6)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The X per-frame-increment.
    temp6  = The Y per-frame-increment.
 */
 pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp2][0] = temp3;
 pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp2][1] = temp4;

 pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp2][0] = temp5;
 pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp2][1] = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_SCALING_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ANIMATION_SCALING_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SCROLLPLANE_ANIMATION_SCALING_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2][X] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2][Y] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2][Z] = e2_CDROM_read_number(4);
   pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSCROLLPLANE_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_SCALING_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_SCALING[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ANIMATION_SCALING_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSCROLLPLANE_ANIMATION_SCALING[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ANIMATION_SCALING[temp1].scaling_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return;
}
// ==================================================
//	[SCROLLPLANE]        :  <<SCROLLPLANE>>
// --------------------------------------------------
e2_SCROLLPLANE_MAP2D_CEL2D_PALETTE2D_load_into_memory(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the map to use.
    temp2 = The slot number of the cel to use.
    temp3 = The slot number of the palette to use.
    temp4 = The memory address in the videoram to use for the map storage.
    temp5 = The memory address in the videoram to use for the cel storage.
    temp6 = The memory address in the colorram to use for the palette storage.
    temp7 = The slot number of the palette in the colorram for the scrollplane to use (0 - 7 [each is a block of 256]).
 */
 if(pMAP2D[temp1].map_size == 4096)
  e2_MAP2D_load_into_VIDEORAM_2x2(temp1, temp4, temp7);
 if(pMAP2D[temp1].map_size == 2048)
  e2_MAP2D_load_into_VIDEORAM_2x1(temp1, temp4, temp7);
 if(pMAP2D[temp1].map_size == 1024)
  e2_MAP2D_load_into_VIDEORAM_1x1(temp1, temp4, temp7);
 e2_CEL2D_load_into_VIDEORAM(     temp2, temp5);
 e2_PALETTE2D_load_into_COLORRAM( temp3, temp6, 256);
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_initialize(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8, int temp9, FIXED temp10, FIXED temp11, FIXED temp12, FIXED temp13, int temp14)
{
 /*
    temp1  = The number of the scrollplane to use for display.
             Specify 0 for NBG0, 1 for NBG1, 2 for NBG2, or 3 for NBG3.
    temp2  = The size of the scrollplane.
             Specify 0 for 1x1, 1 for 2x1, or 2 for 2x2.
    temp3  = The zoom-mode of the scrollplane.
             Specify 0 for ZOOM_1, 1 for ZOOM_HALF, or 2 for ZOOM_QUARTER.
    temp4  = The slot number of the map to use.
    temp5  = The slot number of the cel to use.
    temp6  = The slot number of the palette to use.
    temp7  = The memory address in the videoram to use for the map storage.
    temp8  = The memory address in the videoram to use for the cel storage.
    temp9  = The memory address in the colorram to use for the palette storage.
    temp10 = The X position of the scrollplane.
    temp11 = The Y position of the scrollplane.
    temp12 = The X zoom value of the scrollplane.
    temp13 = The Y zoom value of the scrollplane.
    temp14 = The slot number of the palette in the colorram for the scrollplane to use (0 - 7 [each is a block of 256]).
 */
 switch(temp1)
 {
  case 0:
    slCharNbg0(COL_TYPE_256, CHAR_SIZE_2x2); slPageNbg0((void*)temp8, 0, PNB_1WORD|CN_10BIT);
    switch(temp2)
    {
     case 0:
      slPlaneNbg0(PL_SIZE_1x1);
     break;
     case 1:
      slPlaneNbg0(PL_SIZE_2x1);
     break;
     case 2:
      slPlaneNbg0(PL_SIZE_2x2);
     break;
    }
    slMapNbg0((void*)temp7, (void*)temp7, (void*)temp7, (void*)temp7); slScrPosNbg0(temp10, temp11); slZoomNbg0(temp12, temp13);
    switch(temp3)
    {
     case 0:
      slZoomModeNbg0(ZOOM_1);
     break;
     case 1:
      slZoomModeNbg0(ZOOM_HALF);
     break;
     case 2:
      slZoomModeNbg0(ZOOM_QUARTER);
     break;
    }
  break;

  case 1:
    slCharNbg1(COL_TYPE_256, CHAR_SIZE_2x2); slPageNbg1((void*)temp8, 0, PNB_1WORD|CN_10BIT);
    switch(temp2)
    {
     case 0:
      slPlaneNbg1(PL_SIZE_1x1);
     break;
     case 1:
      slPlaneNbg1(PL_SIZE_2x1);
     break;
     case 2:
      slPlaneNbg1(PL_SIZE_2x2);
     break;
    }
    slMapNbg1((void*)temp7, (void*)temp7, (void*)temp7, (void*)temp7); slScrPosNbg1(temp10, temp11); slZoomNbg1(temp12, temp13);
    switch(temp3)
    {
     case 0:
      slZoomModeNbg1(ZOOM_1);
     break;
     case 1:
      slZoomModeNbg1(ZOOM_HALF);
     break;
     case 2:
      slZoomModeNbg1(ZOOM_QUARTER);
     break;
    }
  break;

  case 2:
    slCharNbg2(COL_TYPE_256, CHAR_SIZE_2x2); slPageNbg2((void*)temp8, 0, PNB_1WORD|CN_10BIT);
    switch(temp2)
    {
     case 0:
      slPlaneNbg2(PL_SIZE_1x1);
     break;
     case 1:
      slPlaneNbg2(PL_SIZE_2x1);
     break;
     case 2:
      slPlaneNbg2(PL_SIZE_2x2);
     break;
    }
    slMapNbg2((void*)temp7, (void*)temp7, (void*)temp7, (void*)temp7); slScrPosNbg2(temp10, temp11);
  break;

  case 3:
    slCharNbg3(COL_TYPE_256, CHAR_SIZE_2x2); slPageNbg3((void*)temp8, 0, PNB_1WORD|CN_10BIT);
    switch(temp2)
    {
     case 0:
      slPlaneNbg3(PL_SIZE_1x1);
     break;
     case 1:
      slPlaneNbg3(PL_SIZE_2x1);
     break;
     case 2:
      slPlaneNbg3(PL_SIZE_2x2);
     break;
    }
    slMapNbg3((void*)temp7, (void*)temp7, (void*)temp7, (void*)temp7); slScrPosNbg3(temp10, temp11);
  break;
 }

 if(pMAP2D[temp4].map_size == 4096)
  e2_MAP2D_load_into_VIDEORAM_2x2(temp4, temp7, temp14);
 if(pMAP2D[temp4].map_size == 2048)
  e2_MAP2D_load_into_VIDEORAM_2x1(temp4, temp7, temp14);
 if(pMAP2D[temp4].map_size == 1024)
  e2_MAP2D_load_into_VIDEORAM_1x1(temp4, temp7, temp14);
 e2_CEL2D_load_into_VIDEORAM(     temp5, temp8);
 e2_PALETTE2D_load_into_COLORRAM( temp6, temp9, 256);
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSCROLLPLANE_BASIC = (SCROLLPLANE_BASIC*)realloc(pSCROLLPLANE_BASIC, temp1 * sizeof(SCROLLPLANE_BASIC));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, FIXED temp6, int temp7, int temp8, int temp9, int temp10, int temp11, int temp12, int temp13)
{
 /*
    temp1  = The slot number of the sprite to edit
    temp2  = The number of the scrollplane to use for display.
             Specify 0 for NBG0, 1 for NBG1, 2 for NBG2, or 3 for NBG3.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The X zoom value of the sprite.
    temp6  = The Y zoom value of the sprite.
    temp7  = The slot number of the current map in use for this sprite.
    temp8  = The slot number of the current cel in use for this sprite
    temp9  = The slot number of the current palette in use for this sprite.
    temp10 = The memory address in the videoram to use for the map storage.
    temp11 = The memory address in the videoram to use for the cel storage.
    temp12 = The memory address in the colorram to use for the palette storage.
    temp13 = The slot number of the palette in the colorram for the sprite to use (0 - 7 [each is a block of 256]).
 */
 pSCROLLPLANE_BASIC[temp1].use_scrollplane = temp2;

 pSCROLLPLANE_BASIC[temp1].position[X] = temp3;
 pSCROLLPLANE_BASIC[temp1].position[Y] = temp4;

 pSCROLLPLANE_BASIC[temp1].scale[X] = temp5;
 pSCROLLPLANE_BASIC[temp1].scale[Y] = temp6;

 pSCROLLPLANE_BASIC[temp1].current_scrollplane_map     = temp7;
 pSCROLLPLANE_BASIC[temp1].current_scrollplane_cel     = temp8;
 pSCROLLPLANE_BASIC[temp1].current_scrollplane_palette = temp9;

 pSCROLLPLANE_BASIC[temp1].scrollplane_map_memory_address     = temp10;
 pSCROLLPLANE_BASIC[temp1].scrollplane_cel_memory_address     = temp11;
 pSCROLLPLANE_BASIC[temp1].scrollplane_palette_memory_address = temp12;

 pSCROLLPLANE_BASIC[temp1].use_palette = temp13;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_setup_SCROLLPLANE_ANIMATION_MAP2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_BASIC[temp1].map_animate = temp2;
 pSCROLLPLANE_BASIC[temp1].map_loop    = temp3;
 pSCROLLPLANE_BASIC[temp1].map_current_animation = temp4;
 pSCROLLPLANE_BASIC[temp1].map_current_frame     = temp5;
 pSCROLLPLANE_BASIC[temp1].map_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_setup_SCROLLPLANE_ANIMATION_CEL2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_BASIC[temp1].cel_animate = temp2;
 pSCROLLPLANE_BASIC[temp1].cel_loop    = temp3;
 pSCROLLPLANE_BASIC[temp1].cel_current_animation = temp4;
 pSCROLLPLANE_BASIC[temp1].cel_current_frame     = temp5;
 pSCROLLPLANE_BASIC[temp1].cel_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_setup_SCROLLPLANE_ANIMATION_PALETTE2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_BASIC[temp1].palette_animate = temp2;
 pSCROLLPLANE_BASIC[temp1].palette_loop    = temp3;
 pSCROLLPLANE_BASIC[temp1].palette_current_animation = temp4;
 pSCROLLPLANE_BASIC[temp1].palette_current_frame     = temp5;
 pSCROLLPLANE_BASIC[temp1].palette_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_setup_SCROLLPLANE_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_BASIC[temp1].movement_animate = temp2;
 pSCROLLPLANE_BASIC[temp1].movement_loop    = temp3;
 pSCROLLPLANE_BASIC[temp1].movement_current_animation = temp4;
 pSCROLLPLANE_BASIC[temp1].movement_current_frame     = temp5;
 pSCROLLPLANE_BASIC[temp1].movement_timer[X] = temp6;
 pSCROLLPLANE_BASIC[temp1].movement_timer[Y] = temp7;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_setup_SCROLLPLANE_ANIMATION_SCALING(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_BASIC[temp1].scaling_animate = temp2;
 pSCROLLPLANE_BASIC[temp1].scaling_loop    = temp3;
 pSCROLLPLANE_BASIC[temp1].scaling_current_animation = temp4;
 pSCROLLPLANE_BASIC[temp1].scaling_current_frame     = temp5;
 pSCROLLPLANE_BASIC[temp1].scaling_timer[X] = temp6;
 pSCROLLPLANE_BASIC[temp1].scaling_timer[Y] = temp7;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int temp2 = 0;

 if(pSCROLLPLANE_BASIC[temp1].movement_current_animation != NONE)
 {
  if(pSCROLLPLANE_BASIC[temp1].movement_animate == YES)
  {
   if(pSCROLLPLANE_BASIC[temp1].movement_current_frame != pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_BASIC[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 2; temp2++)
    {
     if(pSCROLLPLANE_BASIC[temp1].movement_timer[temp2] != pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_BASIC[temp1].movement_current_animation].movement_target[pSCROLLPLANE_BASIC[temp1].movement_current_frame][temp2])
     {
      pSCROLLPLANE_BASIC[temp1].position[temp2] += pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_BASIC[temp1].movement_current_animation].movement_increment[pSCROLLPLANE_BASIC[temp1].movement_current_frame][temp2];
      pSCROLLPLANE_BASIC[temp1].movement_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_BASIC[temp1].use_scrollplane == 0)
     slScrPosNbg0(pSCROLLPLANE_BASIC[temp1].position[X], pSCROLLPLANE_BASIC[temp1].position[Y]);
    if(pSCROLLPLANE_BASIC[temp1].use_scrollplane == 1)
     slScrPosNbg1(pSCROLLPLANE_BASIC[temp1].position[X], pSCROLLPLANE_BASIC[temp1].position[Y]);
    if(pSCROLLPLANE_BASIC[temp1].use_scrollplane == 2)
     slScrPosNbg2(pSCROLLPLANE_BASIC[temp1].position[X], pSCROLLPLANE_BASIC[temp1].position[Y]);
    if(pSCROLLPLANE_BASIC[temp1].use_scrollplane == 3)
     slScrPosNbg3(pSCROLLPLANE_BASIC[temp1].position[X], pSCROLLPLANE_BASIC[temp1].position[Y]);
    if(pSCROLLPLANE_BASIC[temp1].movement_timer[X] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_BASIC[temp1].movement_current_animation].movement_target[pSCROLLPLANE_BASIC[temp1].movement_current_frame][X] && pSCROLLPLANE_BASIC[temp1].movement_timer[Y] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_BASIC[temp1].movement_current_animation].movement_target[pSCROLLPLANE_BASIC[temp1].movement_current_frame][Y])
    {
     pSCROLLPLANE_BASIC[temp1].movement_current_frame++;
     pSCROLLPLANE_BASIC[temp1].movement_timer[X] = pSCROLLPLANE_BASIC[temp1].movement_timer[Y] = 0;
    }
   }
   if(pSCROLLPLANE_BASIC[temp1].movement_current_frame >= pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_BASIC[temp1].movement_current_animation].total_frames)
   {
    if(pSCROLLPLANE_BASIC[temp1].movement_loop == YES)
     pSCROLLPLANE_BASIC[temp1].movement_current_frame = 0;
    else
     pSCROLLPLANE_BASIC[temp1].movement_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_BASIC[temp1].scaling_current_animation != NONE)
 {
  if(pSCROLLPLANE_BASIC[temp1].scaling_animate == YES)
  {
   if(pSCROLLPLANE_BASIC[temp1].scaling_current_frame != pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_BASIC[temp1].scaling_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 2; temp2++)
    {
     if(pSCROLLPLANE_BASIC[temp1].scaling_timer[temp2] != pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_BASIC[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_BASIC[temp1].scaling_current_frame][temp2])
     {
      pSCROLLPLANE_BASIC[temp1].scale[temp2] += pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_BASIC[temp1].scaling_current_animation].scaling_increment[pSCROLLPLANE_BASIC[temp1].scaling_current_frame][temp2];
      pSCROLLPLANE_BASIC[temp1].scaling_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_BASIC[temp1].use_scrollplane == 0)
     slZoomNbg0(pSCROLLPLANE_BASIC[temp1].scale[X], pSCROLLPLANE_BASIC[temp1].scale[Y]);
    if(pSCROLLPLANE_BASIC[temp1].use_scrollplane == 1)
     slZoomNbg1(pSCROLLPLANE_BASIC[temp1].scale[X], pSCROLLPLANE_BASIC[temp1].scale[Y]);
    if(pSCROLLPLANE_BASIC[temp1].scaling_timer[X] == pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_BASIC[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_BASIC[temp1].scaling_current_frame][X] && pSCROLLPLANE_BASIC[temp1].scaling_timer[Y] == pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_BASIC[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_BASIC[temp1].scaling_current_frame][Y])
    {
     pSCROLLPLANE_BASIC[temp1].scaling_current_frame++;
     pSCROLLPLANE_BASIC[temp1].scaling_timer[X] = pSCROLLPLANE_BASIC[temp1].scaling_timer[Y] = 0;
    }
   }
   if(pSCROLLPLANE_BASIC[temp1].scaling_current_frame >= pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_BASIC[temp1].scaling_current_animation].total_frames)
   {
    if(pSCROLLPLANE_BASIC[temp1].scaling_loop == YES)
     pSCROLLPLANE_BASIC[temp1].scaling_current_frame = 0;
    else
     pSCROLLPLANE_BASIC[temp1].scaling_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_BASIC[temp1].map_current_animation != NONE)
 {
  if(pSCROLLPLANE_BASIC[temp1].map_animate == YES)
  {
   if(pSCROLLPLANE_BASIC[temp1].map_current_frame != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].total_frames)
   {
    if(pSCROLLPLANE_BASIC[temp1].map_timer != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map_target[pSCROLLPLANE_BASIC[temp1].map_current_frame])
    {
     pSCROLLPLANE_BASIC[temp1].map_timer++;
    }
    else
    {
     pSCROLLPLANE_BASIC[temp1].map_current_frame++;
     pSCROLLPLANE_BASIC[temp1].map_timer = 0;
     if(pSCROLLPLANE_BASIC[temp1].map_current_frame >= pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].total_frames)
     {
      if(pSCROLLPLANE_BASIC[temp1].map_loop == YES)
       pSCROLLPLANE_BASIC[temp1].map_current_frame = 0;
      else
       {pSCROLLPLANE_BASIC[temp1].map_current_frame--; pSCROLLPLANE_BASIC[temp1].map_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_BASIC[temp1].current_scrollplane_map != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame])
   {
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame]].map_size == 4096)
     e2_MAP2D_load_into_VIDEORAM_2x2(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame], pSCROLLPLANE_BASIC[temp1].scrollplane_map_memory_address, pSCROLLPLANE_BASIC[temp1].use_palette);
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame]].map_size == 2048)
     e2_MAP2D_load_into_VIDEORAM_2x1(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame], pSCROLLPLANE_BASIC[temp1].scrollplane_map_memory_address, pSCROLLPLANE_BASIC[temp1].use_palette);
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame]].map_size == 1024)
     e2_MAP2D_load_into_VIDEORAM_1x1(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame], pSCROLLPLANE_BASIC[temp1].scrollplane_map_memory_address, pSCROLLPLANE_BASIC[temp1].use_palette);
    pSCROLLPLANE_BASIC[temp1].current_scrollplane_map = pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_BASIC[temp1].map_current_animation].map2D_number[pSCROLLPLANE_BASIC[temp1].map_current_frame];
   }
  }
 }

 if(pSCROLLPLANE_BASIC[temp1].cel_current_animation != NONE)
 {
  if(pSCROLLPLANE_BASIC[temp1].cel_animate == YES)
  {
   if(pSCROLLPLANE_BASIC[temp1].cel_current_frame != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_BASIC[temp1].cel_current_animation].total_frames)
   {
    if(pSCROLLPLANE_BASIC[temp1].cel_timer != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_BASIC[temp1].cel_current_animation].cel_target[pSCROLLPLANE_BASIC[temp1].cel_current_frame])
    {
     pSCROLLPLANE_BASIC[temp1].cel_timer++;
    }
    else
    {
     pSCROLLPLANE_BASIC[temp1].cel_current_frame++;
     pSCROLLPLANE_BASIC[temp1].cel_timer = 0;
     if(pSCROLLPLANE_BASIC[temp1].cel_current_frame >= pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_BASIC[temp1].cel_current_animation].total_frames)
     {
      if(pSCROLLPLANE_BASIC[temp1].cel_loop == YES)
       pSCROLLPLANE_BASIC[temp1].cel_current_frame = 0;
      else
       {pSCROLLPLANE_BASIC[temp1].cel_current_frame--; pSCROLLPLANE_BASIC[temp1].cel_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_BASIC[temp1].current_scrollplane_cel != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_BASIC[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_BASIC[temp1].cel_current_frame])
   {
    e2_CEL2D_load_into_VIDEORAM(pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_BASIC[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_BASIC[temp1].cel_current_frame], pSCROLLPLANE_BASIC[temp1].scrollplane_cel_memory_address);
    pSCROLLPLANE_BASIC[temp1].current_scrollplane_cel = pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_BASIC[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_BASIC[temp1].cel_current_frame];
   }
  }
 }

 if(pSCROLLPLANE_BASIC[temp1].palette_current_animation != NONE)
 {
  if(pSCROLLPLANE_BASIC[temp1].palette_animate == YES)
  {
   if(pSCROLLPLANE_BASIC[temp1].palette_current_frame != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_BASIC[temp1].palette_current_animation].total_frames)
   {
    if(pSCROLLPLANE_BASIC[temp1].palette_timer != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_BASIC[temp1].palette_current_animation].palette_target[pSCROLLPLANE_BASIC[temp1].palette_current_frame])
    {
     pSCROLLPLANE_BASIC[temp1].palette_timer++;
    }
    else
    {
     pSCROLLPLANE_BASIC[temp1].palette_current_frame++;
     pSCROLLPLANE_BASIC[temp1].palette_timer = 0;
     if(pSCROLLPLANE_BASIC[temp1].palette_current_frame >= pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_BASIC[temp1].palette_current_animation].total_frames)
     {
      if(pSCROLLPLANE_BASIC[temp1].palette_loop == YES)
       pSCROLLPLANE_BASIC[temp1].palette_current_frame = 0;
      else
       {pSCROLLPLANE_BASIC[temp1].palette_current_frame--; pSCROLLPLANE_BASIC[temp1].palette_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_BASIC[temp1].current_scrollplane_palette != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_BASIC[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_BASIC[temp1].palette_current_frame])
   {
    e2_PALETTE2D_load_into_COLORRAM(pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_BASIC[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_BASIC[temp1].palette_current_frame], pSCROLLPLANE_BASIC[temp1].scrollplane_palette_memory_address, 256);
    pSCROLLPLANE_BASIC[temp1].current_scrollplane_palette = pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_BASIC[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_BASIC[temp1].palette_current_frame];
   }
  }
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_BASIC_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSCROLLPLANE_BASIC[sprite_number + temp1].use_scrollplane = e2_CDROM_read_number(1);

  pSCROLLPLANE_BASIC[sprite_number + temp1].map_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].map_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].map_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].map_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].map_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_BASIC[sprite_number + temp1].cel_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].cel_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].cel_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].cel_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].cel_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_BASIC[sprite_number + temp1].palette_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].palette_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].palette_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].palette_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].palette_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_BASIC[sprite_number + temp1].movement_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].movement_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].movement_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].movement_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].movement_timer[Y]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_BASIC[sprite_number + temp1].scaling_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].scaling_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_BASIC[sprite_number + temp1].scaling_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].scaling_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].scaling_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_BASIC[sprite_number + temp1].scaling_timer[Y]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_BASIC[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_BASIC[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_BASIC[sprite_number + temp1].scale[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_BASIC[sprite_number + temp1].scale[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_BASIC[sprite_number + temp1].current_scrollplane_map     = e2_CDROM_read_number(9);
  pSCROLLPLANE_BASIC[sprite_number + temp1].current_scrollplane_cel     = e2_CDROM_read_number(9);
  pSCROLLPLANE_BASIC[sprite_number + temp1].current_scrollplane_palette = e2_CDROM_read_number(9);

  pSCROLLPLANE_BASIC[sprite_number + temp1].scrollplane_map_memory_address     = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_BASIC[sprite_number + temp1].scrollplane_cel_memory_address     = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_BASIC[sprite_number + temp1].scrollplane_palette_memory_address = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));

  pSCROLLPLANE_BASIC[sprite_number + temp1].use_palette = (e2_CDROM_read_number(8) * e2_CDROM_read_number(1));
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].use_scrollplane, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].map_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].map_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].map_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].map_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].map_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].cel_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].cel_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].cel_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].cel_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].cel_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].palette_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].palette_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].palette_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].palette_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].palette_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scaling_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scaling_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scaling_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scaling_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scaling_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scaling_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scale[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scale[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].current_scrollplane_map, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].current_scrollplane_cel, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].current_scrollplane_palette, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scrollplane_map_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scrollplane_cel_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].scrollplane_palette_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_BASIC[temp1].use_palette, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_BASIC_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].use_scrollplane, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].map_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].map_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].map_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].map_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].map_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].cel_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].cel_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].cel_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].cel_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].cel_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].palette_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].palette_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].palette_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].palette_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].palette_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scaling_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scaling_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scaling_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scaling_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scaling_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scaling_timer[Y], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scale[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scale[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].current_scrollplane_map, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].current_scrollplane_cel, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].current_scrollplane_palette, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scrollplane_map_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scrollplane_cel_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].scrollplane_palette_memory_address, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_BASIC[temp1].use_palette, sizeof(int));
 temp2 += sizeof(int);
 return;
}
// ==================================================
//	[SCROLLPLANE_EXTRA]      :  <<SCROLLPLANE_EXTRA>>
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_initialize(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8, int temp9, int temp10, FIXED temp11, FIXED temp12, ANGLE temp13, FIXED temp14, FIXED temp15, FIXED temp16, FIXED temp17, int temp18)
{
 /*
    temp1  = The number of the scrollplane to use for display.
             Specify either 0 for RA or 1 for RB.
    temp2  = The size of the scrollplane.
             Specify 0 for 1x1, 1 for 2x1, or 2 for 2x2.
    temp3  = The screen overflow processing mode of the scrollplane.
             Specify a number from 0 to 3.
    temp4  = The slot number of the map to use.
    temp5  = The slot number of the cel to use.
    temp6  = The slot number of the palette to use.
    temp7  = The memory address in the videoram to use for the map storage.
    temp8  = The memory address in the videoram to use for the cel storage.
    temp9  = The memory address in the colorram to use for the palette storage.
    temp10 = The memory address of the scrollplane's rotation parameter table.
    temp11 = The X position of the scrollplane.
    temp12 = The Y position of the scrollplane.
    temp13 = The Z angle of the scrollplane.
    temp14 = The X scale of the scrollplane.
    temp15 = The Y scale of the scrollplane.
    temp16 = The X center of rotation for the scrollplane.
    temp17 = The Y center of rotation for the scrollplane.
    temp18 = The slot number of the palette in the colorram for the scrollplane to use (0 - 7 [each is a block of 256]).
 */
 slRparaInitSet((void *)temp10);
 slCharRbg0(COL_TYPE_256, CHAR_SIZE_2x2);
 slPageRbg0((void *)temp8, 0, PNB_1WORD|CN_10BIT);

 if(temp1 == 0)
 {
  if(temp2 == 0) slPlaneRA(PL_SIZE_1x1);
  if(temp2 == 1) slPlaneRA(PL_SIZE_2x1);
  if(temp2 == 2) slPlaneRA(PL_SIZE_2x2);
  sl1MapRA((void *)temp7);
  slOverRA(temp3);
 }

 if(temp1 == 1)
 {
  if(temp2 == 0) slPlaneRB(PL_SIZE_1x1);
  if(temp2 == 1) slPlaneRB(PL_SIZE_2x1);
  if(temp2 == 2) slPlaneRB(PL_SIZE_2x2);
  sl1MapRB((void *)temp7);
  slOverRB(temp3);
 }

 if(pMAP2D[temp4].map_size == 4096)
  e2_MAP2D_load_into_VIDEORAM_2x2(temp4, temp7, temp18);
 if(pMAP2D[temp4].map_size == 2048)
  e2_MAP2D_load_into_VIDEORAM_2x1(temp4, temp7, temp18);
 if(pMAP2D[temp4].map_size == 1024)
  e2_MAP2D_load_into_VIDEORAM_1x1(temp4, temp7, temp18);
 e2_CEL2D_load_into_VIDEORAM(     temp5, temp8);
 e2_PALETTE2D_load_into_COLORRAM( temp6, temp9, 256);

 slDispCenterR(temp16, temp17);
 slLookR(temp11, temp12);
 slZrotR(temp13);
 slZoomR(temp14, temp15);
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSCROLLPLANE_EXTRA = (SCROLLPLANE_EXTRA*)realloc(pSCROLLPLANE_EXTRA, temp1 * sizeof(SCROLLPLANE_EXTRA));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, ANGLE temp5, FIXED temp6, FIXED temp7, FIXED temp8, FIXED temp9, int temp10, int temp11, int temp12, int temp13, int temp14, int temp15, int temp16, int temp17)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = The number of the scrollplane to use for display.
             Specify either 0 for RA or 1 for RB.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z angle of the sprite.
    temp6  = The X scale of the sprite.
    temp7  = The Y scale of the sprite.
    temp8  = The X center of rotation for the sprite.
    temp9  = The Y center of rotation for the sprite.
    temp10 = The slot number of the current map in use for this sprite.
    temp11 = The slot number of the current cel in use for this sprite
    temp12 = The slot number of the current palette in use for this sprite.
    temp13 = The memory address in the videoram to use for the map storage.
    temp14 = The memory address in the videoram to use for the cel storage.
    temp15 = The memory address in the colorram to use for the palette storage.
    temp16 = The memory address of the sprite's rotation parameter table.
    temp17 = The slot number of the palette in the colorram for the sprite to use (0 - 7 [each is a block of 256]).
 */
 pSCROLLPLANE_EXTRA[temp1].use_scrollplane = temp2;

 pSCROLLPLANE_EXTRA[temp1].position[X] = temp3;
 pSCROLLPLANE_EXTRA[temp1].position[Y] = temp4;

 pSCROLLPLANE_EXTRA[temp1].angle = temp5;

 pSCROLLPLANE_EXTRA[temp1].scale[X] = temp6;
 pSCROLLPLANE_EXTRA[temp1].scale[Y] = temp7;

 pSCROLLPLANE_EXTRA[temp1].rotation_position[X] = temp8;
 pSCROLLPLANE_EXTRA[temp1].rotation_position[Y] = temp9;

 pSCROLLPLANE_EXTRA[temp1].current_scrollplane_map     = temp10;
 pSCROLLPLANE_EXTRA[temp1].current_scrollplane_cel     = temp11;
 pSCROLLPLANE_EXTRA[temp1].current_scrollplane_palette = temp12;

 pSCROLLPLANE_EXTRA[temp1].scrollplane_map_memory_address     = temp13;
 pSCROLLPLANE_EXTRA[temp1].scrollplane_cel_memory_address     = temp14;
 pSCROLLPLANE_EXTRA[temp1].scrollplane_palette_memory_address = temp15;

 pSCROLLPLANE_EXTRA[temp1].rotation_parameter_memory_address  = temp16;

 pSCROLLPLANE_EXTRA[temp1].use_palette  = temp17;

 if(pSCROLLPLANE_EXTRA[temp1].use_scrollplane == 0)
  slRparaMode(RA);
 if(pSCROLLPLANE_EXTRA[temp1].use_scrollplane == 1)
  slRparaMode(RB);

 slDispCenterR(pSCROLLPLANE_EXTRA[temp1].rotation_position[X], pSCROLLPLANE_EXTRA[temp1].rotation_position[Y]);
 slLookR(pSCROLLPLANE_EXTRA[temp1].position[X], pSCROLLPLANE_EXTRA[temp1].position[Y]);
 slZrotR(pSCROLLPLANE_EXTRA[temp1].angle);
 slZoomR(pSCROLLPLANE_EXTRA[temp1].scale[X], pSCROLLPLANE_EXTRA[temp1].scale[Y]);
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup_SCROLLPLANE_ANIMATION_MAP2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_EXTRA[temp1].map_animate = temp2;
 pSCROLLPLANE_EXTRA[temp1].map_loop    = temp3;
 pSCROLLPLANE_EXTRA[temp1].map_current_animation = temp4;
 pSCROLLPLANE_EXTRA[temp1].map_current_frame     = temp5;
 pSCROLLPLANE_EXTRA[temp1].map_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup_SCROLLPLANE_ANIMATION_CEL2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_EXTRA[temp1].cel_animate = temp2;
 pSCROLLPLANE_EXTRA[temp1].cel_loop    = temp3;
 pSCROLLPLANE_EXTRA[temp1].cel_current_animation = temp4;
 pSCROLLPLANE_EXTRA[temp1].cel_current_frame     = temp5;
 pSCROLLPLANE_EXTRA[temp1].cel_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup_SCROLLPLANE_ANIMATION_PALETTE2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_EXTRA[temp1].palette_animate = temp2;
 pSCROLLPLANE_EXTRA[temp1].palette_loop    = temp3;
 pSCROLLPLANE_EXTRA[temp1].palette_current_animation = temp4;
 pSCROLLPLANE_EXTRA[temp1].palette_current_frame     = temp5;
 pSCROLLPLANE_EXTRA[temp1].palette_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup_SCROLLPLANE_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_EXTRA[temp1].movement_animate = temp2;
 pSCROLLPLANE_EXTRA[temp1].movement_loop    = temp3;
 pSCROLLPLANE_EXTRA[temp1].movement_current_animation = temp4;
 pSCROLLPLANE_EXTRA[temp1].movement_current_frame     = temp5;
 pSCROLLPLANE_EXTRA[temp1].movement_timer[X] = temp6;
 pSCROLLPLANE_EXTRA[temp1].movement_timer[Y] = temp7;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup_SCROLLPLANE_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_EXTRA[temp1].rotation_animate = temp2;
 pSCROLLPLANE_EXTRA[temp1].rotation_loop    = temp3;
 pSCROLLPLANE_EXTRA[temp1].rotation_current_animation = temp4;
 pSCROLLPLANE_EXTRA[temp1].rotation_current_frame     = temp5;
 pSCROLLPLANE_EXTRA[temp1].rotation_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_setup_SCROLLPLANE_ANIMATION_SCALING(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_EXTRA[temp1].scaling_animate = temp2;
 pSCROLLPLANE_EXTRA[temp1].scaling_loop    = temp3;
 pSCROLLPLANE_EXTRA[temp1].scaling_current_animation = temp4;
 pSCROLLPLANE_EXTRA[temp1].scaling_current_frame     = temp5;
 pSCROLLPLANE_EXTRA[temp1].scaling_timer[X] = temp6;
 pSCROLLPLANE_EXTRA[temp1].scaling_timer[Y] = temp7;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int temp2 = 0;

 if(pSCROLLPLANE_EXTRA[temp1].use_scrollplane == 0)
  slRparaMode(RA);
 if(pSCROLLPLANE_EXTRA[temp1].use_scrollplane == 1)
  slRparaMode(RB);

 if(pSCROLLPLANE_EXTRA[temp1].movement_current_animation != NONE)
 {
  if(pSCROLLPLANE_EXTRA[temp1].movement_animate == YES)
  {
   if(pSCROLLPLANE_EXTRA[temp1].movement_current_frame != pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_EXTRA[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 2; temp2++)
    {
     if(pSCROLLPLANE_EXTRA[temp1].movement_timer[temp2] != pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_EXTRA[temp1].movement_current_animation].movement_target[pSCROLLPLANE_EXTRA[temp1].movement_current_frame][temp2])
     {
      pSCROLLPLANE_EXTRA[temp1].position[temp2] += pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_EXTRA[temp1].movement_current_animation].movement_increment[pSCROLLPLANE_EXTRA[temp1].movement_current_frame][temp2];
      pSCROLLPLANE_EXTRA[temp1].movement_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_EXTRA[temp1].movement_timer[X] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_EXTRA[temp1].movement_current_animation].movement_target[pSCROLLPLANE_EXTRA[temp1].movement_current_frame][X] && pSCROLLPLANE_EXTRA[temp1].movement_timer[Y] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_EXTRA[temp1].movement_current_animation].movement_target[pSCROLLPLANE_EXTRA[temp1].movement_current_frame][Y])
    {
     pSCROLLPLANE_EXTRA[temp1].movement_current_frame++;
     pSCROLLPLANE_EXTRA[temp1].movement_timer[X] = pSCROLLPLANE_EXTRA[temp1].movement_timer[Y] = 0;
    }
   }
   if(pSCROLLPLANE_EXTRA[temp1].movement_current_frame >= pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_EXTRA[temp1].movement_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].movement_loop == YES)
     pSCROLLPLANE_EXTRA[temp1].movement_current_frame = 0;
    else
     pSCROLLPLANE_EXTRA[temp1].movement_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_EXTRA[temp1].rotation_current_animation != NONE)
 {
  if(pSCROLLPLANE_EXTRA[temp1].rotation_animate == YES)
  {
   if(pSCROLLPLANE_EXTRA[temp1].rotation_current_frame != pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_EXTRA[temp1].rotation_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].rotation_timer != pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_EXTRA[temp1].rotation_current_animation].rotation_target[pSCROLLPLANE_EXTRA[temp1].rotation_current_frame][2])
    {
     pSCROLLPLANE_EXTRA[temp1].angle += pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_EXTRA[temp1].rotation_current_animation].rotation_increment[pSCROLLPLANE_EXTRA[temp1].rotation_current_frame][2];
     pSCROLLPLANE_EXTRA[temp1].rotation_timer++;
    }
    if(pSCROLLPLANE_EXTRA[temp1].rotation_timer == pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_EXTRA[temp1].rotation_current_animation].rotation_target[pSCROLLPLANE_EXTRA[temp1].rotation_current_frame][2])
    {
     pSCROLLPLANE_EXTRA[temp1].rotation_current_frame++;
     pSCROLLPLANE_EXTRA[temp1].rotation_timer = 0;
    }
   }
   if(pSCROLLPLANE_EXTRA[temp1].rotation_current_frame >= pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_EXTRA[temp1].rotation_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].rotation_loop == YES)
     pSCROLLPLANE_EXTRA[temp1].rotation_current_frame = 0;
    else
     pSCROLLPLANE_EXTRA[temp1].rotation_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_EXTRA[temp1].scaling_current_animation != NONE)
 {
  if(pSCROLLPLANE_EXTRA[temp1].scaling_animate == YES)
  {
   if(pSCROLLPLANE_EXTRA[temp1].scaling_current_frame != pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_EXTRA[temp1].scaling_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 2; temp2++)
    {
     if(pSCROLLPLANE_EXTRA[temp1].scaling_timer[temp2] != pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_EXTRA[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_EXTRA[temp1].scaling_current_frame][temp2])
     {
      pSCROLLPLANE_EXTRA[temp1].scale[temp2] += pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_EXTRA[temp1].scaling_current_animation].scaling_increment[pSCROLLPLANE_EXTRA[temp1].scaling_current_frame][temp2];
      pSCROLLPLANE_EXTRA[temp1].scaling_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_EXTRA[temp1].scaling_timer[X] == pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_EXTRA[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_EXTRA[temp1].scaling_current_frame][X] && pSCROLLPLANE_EXTRA[temp1].scaling_timer[Y] == pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_EXTRA[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_EXTRA[temp1].scaling_current_frame][Y])
    {
     pSCROLLPLANE_EXTRA[temp1].scaling_current_frame++;
     pSCROLLPLANE_EXTRA[temp1].scaling_timer[X] = pSCROLLPLANE_EXTRA[temp1].scaling_timer[Y] = 0;
    }
   }
   if(pSCROLLPLANE_EXTRA[temp1].scaling_current_frame >= pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_EXTRA[temp1].scaling_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].scaling_loop == YES)
     pSCROLLPLANE_EXTRA[temp1].scaling_current_frame = 0;
    else
     pSCROLLPLANE_EXTRA[temp1].scaling_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_EXTRA[temp1].map_current_animation != NONE)
 {
  if(pSCROLLPLANE_EXTRA[temp1].map_animate == YES)
  {
   if(pSCROLLPLANE_EXTRA[temp1].map_current_frame != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].map_timer != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map_target[pSCROLLPLANE_EXTRA[temp1].map_current_frame])
    {
     pSCROLLPLANE_EXTRA[temp1].map_timer++;
    }
    else
    {
     pSCROLLPLANE_EXTRA[temp1].map_current_frame++;
     pSCROLLPLANE_EXTRA[temp1].map_timer = 0;
     if(pSCROLLPLANE_EXTRA[temp1].map_current_frame >= pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].total_frames)
     {
      if(pSCROLLPLANE_EXTRA[temp1].map_loop == YES)
       pSCROLLPLANE_EXTRA[temp1].map_current_frame = 0;
      else
       {pSCROLLPLANE_EXTRA[temp1].map_current_frame--; pSCROLLPLANE_EXTRA[temp1].map_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_EXTRA[temp1].current_scrollplane_map != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame])
   {
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame]].map_size == 4096)
     e2_MAP2D_load_into_VIDEORAM_2x2(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame], pSCROLLPLANE_EXTRA[temp1].scrollplane_map_memory_address, pSCROLLPLANE_EXTRA[temp1].use_palette);
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame]].map_size == 2048)
     e2_MAP2D_load_into_VIDEORAM_2x1(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame], pSCROLLPLANE_EXTRA[temp1].scrollplane_map_memory_address, pSCROLLPLANE_EXTRA[temp1].use_palette);
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame]].map_size == 1024)
     e2_MAP2D_load_into_VIDEORAM_1x1(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame], pSCROLLPLANE_EXTRA[temp1].scrollplane_map_memory_address, pSCROLLPLANE_EXTRA[temp1].use_palette);
    pSCROLLPLANE_EXTRA[temp1].current_scrollplane_map = pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_EXTRA[temp1].map_current_animation].map2D_number[pSCROLLPLANE_EXTRA[temp1].map_current_frame];
   }
  }
 }

 if(pSCROLLPLANE_EXTRA[temp1].cel_current_animation != NONE)
 {
  if(pSCROLLPLANE_EXTRA[temp1].cel_animate == YES)
  {
   if(pSCROLLPLANE_EXTRA[temp1].cel_current_frame != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_EXTRA[temp1].cel_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].cel_timer != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_EXTRA[temp1].cel_current_animation].cel_target[pSCROLLPLANE_EXTRA[temp1].cel_current_frame])
    {
     pSCROLLPLANE_EXTRA[temp1].cel_timer++;
    }
    else
    {
     pSCROLLPLANE_EXTRA[temp1].cel_current_frame++;
     pSCROLLPLANE_EXTRA[temp1].cel_timer = 0;
     if(pSCROLLPLANE_EXTRA[temp1].cel_current_frame >= pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_EXTRA[temp1].cel_current_animation].total_frames)
     {
      if(pSCROLLPLANE_EXTRA[temp1].cel_loop == YES)
       pSCROLLPLANE_EXTRA[temp1].cel_current_frame = 0;
      else
       {pSCROLLPLANE_EXTRA[temp1].cel_current_frame--; pSCROLLPLANE_EXTRA[temp1].cel_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_EXTRA[temp1].current_scrollplane_cel != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_EXTRA[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_EXTRA[temp1].cel_current_frame])
   {
    e2_CEL2D_load_into_VIDEORAM(pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_EXTRA[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_EXTRA[temp1].cel_current_frame], pSCROLLPLANE_EXTRA[temp1].scrollplane_cel_memory_address);
    pSCROLLPLANE_EXTRA[temp1].current_scrollplane_cel = pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_EXTRA[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_EXTRA[temp1].cel_current_frame];
   }
  }
 }

 if(pSCROLLPLANE_EXTRA[temp1].palette_current_animation != NONE)
 {
  if(pSCROLLPLANE_EXTRA[temp1].palette_animate == YES)
  {
   if(pSCROLLPLANE_EXTRA[temp1].palette_current_frame != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_EXTRA[temp1].palette_current_animation].total_frames)
   {
    if(pSCROLLPLANE_EXTRA[temp1].palette_timer != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_EXTRA[temp1].palette_current_animation].palette_target[pSCROLLPLANE_EXTRA[temp1].palette_current_frame])
    {
     pSCROLLPLANE_EXTRA[temp1].palette_timer++;
    }
    else
    {
     pSCROLLPLANE_EXTRA[temp1].palette_current_frame++;
     pSCROLLPLANE_EXTRA[temp1].palette_timer = 0;
     if(pSCROLLPLANE_EXTRA[temp1].palette_current_frame >= pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_EXTRA[temp1].palette_current_animation].total_frames)
     {
      if(pSCROLLPLANE_EXTRA[temp1].palette_loop == YES)
       pSCROLLPLANE_EXTRA[temp1].palette_current_frame = 0;
      else
       {pSCROLLPLANE_EXTRA[temp1].palette_current_frame--; pSCROLLPLANE_EXTRA[temp1].palette_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_EXTRA[temp1].current_scrollplane_palette != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_EXTRA[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_EXTRA[temp1].palette_current_frame])
   {
    e2_PALETTE2D_load_into_COLORRAM(pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_EXTRA[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_EXTRA[temp1].palette_current_frame], pSCROLLPLANE_EXTRA[temp1].scrollplane_palette_memory_address, 256);
    pSCROLLPLANE_EXTRA[temp1].current_scrollplane_palette = pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_EXTRA[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_EXTRA[temp1].palette_current_frame];
   }
  }
 }

 slDispCenterR(pSCROLLPLANE_EXTRA[temp1].position[X], pSCROLLPLANE_EXTRA[temp1].position[Y]);
 slLookR(pSCROLLPLANE_EXTRA[temp1].rotation_position[X], pSCROLLPLANE_EXTRA[temp1].rotation_position[Y]);
 slZrotR(pSCROLLPLANE_EXTRA[temp1].angle);
 slZoomR(pSCROLLPLANE_EXTRA[temp1].scale[X], pSCROLLPLANE_EXTRA[temp1].scale[Y]);
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_EXTRA_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSCROLLPLANE_EXTRA[sprite_number + temp1].use_scrollplane = e2_CDROM_read_number(1);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].map_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].map_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].map_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].map_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].map_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].cel_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].cel_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].cel_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].cel_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].cel_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].palette_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].palette_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].palette_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].palette_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].palette_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].movement_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].movement_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].movement_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].movement_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].movement_timer[Y]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].scaling_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scaling_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scaling_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scaling_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scaling_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scaling_timer[Y]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].angle = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].scale[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scale[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].current_scrollplane_map     = e2_CDROM_read_number(9);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].current_scrollplane_cel     = e2_CDROM_read_number(9);
  pSCROLLPLANE_EXTRA[sprite_number + temp1].current_scrollplane_palette = e2_CDROM_read_number(9);

  pSCROLLPLANE_EXTRA[sprite_number + temp1].scrollplane_map_memory_address     = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scrollplane_cel_memory_address     = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_EXTRA[sprite_number + temp1].scrollplane_palette_memory_address = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));

  pSCROLLPLANE_EXTRA[sprite_number + temp1].rotation_parameter_memory_address  = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));

  pSCROLLPLANE_EXTRA[sprite_number + temp1].use_palette  = e2_CDROM_read_number(1);
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].use_scrollplane, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].map_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].map_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].map_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].map_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].map_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].cel_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].cel_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].cel_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].cel_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].cel_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].palette_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].palette_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].palette_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].palette_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].palette_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scaling_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scaling_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scaling_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scaling_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scaling_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scaling_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].angle, (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scale[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scale[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].current_scrollplane_map, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].current_scrollplane_cel, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].current_scrollplane_palette, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scrollplane_map_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scrollplane_cel_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].scrollplane_palette_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].rotation_parameter_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_EXTRA[temp1].use_palette, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_EXTRA_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].use_scrollplane, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].map_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].map_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].map_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].map_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].map_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].cel_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].cel_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].cel_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].cel_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].cel_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].palette_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].palette_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].palette_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].palette_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].palette_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scaling_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scaling_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scaling_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scaling_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scaling_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scaling_timer[Y], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].angle, sizeof(ANGLE));
 temp2 += sizeof(ANGLE);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scale[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scale[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].current_scrollplane_map, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].current_scrollplane_cel, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].current_scrollplane_palette, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scrollplane_map_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scrollplane_cel_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].scrollplane_palette_memory_address, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].rotation_parameter_memory_address, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_EXTRA[temp1].use_palette, sizeof(int));
 temp2 += sizeof(int);
 return;
}
// ==================================================
//	[SCROLLPLANE_ADVANCED]    :  <<SCROLLPLANE_ADVANCED>>
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_initialize(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8, int temp9, int temp10, int temp11, int temp12, FIXED temp13, FIXED temp14, FIXED temp15, ANGLE temp16, ANGLE temp17, ANGLE temp18, FIXED temp19, FIXED temp20, FIXED temp21, FIXED temp22, int temp23)
{
 /*
    temp1  = The number of the scrollplane to use for display.
             Specify either 0 for RA or 1 for RB.
    temp2  = The size of the scrollplane.
             Specify 0 for 1x1, 1 for 2x1, or 2 for 2x2.
    temp3  = The screen overflow processing mode of the scrollplane.
             Specify a number from 0 to 3.
    temp4  = The K_MODE of the scrollplane.
             Specify 0 for RA, 1 for RB, or 2 for K_CHANGE.
    temp5  = The slot number of the map to use.
    temp6  = The slot number of the cel to use.
    temp7  = The slot number of the palette to use.
    temp8  = The memory address in the videoram to use for the map storage.
    temp9  = The memory address in the videoram to use for the cel storage.
    temp10 = The memory address in the colorram to use for the palette storage.
    temp11 = The memory address of the scrollplane's rotation parameter table.
    temp12 = The memory address of the scrollplane's rotation calculation table.
    temp13 = The X position of the scrollplane.
    temp14 = The Y position of the scrollplane.
    temp15 = The Z position of the scrollplane.
    temp16 = The X angle of the scrollplane.
    temp17 = The Y angle of the scrollplane.
    temp18 = The Z angle of the scrollplane
    temp19 = The X scale of the scrollplane.
    temp20 = The Y scale of the scrollplane.
    temp21 = The X center of rotation for the scrollplane.
    temp22 = The Y center of rotation for the scrollplane.
    temp23 = The slot number of the palette in the colorram for the scrollplane to use (0 - 7 [each is a block of 256]).
 */
 slRparaInitSet((void *)temp11);
 slMakeKtable((void *)temp12);
 slCharRbg0(COL_TYPE_256, CHAR_SIZE_2x2);
 slPageRbg0((void *)temp9, 0, PNB_1WORD|CN_10BIT);

 if(temp1 == 0)
 {
  if(temp2 == 0) slPlaneRA(PL_SIZE_1x1);
  if(temp2 == 1) slPlaneRA(PL_SIZE_2x1);
  if(temp2 == 2) slPlaneRA(PL_SIZE_2x2);
  sl1MapRA((void *)temp8);
  slOverRA(temp3);
  slKtableRA((void *)temp12 , K_FIX | K_DOT | K_2WORD | K_ON);
 }

 if(temp1 == 1)
 {
  if(temp2 == 0) slPlaneRB(PL_SIZE_1x1);
  if(temp2 == 1) slPlaneRB(PL_SIZE_2x1);
  if(temp2 == 2) slPlaneRB(PL_SIZE_2x2);
  sl1MapRB((void *)temp8);
  slOverRB(temp3);
  slKtableRB((void *)temp12 , K_FIX | K_DOT | K_2WORD | K_ON);
 }

 if(pMAP2D[temp5].map_size == 4096)
  e2_MAP2D_load_into_VIDEORAM_2x2(temp5, temp8,  temp23);
 if(pMAP2D[temp5].map_size == 2048)
  e2_MAP2D_load_into_VIDEORAM_2x1(temp5, temp8,  temp23);
 if(pMAP2D[temp5].map_size == 1024)
  e2_MAP2D_load_into_VIDEORAM_1x1(temp5, temp8,  temp23);
 e2_CEL2D_load_into_VIDEORAM(     temp6, temp9);
 e2_PALETTE2D_load_into_COLORRAM( temp7, temp10, 256);

 if(temp4 == 0) slRparaMode(RA);
 if(temp4 == 1) slRparaMode(RB);
 if(temp4 == 2) slRparaMode(K_CHANGE);

 if(temp1 == 0) slCurRpara(RA);
 if(temp1 == 1) slCurRpara(RB);

 slUnitMatrix(CURRENT);
 slDispCenterR(temp21, temp22);
 slTranslate(temp13, temp14, temp15);
 slRotX(temp16);
 slRotY(temp17);
 slRotZ(temp18);
 slZoomR(temp19, temp20);
 slScrMatSet();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSCROLLPLANE_ADVANCED = (SCROLLPLANE_ADVANCED*)realloc(pSCROLLPLANE_ADVANCED, temp1 * sizeof(SCROLLPLANE_ADVANCED));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8, FIXED temp9, FIXED temp10, FIXED temp11, FIXED temp12, int temp13, int temp14, int temp15, int temp16, int temp17, int temp18, int temp19, int temp20, int temp21)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = The number of the scrollplane to use for display.
             Specify either 0 for RA or 1 for RB.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The X angle of the sprite.
    temp7  = The Y angle of the sprite.
    temp8  = The Z angle of the sprite.
    temp9  = The X scale of the sprite.
    temp10 = The Y scale of the sprite.
    temp11 = The X center of rotation for the sprite.
    temp12 = The Y center of rotation for the sprite.
    temp13 = The slot number of the current map in use for this sprite.
    temp14 = The slot number of the current cel in use for this sprite
    temp15 = The slot number of the current palette in use for this sprite.
    temp16 = The memory address in the videoram to use for the map storage.
    temp17 = The memory address in the videoram to use for the cel storage.
    temp18 = The memory address in the colorram to use for the palette storage.
    temp19 = The memory address of the sprite's rotation parameter table.
    temp20 = The memory address of the sprite's rotation calculation table.
    temp21 = The slot number of the palette in the colorram for the sprite to use (0 - 7 [each is a block of 256]).
 */
 pSCROLLPLANE_ADVANCED[temp1].use_scrollplane = temp2;

 pSCROLLPLANE_ADVANCED[temp1].position[X] = temp3;
 pSCROLLPLANE_ADVANCED[temp1].position[Y] = temp4;
 pSCROLLPLANE_ADVANCED[temp1].position[Z] = temp5;

 pSCROLLPLANE_ADVANCED[temp1].angle[X] = temp6;
 pSCROLLPLANE_ADVANCED[temp1].angle[Y] = temp7;
 pSCROLLPLANE_ADVANCED[temp1].angle[Z] = temp8;

 pSCROLLPLANE_ADVANCED[temp1].scale[X] = temp9;
 pSCROLLPLANE_ADVANCED[temp1].scale[Y] = temp10;

 pSCROLLPLANE_ADVANCED[temp1].rotation_position[X] = temp11;
 pSCROLLPLANE_ADVANCED[temp1].rotation_position[Y] = temp12;

 pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_map     = temp13;
 pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_cel     = temp14;
 pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_palette = temp15;

 pSCROLLPLANE_ADVANCED[temp1].scrollplane_map_memory_address     = temp16;
 pSCROLLPLANE_ADVANCED[temp1].scrollplane_cel_memory_address     = temp17;
 pSCROLLPLANE_ADVANCED[temp1].scrollplane_palette_memory_address = temp18;

 pSCROLLPLANE_ADVANCED[temp1].rotation_parameter_memory_address = temp19;
 pSCROLLPLANE_ADVANCED[temp1].rotation_table_memory_address     = temp20;

 pSCROLLPLANE_ADVANCED[temp1].use_palette = temp21;

 if(pSCROLLPLANE_ADVANCED[temp1].use_scrollplane == 0) slCurRpara(RA);
 if(pSCROLLPLANE_ADVANCED[temp1].use_scrollplane == 1) slCurRpara(RB);

 slUnitMatrix(CURRENT);
 slDispCenterR(pSCROLLPLANE_ADVANCED[temp1].rotation_position[X], pSCROLLPLANE_ADVANCED[temp1].rotation_position[Y]);
 slTranslate(pSCROLLPLANE_ADVANCED[temp1].position[X], pSCROLLPLANE_ADVANCED[temp1].position[Y], pSCROLLPLANE_ADVANCED[temp1].position[Z]);
 slRotX(pSCROLLPLANE_ADVANCED[temp1].angle[X]);
 slRotY(pSCROLLPLANE_ADVANCED[temp1].angle[Y]);
 slRotZ(pSCROLLPLANE_ADVANCED[temp1].angle[Z]);
 slZoomR(pSCROLLPLANE_ADVANCED[temp1].scale[X], pSCROLLPLANE_ADVANCED[temp1].scale[Y]);
 slScrMatSet();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup_SCROLLPLANE_ANIMATION_MAP2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_ADVANCED[temp1].map_animate = temp2;
 pSCROLLPLANE_ADVANCED[temp1].map_loop    = temp3;
 pSCROLLPLANE_ADVANCED[temp1].map_current_animation = temp4;
 pSCROLLPLANE_ADVANCED[temp1].map_current_frame     = temp5;
 pSCROLLPLANE_ADVANCED[temp1].map_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup_SCROLLPLANE_ANIMATION_CEL2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_ADVANCED[temp1].cel_animate = temp2;
 pSCROLLPLANE_ADVANCED[temp1].cel_loop    = temp3;
 pSCROLLPLANE_ADVANCED[temp1].cel_current_animation = temp4;
 pSCROLLPLANE_ADVANCED[temp1].cel_current_frame     = temp5;
 pSCROLLPLANE_ADVANCED[temp1].cel_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup_SCROLLPLANE_ANIMATION_PALETTE2D(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_ADVANCED[temp1].palette_animate = temp2;
 pSCROLLPLANE_ADVANCED[temp1].palette_loop    = temp3;
 pSCROLLPLANE_ADVANCED[temp1].palette_current_animation = temp4;
 pSCROLLPLANE_ADVANCED[temp1].palette_current_frame     = temp5;
 pSCROLLPLANE_ADVANCED[temp1].palette_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup_SCROLLPLANE_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_ADVANCED[temp1].movement_animate = temp2;
 pSCROLLPLANE_ADVANCED[temp1].movement_loop    = temp3;
 pSCROLLPLANE_ADVANCED[temp1].movement_current_animation = temp4;
 pSCROLLPLANE_ADVANCED[temp1].movement_current_frame     = temp5;
 pSCROLLPLANE_ADVANCED[temp1].movement_timer[X] = temp6;
 pSCROLLPLANE_ADVANCED[temp1].movement_timer[Y] = temp7;
 pSCROLLPLANE_ADVANCED[temp1].movement_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup_SCROLLPLANE_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_ADVANCED[temp1].rotation_animate = temp2;
 pSCROLLPLANE_ADVANCED[temp1].rotation_loop    = temp3;
 pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation = temp4;
 pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame     = temp5;
 pSCROLLPLANE_ADVANCED[temp1].rotation_timer[X] = temp6;
 pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Y] = temp7;
 pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_setup_SCROLLPLANE_ANIMATION_SCALING(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
 */
 pSCROLLPLANE_ADVANCED[temp1].scaling_animate = temp2;
 pSCROLLPLANE_ADVANCED[temp1].scaling_loop    = temp3;
 pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation = temp4;
 pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame     = temp5;
 pSCROLLPLANE_ADVANCED[temp1].scaling_timer[X] = temp6;
 pSCROLLPLANE_ADVANCED[temp1].scaling_timer[Y] = temp7;
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int temp2 = 0;

 if(pSCROLLPLANE_ADVANCED[temp1].use_scrollplane == 0)
  slCurRpara(RA);
 if(pSCROLLPLANE_ADVANCED[temp1].use_scrollplane == 1)
  slCurRpara(RB);

 if(pSCROLLPLANE_ADVANCED[temp1].movement_current_animation != NONE)
 {
  if(pSCROLLPLANE_ADVANCED[temp1].movement_animate == YES)
  {
   if(pSCROLLPLANE_ADVANCED[temp1].movement_current_frame != pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSCROLLPLANE_ADVANCED[temp1].movement_timer[temp2] != pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].movement_target[pSCROLLPLANE_ADVANCED[temp1].movement_current_frame][temp2])
     {
      pSCROLLPLANE_ADVANCED[temp1].position[temp2] += pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].movement_increment[pSCROLLPLANE_ADVANCED[temp1].movement_current_frame][temp2];
      pSCROLLPLANE_ADVANCED[temp1].movement_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_ADVANCED[temp1].movement_timer[X] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].movement_target[pSCROLLPLANE_ADVANCED[temp1].movement_current_frame][X] && pSCROLLPLANE_ADVANCED[temp1].movement_timer[Y] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].movement_target[pSCROLLPLANE_ADVANCED[temp1].movement_current_frame][Y] && pSCROLLPLANE_ADVANCED[temp1].movement_timer[Z] == pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].movement_target[pSCROLLPLANE_ADVANCED[temp1].movement_current_frame][Z])
    {
     pSCROLLPLANE_ADVANCED[temp1].movement_current_frame++;
     pSCROLLPLANE_ADVANCED[temp1].movement_timer[X] = pSCROLLPLANE_ADVANCED[temp1].movement_timer[Y] = pSCROLLPLANE_ADVANCED[temp1].movement_timer[Z] = 0;
    }
   }
   if(pSCROLLPLANE_ADVANCED[temp1].movement_current_frame >= pSCROLLPLANE_ANIMATION_MOVEMENT[pSCROLLPLANE_ADVANCED[temp1].movement_current_animation].total_frames)
   {
    if(pSCROLLPLANE_ADVANCED[temp1].movement_loop == YES)
     pSCROLLPLANE_ADVANCED[temp1].movement_current_frame = 0;
    else
     pSCROLLPLANE_ADVANCED[temp1].movement_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation != NONE)
 {
  if(pSCROLLPLANE_ADVANCED[temp1].rotation_animate == YES)
  {
   if(pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame != pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSCROLLPLANE_ADVANCED[temp1].rotation_timer[temp2] != pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].rotation_target[pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame][temp2])
     {
      pSCROLLPLANE_ADVANCED[temp1].angle[temp2] += pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].rotation_increment[pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame][temp2];
      pSCROLLPLANE_ADVANCED[temp1].rotation_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_ADVANCED[temp1].rotation_timer[X] == pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].rotation_target[pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame][X] && pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Y] == pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].rotation_target[pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame][Y] && pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Z] == pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].rotation_target[pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame][Z])
    {
     pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame++;
     pSCROLLPLANE_ADVANCED[temp1].rotation_timer[X] = pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Y] = pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Z] = 0;
    }
   }
   if(pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame >= pSCROLLPLANE_ANIMATION_ROTATION[pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation].total_frames)
   {
    if(pSCROLLPLANE_ADVANCED[temp1].rotation_loop == YES)
     pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame = 0;
    else
     pSCROLLPLANE_ADVANCED[temp1].rotation_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation != NONE)
 {
  if(pSCROLLPLANE_ADVANCED[temp1].scaling_animate == YES)
  {
   if(pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame != pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 2; temp2++)
    {
     if(pSCROLLPLANE_ADVANCED[temp1].scaling_timer[temp2] != pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame][temp2])
     {
      pSCROLLPLANE_ADVANCED[temp1].scale[temp2] += pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation].scaling_increment[pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame][temp2];
      pSCROLLPLANE_ADVANCED[temp1].scaling_timer[temp2]++;
     }
    }
    if(pSCROLLPLANE_ADVANCED[temp1].scaling_timer[X] == pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame][X] && pSCROLLPLANE_ADVANCED[temp1].scaling_timer[Y] == pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation].scaling_target[pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame][Y])
    {
     pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame++;
     pSCROLLPLANE_ADVANCED[temp1].scaling_timer[X] = pSCROLLPLANE_ADVANCED[temp1].scaling_timer[Y] = 0;
    }
   }
   if(pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame >= pSCROLLPLANE_ANIMATION_SCALING[pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation].total_frames)
   {
    if(pSCROLLPLANE_ADVANCED[temp1].scaling_loop == YES)
     pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame = 0;
    else
     pSCROLLPLANE_ADVANCED[temp1].scaling_animate = NO;
   }
  }
 }

 if(pSCROLLPLANE_ADVANCED[temp1].map_current_animation != NONE)
 {
  if(pSCROLLPLANE_ADVANCED[temp1].map_animate == YES)
  {
   if(pSCROLLPLANE_ADVANCED[temp1].map_current_frame != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].total_frames)
   {
    if(pSCROLLPLANE_ADVANCED[temp1].map_timer != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map_target[pSCROLLPLANE_ADVANCED[temp1].map_current_frame])
    {
     pSCROLLPLANE_ADVANCED[temp1].map_timer++;
    }
    else
    {
     pSCROLLPLANE_ADVANCED[temp1].map_current_frame++;
     pSCROLLPLANE_ADVANCED[temp1].map_timer = 0;
     if(pSCROLLPLANE_ADVANCED[temp1].map_current_frame >= pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].total_frames)
     {
      if(pSCROLLPLANE_ADVANCED[temp1].map_loop == YES)
       pSCROLLPLANE_ADVANCED[temp1].map_current_frame = 0;
      else
       {pSCROLLPLANE_ADVANCED[temp1].map_current_frame--; pSCROLLPLANE_ADVANCED[temp1].map_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_map != pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame])
   {
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame]].map_size == 4096)
     e2_MAP2D_load_into_VIDEORAM_2x2(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame], pSCROLLPLANE_ADVANCED[temp1].scrollplane_map_memory_address, pSCROLLPLANE_ADVANCED[temp1].use_palette);
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame]].map_size == 2048)
     e2_MAP2D_load_into_VIDEORAM_2x1(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame], pSCROLLPLANE_ADVANCED[temp1].scrollplane_map_memory_address, pSCROLLPLANE_ADVANCED[temp1].use_palette);
    if(pMAP2D[pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame]].map_size == 1024)
     e2_MAP2D_load_into_VIDEORAM_1x1(pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame], pSCROLLPLANE_ADVANCED[temp1].scrollplane_map_memory_address, pSCROLLPLANE_ADVANCED[temp1].use_palette);
    pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_map = pSCROLLPLANE_ANIMATION_MAP2D[pSCROLLPLANE_ADVANCED[temp1].map_current_animation].map2D_number[pSCROLLPLANE_ADVANCED[temp1].map_current_frame];
   }
  }
 }

 if(pSCROLLPLANE_ADVANCED[temp1].cel_current_animation != NONE)
 {
  if(pSCROLLPLANE_ADVANCED[temp1].cel_animate == YES)
  {
   if(pSCROLLPLANE_ADVANCED[temp1].cel_current_frame != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_ADVANCED[temp1].cel_current_animation].total_frames)
   {
    if(pSCROLLPLANE_ADVANCED[temp1].cel_timer != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_ADVANCED[temp1].cel_current_animation].cel_target[pSCROLLPLANE_ADVANCED[temp1].cel_current_frame])
    {
     pSCROLLPLANE_ADVANCED[temp1].cel_timer++;
    }
    else
    {
     pSCROLLPLANE_ADVANCED[temp1].cel_current_frame++;
     pSCROLLPLANE_ADVANCED[temp1].cel_timer = 0;
     if(pSCROLLPLANE_ADVANCED[temp1].cel_current_frame >= pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_ADVANCED[temp1].cel_current_animation].total_frames)
     {
      if(pSCROLLPLANE_ADVANCED[temp1].cel_loop == YES)
       pSCROLLPLANE_ADVANCED[temp1].cel_current_frame = 0;
      else
       {pSCROLLPLANE_ADVANCED[temp1].cel_current_frame--; pSCROLLPLANE_ADVANCED[temp1].cel_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_cel != pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_ADVANCED[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_ADVANCED[temp1].cel_current_frame])
   {
    e2_CEL2D_load_into_VIDEORAM(pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_ADVANCED[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_ADVANCED[temp1].cel_current_frame], pSCROLLPLANE_ADVANCED[temp1].scrollplane_cel_memory_address);
    pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_cel = pSCROLLPLANE_ANIMATION_CEL2D[pSCROLLPLANE_ADVANCED[temp1].cel_current_animation].cel2D_number[pSCROLLPLANE_ADVANCED[temp1].cel_current_frame];
   }
  }
 }

 if(pSCROLLPLANE_ADVANCED[temp1].palette_current_animation != NONE)
 {
  if(pSCROLLPLANE_ADVANCED[temp1].palette_animate == YES)
  {
   if(pSCROLLPLANE_ADVANCED[temp1].palette_current_frame != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_ADVANCED[temp1].palette_current_animation].total_frames)
   {
    if(pSCROLLPLANE_ADVANCED[temp1].palette_timer != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_ADVANCED[temp1].palette_current_animation].palette_target[pSCROLLPLANE_ADVANCED[temp1].palette_current_frame])
    {
     pSCROLLPLANE_ADVANCED[temp1].palette_timer++;
    }
    else
    {
     pSCROLLPLANE_ADVANCED[temp1].palette_current_frame++;
     pSCROLLPLANE_ADVANCED[temp1].palette_timer = 0;
     if(pSCROLLPLANE_ADVANCED[temp1].palette_current_frame >= pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_ADVANCED[temp1].palette_current_animation].total_frames)
     {
      if(pSCROLLPLANE_ADVANCED[temp1].palette_loop == YES)
       pSCROLLPLANE_ADVANCED[temp1].palette_current_frame = 0;
      else
       {pSCROLLPLANE_ADVANCED[temp1].palette_current_frame--; pSCROLLPLANE_ADVANCED[temp1].palette_animate = NO;}
     }
    }
   }
   if(pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_palette != pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_ADVANCED[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_ADVANCED[temp1].palette_current_frame])
   {
    e2_PALETTE2D_load_into_COLORRAM(pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_ADVANCED[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_ADVANCED[temp1].palette_current_frame], pSCROLLPLANE_ADVANCED[temp1].scrollplane_palette_memory_address, 256);
    pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_palette = pSCROLLPLANE_ANIMATION_PALETTE2D[pSCROLLPLANE_ADVANCED[temp1].palette_current_animation].palette2D_number[pSCROLLPLANE_ADVANCED[temp1].palette_current_frame];
   }
  }
 }

 slUnitMatrix(CURRENT);
 slDispCenterR(pSCROLLPLANE_ADVANCED[temp1].rotation_position[X], pSCROLLPLANE_ADVANCED[temp1].rotation_position[Y]);
 slTranslate(pSCROLLPLANE_ADVANCED[temp1].position[X], pSCROLLPLANE_ADVANCED[temp1].position[Y], pSCROLLPLANE_ADVANCED[temp1].position[Z]);
 slRotX(pSCROLLPLANE_ADVANCED[temp1].angle[X]);
 slRotY(pSCROLLPLANE_ADVANCED[temp1].angle[Y]);
 slRotZ(pSCROLLPLANE_ADVANCED[temp1].angle[Z]);
 slZoomR(pSCROLLPLANE_ADVANCED[temp1].scale[X], pSCROLLPLANE_ADVANCED[temp1].scale[Y]);
 slScrMatSet();
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SCROLLPLANE_ADVANCED_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].use_scrollplane = e2_CDROM_read_number(1);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].map_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].map_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].map_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].map_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].map_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].cel_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].cel_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].cel_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].cel_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].cel_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].palette_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].palette_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].palette_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].palette_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].palette_timer             = e2_CDROM_read_number(4);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_timer[Y]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].movement_timer[Z]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_timer[Y]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_timer[Z]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scaling_animate           = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scaling_loop              = e2_CDROM_read_number(1);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scaling_current_animation = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scaling_current_frame     = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scaling_timer[X]          = e2_CDROM_read_number(4);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scaling_timer[Y]          = e2_CDROM_read_number(4);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].angle[X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].angle[Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].angle[Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scale[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scale[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].current_scrollplane_map     = e2_CDROM_read_number(9);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].current_scrollplane_cel     = e2_CDROM_read_number(9);
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].current_scrollplane_palette = e2_CDROM_read_number(9);

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scrollplane_map_memory_address     = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scrollplane_cel_memory_address     = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].scrollplane_palette_memory_address = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_parameter_memory_address  = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));
  pSCROLLPLANE_ADVANCED[sprite_number + temp1].rotation_table_memory_address      = (e2_CDROM_read_number(8) * e2_CDROM_read_number(4));

  pSCROLLPLANE_ADVANCED[sprite_number + temp1].use_palette = e2_CDROM_read_number(1);
 }
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].use_scrollplane, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].map_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].map_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].map_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].map_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].map_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].cel_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].cel_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].cel_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].cel_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].cel_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].palette_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].palette_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].palette_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].palette_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].palette_timer, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].movement_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].angle[X], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].angle[Y], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].angle[Z], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scale[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scale[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_map, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_cel, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_palette, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scrollplane_map_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scrollplane_cel_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].scrollplane_palette_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_parameter_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_table_memory_address, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSCROLLPLANE_ADVANCED[temp1].use_palette, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 return;
}
// --------------------------------------------------
e2_SCROLLPLANE_ADVANCED_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].use_scrollplane, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].map_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].map_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].map_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].map_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].map_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].cel_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].cel_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].cel_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].cel_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].cel_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].palette_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].palette_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].palette_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].palette_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].palette_timer, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].movement_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scaling_timer[Y], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].angle[X], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].angle[Y], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].angle[Z], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scale[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scale[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_map, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_cel, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].current_scrollplane_palette, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scrollplane_map_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scrollplane_cel_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].scrollplane_palette_memory_address, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_parameter_memory_address, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].rotation_table_memory_address, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSCROLLPLANE_ADVANCED[temp1].use_palette, sizeof(int));
 temp2 += sizeof(int);
 return;
}
// ==================================================
//	[LIGHT_SOURCE_ANIMATION_MOVEMENT] :  <<LIGHT_SOURCE_ANIMATION_MOVEMENT>>
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pLIGHT_SOURCE_ANIMATION_MOVEMENT = (LIGHT_SOURCE_ANIMATION_MOVEMENT*)realloc(pLIGHT_SOURCE_ANIMATION_MOVEMENT, temp2 * sizeof(LIGHT_SOURCE_ANIMATION_MOVEMENT));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp3].movement_target);
   free(pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp3].movement_increment);
  }
  pLIGHT_SOURCE_ANIMATION_MOVEMENT = (LIGHT_SOURCE_ANIMATION_MOVEMENT*)realloc(pLIGHT_SOURCE_ANIMATION_MOVEMENT, temp2 * sizeof(LIGHT_SOURCE_ANIMATION_MOVEMENT));
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames = temp2;
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target = (int(*)[3])realloc(pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target, temp2 * sizeof(int * [3]));
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment = (FIXED(*)[3])realloc(pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment, temp2 * sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_setup(int temp1, int temp2, int temp3, int temp4, int temp5, FIXED temp6, FIXED temp7, FIXED temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = temp3;
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = temp4;
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = temp5;
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = temp6;
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = temp7;
 pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = temp8;
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_setup_interpolated(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, FIXED temp7, FIXED temp8, FIXED temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting position.
    temp5 = The Y starting position.
    temp6 = The Z starting position.
    temp7 = The X desired ending position.
    temp8 = The Y desired ending position.
    temp9 = The Z desired ending position.
 */
 int temp10 = 0;
 FIXED chk_val[XYZ] = {(temp7 - temp4), (temp8 - temp5), (temp9 - temp6)};

 for(temp10 = 0; temp10 != 3; temp10++) if(chk_val[temp10] <= 0) chk_val[temp10] *= -1;

 if(chk_val[X] >= chk_val[Y] && chk_val[X] >= chk_val[Z])
 {
  if(chk_val[X] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = toFIXED(temp3); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = (temp7 - temp4) / toFIXED(temp3);}
  if(chk_val[Y] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp7 - temp4) / toFIXED(temp3)); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
  if(chk_val[Z] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp7 - temp4) / toFIXED(temp3)); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
 }

 if(chk_val[Y] >= chk_val[X] && chk_val[Y] >= chk_val[Z])
 {
  if(chk_val[Y] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = toFIXED(temp3); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = (temp8 - temp5) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp8 - temp5) / toFIXED(temp3)); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
  if(chk_val[Z] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp8 - temp5) / toFIXED(temp3)); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
 }

 if(chk_val[Z] >= chk_val[X] && chk_val[Z] >= chk_val[Y])
 {
  if(chk_val[Z] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = toFIXED(temp3); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = (temp9 - temp6) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp9 - temp6) / toFIXED(temp3)); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
  if(chk_val[Y] >= toFIXED(0.0)){pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp9 - temp6) / toFIXED(temp3)); pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
 }

 for(temp10 = 0; temp10 != 3; temp10++) if(pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] <= 0)
 {
  pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] *= -1;
  pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][temp10] *= -1;
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][X] = e2_CDROM_read_number(4);
   pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Y] = e2_CDROM_read_number(4);
   pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Z] = e2_CDROM_read_number(4);
   pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_MOVEMENT_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return;
}
// ==================================================
//	[LIGHT_SOURCE_ANIMATION_ROTATION] :  <<LIGHT_SOURCE_ANIMATION_ROTATION>>
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pLIGHT_SOURCE_ANIMATION_ROTATION = (LIGHT_SOURCE_ANIMATION_ROTATION*)realloc(pLIGHT_SOURCE_ANIMATION_ROTATION, temp2 * sizeof(LIGHT_SOURCE_ANIMATION_ROTATION));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pLIGHT_SOURCE_ANIMATION_ROTATION[temp3].rotation_target);
   free(pLIGHT_SOURCE_ANIMATION_ROTATION[temp3].rotation_increment);
   free(pLIGHT_SOURCE_ANIMATION_ROTATION[temp3].rotation_final_position);
  }
  pLIGHT_SOURCE_ANIMATION_ROTATION = (LIGHT_SOURCE_ANIMATION_ROTATION*)realloc(pLIGHT_SOURCE_ANIMATION_ROTATION, temp2 * sizeof(LIGHT_SOURCE_ANIMATION_ROTATION));
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].total_frames = temp2;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target = (int(*)[3])realloc(pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target, temp2 * sizeof(int * [3]));
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment = (ANGLE(*)[3])realloc(pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment, temp2 * sizeof(ANGLE * [3]));
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position = (ANGLE(*)[4])realloc(pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position, temp2 * sizeof(ANGLE * [4]));
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_setup(int temp1, int temp2, int temp3, int temp4, int temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][X] = temp3;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Y] = temp4;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Z] = temp5;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = temp6;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = temp7;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = temp8;

 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][X] = DEGtoANG(temp3 * temp6);
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Y] = DEGtoANG(temp4 * temp7);
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = DEGtoANG(temp5 * temp8);
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][3] = DEGtoANG(NO);
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_setup_interpolated(int temp1, int temp2, int temp3, ANGLE temp4, ANGLE temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8, ANGLE temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting angle.
    temp5 = The Y starting angle.
    temp6 = The Z starting angle.
    temp7 = The X desired ending angle.
    temp8 = The Y desired ending angle.
    temp9 = The Z desired ending angle.
 */
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][X] = temp3;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Y] = temp3;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Z] = temp3;

 if(temp4 >= temp7)
  pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = ((temp4 - temp7) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else
  pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = ((temp7 - temp4) / DEGtoANG(temp3));

 if(temp5 >= temp8)
  pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = ((temp5 - temp8) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else
  pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = ((temp8 - temp5) / DEGtoANG(temp3));

 if(temp6 >= temp9)
  pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = ((temp6 - temp9) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else                                                                                  
  pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = ((temp9 - temp6) / DEGtoANG(temp3));

 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][X] = temp7;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Y] = temp8;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = temp9;
 pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][3] = DEGtoANG(YES);
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_LIGHT_SOURCE_ANIMATION_ROTATION_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_LIGHT_SOURCE_ANIMATION_ROTATION_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][X] = e2_CDROM_read_number(4);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Y] = e2_CDROM_read_number(4);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Z] = e2_CDROM_read_number(4);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pLIGHT_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][3] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);

  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][3], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_ANIMATION_ROTATION_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));

  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][3], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
 }
 return;
}
// ==================================================
//	[LIGHT_SOURCE]       :  <<LIGHT_SOURCE>>
// --------------------------------------------------
e2_LIGHT_SOURCE_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pLIGHT_SOURCE = (LIGHT_SOURCE*)realloc(pLIGHT_SOURCE, temp1 * sizeof(LIGHT_SOURCE));
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8, FIXED temp9, FIXED temp10, FIXED temp11, int temp12, FIXED temp13, FIXED temp14, FIXED temp15, FIXED temp16, FIXED temp17, FIXED temp18)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The X angle of the sprite.
    temp7  = The Y angle of the sprite.
    temp8  = The Z angle of the sprite.
    temp9  = The X light vector component of the sprite.
    temp10 = The Y light vector component of the sprite.
    temp11 = The Z light vector component of the sprite.
    temp12 = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp13 = The left clipping boundary.
    temp14 = The right clipping boundary.
    temp15 = The top clipping boundary.
    temp16 = The bottom clipping boundary.
    temp17 = The front clipping boundary.
    temp18 = The back clipping boundary.
 */
 pLIGHT_SOURCE[temp1].show_sprite = temp2;

 pLIGHT_SOURCE[temp1].position[X] = temp3;
 pLIGHT_SOURCE[temp1].position[Y] = temp4;
 pLIGHT_SOURCE[temp1].position[Z] = temp5;

 pLIGHT_SOURCE[temp1].angle[X] = temp6;
 pLIGHT_SOURCE[temp1].angle[Y] = temp7;
 pLIGHT_SOURCE[temp1].angle[Z] = temp8;

 pLIGHT_SOURCE[temp1].light_vector[X] = temp9;
 pLIGHT_SOURCE[temp1].light_vector[Y] = temp10;
 pLIGHT_SOURCE[temp1].light_vector[Z] = temp11;

 pLIGHT_SOURCE[temp1].clipping_check = temp12;
 pLIGHT_SOURCE[temp1].clipping_left_boundary   = temp13;
 pLIGHT_SOURCE[temp1].clipping_right_boundary  = temp14;
 pLIGHT_SOURCE[temp1].clipping_top_boundary    = temp15;
 pLIGHT_SOURCE[temp1].clipping_bottom_boundary = temp16;
 pLIGHT_SOURCE[temp1].clipping_front_boundary  = temp17;
 pLIGHT_SOURCE[temp1].clipping_back_boundary   = temp18;
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_setup_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pLIGHT_SOURCE[temp1].movement_animate = temp2;
 pLIGHT_SOURCE[temp1].movement_loop = temp3;
 pLIGHT_SOURCE[temp1].movement_current_animation = temp4;
 pLIGHT_SOURCE[temp1].movement_current_frame = temp5;
 pLIGHT_SOURCE[temp1].movement_timer[X] = temp6;
 pLIGHT_SOURCE[temp1].movement_timer[Y] = temp7;
 pLIGHT_SOURCE[temp1].movement_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_setup_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pLIGHT_SOURCE[temp1].rotation_animate = temp2;
 pLIGHT_SOURCE[temp1].rotation_loop = temp3;
 pLIGHT_SOURCE[temp1].rotation_current_animation = temp4;
 pLIGHT_SOURCE[temp1].rotation_current_frame = temp5;
 pLIGHT_SOURCE[temp1].rotation_timer[X] = temp6;
 pLIGHT_SOURCE[temp1].rotation_timer[Y] = temp7;
 pLIGHT_SOURCE[temp1].rotation_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int temp2 = 0;

 if(pLIGHT_SOURCE[temp1].movement_current_animation != NONE)
 {
  if(pLIGHT_SOURCE[temp1].movement_animate == YES)
  {
   if(pLIGHT_SOURCE[temp1].movement_current_frame != pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pLIGHT_SOURCE[temp1].movement_timer[temp2] != pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].movement_target[pLIGHT_SOURCE[temp1].movement_current_frame][temp2])
     {
      pLIGHT_SOURCE[temp1].position[temp2] += pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].movement_increment[pLIGHT_SOURCE[temp1].movement_current_frame][temp2];
      pLIGHT_SOURCE[temp1].movement_timer[temp2]++;
     }
    }
    if(pLIGHT_SOURCE[temp1].movement_timer[X] == pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].movement_target[pLIGHT_SOURCE[temp1].movement_current_frame][X] && pLIGHT_SOURCE[temp1].movement_timer[Y] == pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].movement_target[pLIGHT_SOURCE[temp1].movement_current_frame][Y] && pLIGHT_SOURCE[temp1].movement_timer[Z] == pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].movement_target[pLIGHT_SOURCE[temp1].movement_current_frame][Z])
    {
     pLIGHT_SOURCE[temp1].movement_current_frame++;
     pLIGHT_SOURCE[temp1].movement_timer[X] = pLIGHT_SOURCE[temp1].movement_timer[Y] = pLIGHT_SOURCE[temp1].movement_timer[Z] = 0;
    }
   }
   if(pLIGHT_SOURCE[temp1].movement_current_frame >= pLIGHT_SOURCE_ANIMATION_MOVEMENT[pLIGHT_SOURCE[temp1].movement_current_animation].total_frames)
   {
    if(pLIGHT_SOURCE[temp1].movement_loop == YES)
     pLIGHT_SOURCE[temp1].movement_current_frame = 0;
    else
     pLIGHT_SOURCE[temp1].movement_animate = NO;
   }
  }
 }

 if(pLIGHT_SOURCE[temp1].rotation_current_animation != NONE)
 {
  if(pLIGHT_SOURCE[temp1].rotation_animate == YES)
  {
   if(pLIGHT_SOURCE[temp1].rotation_current_frame != pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pLIGHT_SOURCE[temp1].rotation_timer[temp2] != pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_target[pLIGHT_SOURCE[temp1].rotation_current_frame][temp2])
     {
      pLIGHT_SOURCE[temp1].angle[temp2] += pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_increment[pLIGHT_SOURCE[temp1].rotation_current_frame][temp2];
      pLIGHT_SOURCE[temp1].rotation_timer[temp2]++;
     }
    }
    if(pLIGHT_SOURCE[temp1].rotation_timer[X] == pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_target[pLIGHT_SOURCE[temp1].rotation_current_frame][X] && pLIGHT_SOURCE[temp1].rotation_timer[Y] == pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_target[pLIGHT_SOURCE[temp1].rotation_current_frame][Y] && pLIGHT_SOURCE[temp1].rotation_timer[Z] == pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_target[pLIGHT_SOURCE[temp1].rotation_current_frame][Z])
    {
     if(pLIGHT_SOURCE[temp1].angle[X] = pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_final_position[pLIGHT_SOURCE[temp1].rotation_current_frame][3] == DEGtoANG(YES))
     {
      pLIGHT_SOURCE[temp1].angle[X] = pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_final_position[pLIGHT_SOURCE[temp1].rotation_current_frame][X];
      pLIGHT_SOURCE[temp1].angle[Y] = pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_final_position[pLIGHT_SOURCE[temp1].rotation_current_frame][Y];
      pLIGHT_SOURCE[temp1].angle[Z] = pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].rotation_final_position[pLIGHT_SOURCE[temp1].rotation_current_frame][Z];
     }
     pLIGHT_SOURCE[temp1].rotation_current_frame++;
     pLIGHT_SOURCE[temp1].rotation_timer[X] = pLIGHT_SOURCE[temp1].rotation_timer[Y] = pLIGHT_SOURCE[temp1].rotation_timer[Z] = 0;
    }
   }
   if(pLIGHT_SOURCE[temp1].rotation_current_frame >= pLIGHT_SOURCE_ANIMATION_ROTATION[pLIGHT_SOURCE[temp1].rotation_current_animation].total_frames)
   {
    if(pLIGHT_SOURCE[temp1].rotation_loop == YES)
     pLIGHT_SOURCE[temp1].rotation_current_frame = 0;
    else
     pLIGHT_SOURCE[temp1].rotation_animate = NO;
   }
  }
 }

 if(pLIGHT_SOURCE[temp1].clipping_check == YES && pLIGHT_SOURCE[temp1].position[X] < pLIGHT_SOURCE[temp1].clipping_left_boundary  || pLIGHT_SOURCE[temp1].clipping_check == YES && pLIGHT_SOURCE[temp1].position[X] > pLIGHT_SOURCE[temp1].clipping_right_boundary  ||
    pLIGHT_SOURCE[temp1].clipping_check == YES && pLIGHT_SOURCE[temp1].position[Y] < pLIGHT_SOURCE[temp1].clipping_top_boundary   || pLIGHT_SOURCE[temp1].clipping_check == YES && pLIGHT_SOURCE[temp1].position[Y] > pLIGHT_SOURCE[temp1].clipping_bottom_boundary ||
    pLIGHT_SOURCE[temp1].clipping_check == YES && pLIGHT_SOURCE[temp1].position[Z] < pLIGHT_SOURCE[temp1].clipping_front_boundary || pLIGHT_SOURCE[temp1].clipping_check == YES && pLIGHT_SOURCE[temp1].position[Z] > pLIGHT_SOURCE[temp1].clipping_back_boundary);
 else
 {
  if(pLIGHT_SOURCE[temp1].show_sprite)
  {
   slPushUnitMatrix();
   {
    slRotX(pLIGHT_SOURCE[temp1].angle[X]);
    slRotY(pLIGHT_SOURCE[temp1].angle[Y]);
    slRotZ(pLIGHT_SOURCE[temp1].angle[Z]);
    slCalcPoint(pLIGHT_SOURCE[temp1].position[X], pLIGHT_SOURCE[temp1].position[Y], pLIGHT_SOURCE[temp1].position[Z], pLIGHT_SOURCE[temp1].light_vector);
   }
   slPopMatrix();
   slLight(pLIGHT_SOURCE[temp1].light_vector);
  }
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_LIGHT_SOURCE_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pLIGHT_SOURCE[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);

  pLIGHT_SOURCE[sprite_number + temp1].movement_animate = e2_CDROM_read_number(1);
  pLIGHT_SOURCE[sprite_number + temp1].movement_loop = e2_CDROM_read_number(1);
  pLIGHT_SOURCE[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].movement_current_frame = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].movement_timer[X] = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].movement_timer[Y] = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].movement_timer[Z] = e2_CDROM_read_number(4);

  pLIGHT_SOURCE[sprite_number + temp1].rotation_animate = e2_CDROM_read_number(1);
  pLIGHT_SOURCE[sprite_number + temp1].rotation_loop = e2_CDROM_read_number(1);
  pLIGHT_SOURCE[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].rotation_current_frame = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].rotation_timer[X] = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].rotation_timer[Y] = e2_CDROM_read_number(4);
  pLIGHT_SOURCE[sprite_number + temp1].rotation_timer[Z] = e2_CDROM_read_number(4);

  pLIGHT_SOURCE[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pLIGHT_SOURCE[sprite_number + temp1].angle[X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].angle[Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].angle[Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);

  pLIGHT_SOURCE[sprite_number + temp1].light_vector[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].light_vector[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].light_vector[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pLIGHT_SOURCE[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pLIGHT_SOURCE[sprite_number + temp1].clipping_left_boundary   = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].clipping_right_boundary  = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].clipping_top_boundary    = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].clipping_front_boundary  = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pLIGHT_SOURCE[sprite_number + temp1].clipping_back_boundary   = toFIXED(e2_CDROM_read_number(9) * 0.0001);
 }
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].movement_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].rotation_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pLIGHT_SOURCE[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pLIGHT_SOURCE[temp1].angle[X], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].angle[Y], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].angle[Z], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));

 slDMACopy((void*)&pLIGHT_SOURCE[temp1].light_vector[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].light_vector[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].light_vector[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pLIGHT_SOURCE[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 return;
}
// --------------------------------------------------
e2_LIGHT_SOURCE_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].movement_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].rotation_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].angle[X], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].angle[Y], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].angle[Z], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].light_vector[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].light_vector[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].light_vector[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pLIGHT_SOURCE[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return;
}
// ==================================================
//	[CAMERA_SOURCE_ANIMATION_MOVEMENT] :  <<CAMERA_SOURCE_ANIMATION_MOVEMENT>>
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pCAMERA_SOURCE_ANIMATION_MOVEMENT = (CAMERA_SOURCE_ANIMATION_MOVEMENT*)realloc(pCAMERA_SOURCE_ANIMATION_MOVEMENT, temp2 * sizeof(CAMERA_SOURCE_ANIMATION_MOVEMENT));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp3].movement_target);
   free(pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp3].movement_increment);
  }
  pCAMERA_SOURCE_ANIMATION_MOVEMENT = (CAMERA_SOURCE_ANIMATION_MOVEMENT*)realloc(pCAMERA_SOURCE_ANIMATION_MOVEMENT, temp2 * sizeof(CAMERA_SOURCE_ANIMATION_MOVEMENT));
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames = temp2;
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target = (int(*)[3])realloc(pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target, temp2 * sizeof(int * [3]));
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment = (FIXED(*)[3])realloc(pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment, temp2 * sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_setup(int temp1, int temp2, int temp3, int temp4, int temp5, FIXED temp6, FIXED temp7, FIXED temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = temp3;
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = temp4;
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = temp5;
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = temp6;
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = temp7;
 pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = temp8;
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_setup_interpolated(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, FIXED temp7, FIXED temp8, FIXED temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting position.
    temp5 = The Y starting position.
    temp6 = The Z starting position.
    temp7 = The X desired ending position.
    temp8 = The Y desired ending position.
    temp9 = The Z desired ending position.
 */
 int temp10 = 0;
 FIXED chk_val[XYZ] = {(temp7 - temp4), (temp8 - temp5), (temp9 - temp6)};

 for(temp10 = 0; temp10 != 3; temp10++) if(chk_val[temp10] <= 0) chk_val[temp10] *= -1;

 if(chk_val[X] >= chk_val[Y] && chk_val[X] >= chk_val[Z])
 {
  if(chk_val[X] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = toFIXED(temp3); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = (temp7 - temp4) / toFIXED(temp3);}
  if(chk_val[Y] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp7 - temp4) / toFIXED(temp3)); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
  if(chk_val[Z] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp7 - temp4) / toFIXED(temp3)); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
 }

 if(chk_val[Y] >= chk_val[X] && chk_val[Y] >= chk_val[Z])
 {
  if(chk_val[Y] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = toFIXED(temp3); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = (temp8 - temp5) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp8 - temp5) / toFIXED(temp3)); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
  if(chk_val[Z] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp8 - temp5) / toFIXED(temp3)); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
 }

 if(chk_val[Z] >= chk_val[X] && chk_val[Z] >= chk_val[Y])
 {
  if(chk_val[Z] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = toFIXED(temp3); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = (temp9 - temp6) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp9 - temp6) / toFIXED(temp3)); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
  if(chk_val[Y] >= toFIXED(0.0)){pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp9 - temp6) / toFIXED(temp3)); pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
 }

 for(temp10 = 0; temp10 != 3; temp10++) if(pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] <= 0)
 {
  pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] *= -1;
  pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][temp10] *= -1;
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][X] = e2_CDROM_read_number(4);
   pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Y] = e2_CDROM_read_number(4);
   pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Z] = e2_CDROM_read_number(4);
   pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_MOVEMENT_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return;
}
// ==================================================
//	[CAMERA_SOURCE_ANIMATION_ROTATION] :  <<CAMERA_SOURCE_ANIMATION_ROTATION>>
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pCAMERA_SOURCE_ANIMATION_ROTATION = (CAMERA_SOURCE_ANIMATION_ROTATION*)realloc(pCAMERA_SOURCE_ANIMATION_ROTATION, temp2 * sizeof(CAMERA_SOURCE_ANIMATION_ROTATION));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pCAMERA_SOURCE_ANIMATION_ROTATION[temp3].rotation_target);
   free(pCAMERA_SOURCE_ANIMATION_ROTATION[temp3].rotation_increment);
   free(pCAMERA_SOURCE_ANIMATION_ROTATION[temp3].rotation_final_position);
  }
  pCAMERA_SOURCE_ANIMATION_ROTATION = (CAMERA_SOURCE_ANIMATION_ROTATION*)realloc(pCAMERA_SOURCE_ANIMATION_ROTATION, temp2 * sizeof(CAMERA_SOURCE_ANIMATION_ROTATION));
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].total_frames = temp2;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target = (int(*)[3])realloc(pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target, temp2 * sizeof(int * [3]));
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment = (ANGLE(*)[3])realloc(pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment, temp2 * sizeof(ANGLE * [3]));
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position = (ANGLE(*)[4])realloc(pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position, temp2 * sizeof(ANGLE * [4]));
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_setup(int temp1, int temp2, int temp3, int temp4, int temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][X] = temp3;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Y] = temp4;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Z] = temp5;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = temp6;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = temp7;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = temp8;

 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][X] = DEGtoANG(temp3 * temp6);
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Y] = DEGtoANG(temp4 * temp7);
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = DEGtoANG(temp5 * temp8);
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = DEGtoANG(NO);
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_setup_interpolated(int temp1, int temp2, int temp3, ANGLE temp4, ANGLE temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8, ANGLE temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting angle.
    temp5 = The Y starting angle.
    temp6 = The Z starting angle.
    temp7 = The X desired ending angle.
    temp8 = The Y desired ending angle.
    temp9 = The Z desired ending angle.
 */
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][X] = temp3;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Y] = temp3;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp2][Z] = temp3;

 if(temp4 >= temp7)
  pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = ((temp4 - temp7) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else
  pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = ((temp7 - temp4) / DEGtoANG(temp3));

 if(temp5 >= temp8)
  pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = ((temp5 - temp8) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else
  pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = ((temp8 - temp5) / DEGtoANG(temp3));

 if(temp6 >= temp9)
  pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = ((temp6 - temp9) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else                                                                                  
  pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = ((temp9 - temp6) / DEGtoANG(temp3));

 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][X] = temp7;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Y] = temp8;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = temp9;
 pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][3] = DEGtoANG(YES);
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_CAMERA_SOURCE_ANIMATION_ROTATION_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_CAMERA_SOURCE_ANIMATION_ROTATION_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][X] = e2_CDROM_read_number(4);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Y] = e2_CDROM_read_number(4);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Z] = e2_CDROM_read_number(4);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pCAMERA_SOURCE_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);

  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_ANIMATION_ROTATION_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));

  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
 }
 return;
}
// ==================================================
//	[CAMERA_SOURCE]      :  <<CAMERA_SOURCE>>
// --------------------------------------------------
e2_CAMERA_SOURCE_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pCAMERA_SOURCE = (CAMERA_SOURCE*)realloc(pCAMERA_SOURCE, temp1 * sizeof(CAMERA_SOURCE));
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_setup(int temp1, int temp2, FIXED temp3, FIXED temp4, FIXED temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8, FIXED temp9, FIXED temp10, FIXED temp11, int temp12, FIXED temp13, FIXED temp14, FIXED temp15, FIXED temp16, FIXED temp17, FIXED temp18)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The X position of the sprite.
    temp4  = The Y position of the sprite.
    temp5  = The Z position of the sprite.
    temp6  = The X angle of the sprite.
    temp7  = The Y angle of the sprite.
    temp8  = The Z angle of the sprite.
    temp9  = The X target of the sprite.
    temp10 = The Y target of the sprite.
    temp11 = The Z target of the sprite.
    temp12 = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp13 = The left clipping boundary.
    temp14 = The right clipping boundary.
    temp15 = The top clipping boundary.
    temp16 = The bottom clipping boundary.
    temp17 = The front clipping boundary.
    temp18 = The back clipping boundary.
 */
 pCAMERA_SOURCE[temp1].show_sprite = temp2;

 pCAMERA_SOURCE[temp1].position[X] = temp3;
 pCAMERA_SOURCE[temp1].position[Y] = temp4;
 pCAMERA_SOURCE[temp1].position[Z] = temp5;

 pCAMERA_SOURCE[temp1].angle[X] = temp6;
 pCAMERA_SOURCE[temp1].angle[Y] = temp7;
 pCAMERA_SOURCE[temp1].angle[Z] = temp8;

 pCAMERA_SOURCE[temp1].camera_target[X] = temp9;
 pCAMERA_SOURCE[temp1].camera_target[Y] = temp10;
 pCAMERA_SOURCE[temp1].camera_target[Z] = temp11;

 pCAMERA_SOURCE[temp1].clipping_check = temp12;
 pCAMERA_SOURCE[temp1].clipping_left_boundary   = temp13;
 pCAMERA_SOURCE[temp1].clipping_right_boundary  = temp14;
 pCAMERA_SOURCE[temp1].clipping_top_boundary    = temp15;
 pCAMERA_SOURCE[temp1].clipping_bottom_boundary = temp16;
 pCAMERA_SOURCE[temp1].clipping_front_boundary  = temp17;
 pCAMERA_SOURCE[temp1].clipping_back_boundary   = temp18;
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_setup_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pCAMERA_SOURCE[temp1].movement_animate = temp2;
 pCAMERA_SOURCE[temp1].movement_loop = temp3;
 pCAMERA_SOURCE[temp1].movement_current_animation = temp4;
 pCAMERA_SOURCE[temp1].movement_current_frame = temp5;
 pCAMERA_SOURCE[temp1].movement_timer[X] = temp6;
 pCAMERA_SOURCE[temp1].movement_timer[Y] = temp7;
 pCAMERA_SOURCE[temp1].movement_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_setup_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pCAMERA_SOURCE[temp1].rotation_animate = temp2;
 pCAMERA_SOURCE[temp1].rotation_loop = temp3;
 pCAMERA_SOURCE[temp1].rotation_current_animation = temp4;
 pCAMERA_SOURCE[temp1].rotation_current_frame = temp5;
 pCAMERA_SOURCE[temp1].rotation_timer[X] = temp6;
 pCAMERA_SOURCE[temp1].rotation_timer[Y] = temp7;
 pCAMERA_SOURCE[temp1].rotation_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_position(int temp1, FIXED temp2, FIXED temp3, FIXED temp4)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = The desired X position.
    temp3 = The desired Y position.
    temp4 = The desired Z position.
 */
 pCAMERA_SOURCE[temp1].position[X] = temp2;
 pCAMERA_SOURCE[temp1].position[Y] = temp3;
 pCAMERA_SOURCE[temp1].position[Z] = temp4;
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_target(int temp1, FIXED temp2, FIXED temp3, FIXED temp4)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = The X target position of the sprite.
    temp3 = The Y target position of the sprite.
    temp4 = The Z target position of the sprite.
 */
 pCAMERA_SOURCE[temp1].camera_target[X] = temp2;
 pCAMERA_SOURCE[temp1].camera_target[Y] = temp3;
 pCAMERA_SOURCE[temp1].camera_target[Z] = temp4;
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int temp2;

 if(pCAMERA_SOURCE[temp1].movement_current_animation != NONE)
 {
  if(pCAMERA_SOURCE[temp1].movement_animate == YES)
  {
   if(pCAMERA_SOURCE[temp1].movement_current_frame != pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pCAMERA_SOURCE[temp1].movement_timer[temp2] != pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].movement_target[pCAMERA_SOURCE[temp1].movement_current_frame][temp2])
     {
      pCAMERA_SOURCE[temp1].position[temp2] += pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].movement_increment[pCAMERA_SOURCE[temp1].movement_current_frame][temp2];
      pCAMERA_SOURCE[temp1].movement_timer[temp2]++;
     }
    }
    if(pCAMERA_SOURCE[temp1].movement_timer[X] == pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].movement_target[pCAMERA_SOURCE[temp1].movement_current_frame][X] && pCAMERA_SOURCE[temp1].movement_timer[Y] == pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].movement_target[pCAMERA_SOURCE[temp1].movement_current_frame][Y] && pCAMERA_SOURCE[temp1].movement_timer[Z] == pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].movement_target[pCAMERA_SOURCE[temp1].movement_current_frame][Z])
    {
     pCAMERA_SOURCE[temp1].movement_current_frame++;
     pCAMERA_SOURCE[temp1].movement_timer[X] = pCAMERA_SOURCE[temp1].movement_timer[Y] = pCAMERA_SOURCE[temp1].movement_timer[Z] = 0;
    }
   }
   if(pCAMERA_SOURCE[temp1].movement_current_frame >= pCAMERA_SOURCE_ANIMATION_MOVEMENT[pCAMERA_SOURCE[temp1].movement_current_animation].total_frames)
   {
    if(pCAMERA_SOURCE[temp1].movement_loop == YES)
     pCAMERA_SOURCE[temp1].movement_current_frame = 0;
    else
     pCAMERA_SOURCE[temp1].movement_animate = NO;
   }
  }
 }

 if(pCAMERA_SOURCE[temp1].rotation_current_animation != NONE)
 {
  if(pCAMERA_SOURCE[temp1].rotation_animate == YES)
  {
   if(pCAMERA_SOURCE[temp1].rotation_current_frame != pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pCAMERA_SOURCE[temp1].rotation_timer[temp2] != pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].rotation_target[pCAMERA_SOURCE[temp1].rotation_current_frame][temp2])
     {
      pCAMERA_SOURCE[temp1].angle[temp2] += pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].rotation_increment[pCAMERA_SOURCE[temp1].rotation_current_frame][temp2];
      pCAMERA_SOURCE[temp1].rotation_timer[temp2]++;
     }
    }
    if(pCAMERA_SOURCE[temp1].rotation_timer[X] == pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].rotation_target[pCAMERA_SOURCE[temp1].rotation_current_frame][X] && pCAMERA_SOURCE[temp1].rotation_timer[Y] == pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].rotation_target[pCAMERA_SOURCE[temp1].rotation_current_frame][Y] && pCAMERA_SOURCE[temp1].rotation_timer[Z] == pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].rotation_target[pCAMERA_SOURCE[temp1].rotation_current_frame][Z])
    {
     pCAMERA_SOURCE[temp1].rotation_current_frame++;
     pCAMERA_SOURCE[temp1].rotation_timer[X] = pCAMERA_SOURCE[temp1].rotation_timer[Y] = pCAMERA_SOURCE[temp1].rotation_timer[Z] = 0;
    }
   }
   if(pCAMERA_SOURCE[temp1].rotation_current_frame >= pCAMERA_SOURCE_ANIMATION_ROTATION[pCAMERA_SOURCE[temp1].rotation_current_animation].total_frames)
   {
    if(pCAMERA_SOURCE[temp1].rotation_loop == YES)
     pCAMERA_SOURCE[temp1].rotation_current_frame = 0;
    else
     pCAMERA_SOURCE[temp1].rotation_animate = NO;
   }
  }
 }

 if(pCAMERA_SOURCE[temp1].clipping_check == YES && pCAMERA_SOURCE[temp1].position[X] < pCAMERA_SOURCE[temp1].clipping_left_boundary  || pCAMERA_SOURCE[temp1].clipping_check == YES && pCAMERA_SOURCE[temp1].position[X] > pCAMERA_SOURCE[temp1].clipping_right_boundary  ||
    pCAMERA_SOURCE[temp1].clipping_check == YES && pCAMERA_SOURCE[temp1].position[Y] < pCAMERA_SOURCE[temp1].clipping_top_boundary   || pCAMERA_SOURCE[temp1].clipping_check == YES && pCAMERA_SOURCE[temp1].position[Y] > pCAMERA_SOURCE[temp1].clipping_bottom_boundary ||
    pCAMERA_SOURCE[temp1].clipping_check == YES && pCAMERA_SOURCE[temp1].position[Z] < pCAMERA_SOURCE[temp1].clipping_front_boundary || pCAMERA_SOURCE[temp1].clipping_check == YES && pCAMERA_SOURCE[temp1].position[Z] > pCAMERA_SOURCE[temp1].clipping_back_boundary);
 else
 {
  if(pCAMERA_SOURCE[temp1].show_sprite == YES)
   slUnitMatrix(CURRENT);
   slLookAt(pCAMERA_SOURCE[temp1].position, pCAMERA_SOURCE[temp1].camera_target, pCAMERA_SOURCE[temp1].angle[Z]);
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    collision_box_number   = The starting slot number of the sprite to begin loading into.
    collision_box_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_CAMERA_SOURCE_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pCAMERA_SOURCE[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);

  pCAMERA_SOURCE[sprite_number + temp1].movement_animate = e2_CDROM_read_number(1);
  pCAMERA_SOURCE[sprite_number + temp1].movement_loop = e2_CDROM_read_number(1);
  pCAMERA_SOURCE[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].movement_current_frame = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].movement_timer[X] = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].movement_timer[Y] = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].movement_timer[Z] = e2_CDROM_read_number(4);

  pCAMERA_SOURCE[sprite_number + temp1].rotation_animate = e2_CDROM_read_number(1);
  pCAMERA_SOURCE[sprite_number + temp1].rotation_loop = e2_CDROM_read_number(1);
  pCAMERA_SOURCE[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].rotation_current_frame = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].rotation_timer[X] = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].rotation_timer[Y] = e2_CDROM_read_number(4);
  pCAMERA_SOURCE[sprite_number + temp1].rotation_timer[Z] = e2_CDROM_read_number(4);

  pCAMERA_SOURCE[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pCAMERA_SOURCE[sprite_number + temp1].angle[X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].angle[Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].angle[Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);

  pCAMERA_SOURCE[sprite_number + temp1].camera_target[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].camera_target[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].camera_target[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);

  pCAMERA_SOURCE[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pCAMERA_SOURCE[sprite_number + temp1].clipping_left_boundary   = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].clipping_right_boundary  = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].clipping_top_boundary    = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].clipping_front_boundary  = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pCAMERA_SOURCE[sprite_number + temp1].clipping_back_boundary   = toFIXED(e2_CDROM_read_number(9) * 0.0001);
 }
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].movement_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].rotation_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pCAMERA_SOURCE[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pCAMERA_SOURCE[temp1].angle[X], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].angle[Y], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].angle[Z], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));

 slDMACopy((void*)&pCAMERA_SOURCE[temp1].camera_target[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].camera_target[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].camera_target[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pCAMERA_SOURCE[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 return;
}
// --------------------------------------------------
e2_CAMERA_SOURCE_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].movement_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].rotation_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].angle[X], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].angle[Y], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].angle[Z], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].camera_target[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].camera_target[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].camera_target[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pCAMERA_SOURCE[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return;
}
// ==================================================
//	[IMAGE3D]            :  <<IMAGE3D>>
// --------------------------------------------------
e2_IMAGE3D_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of model slots.
    temp2 = The desired number of model slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pIMAGE3D = (IMAGE3D*)realloc(pIMAGE3D, temp2 * sizeof(IMAGE3D));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pIMAGE3D[temp3].model_points);
   free(pIMAGE3D[temp3].model_polygons);
   free(pIMAGE3D[temp3].model_attributes);
  }
  pIMAGE3D = (IMAGE3D*)realloc(pIMAGE3D, temp2 * sizeof(IMAGE3D));
 }
 return;
}
// --------------------------------------------------
e2_IMAGE3D_modify(int temp1, int temp2, Uint8 temp3, Uint8 temp4, Uint16 temp5, Uint16 temp6, Uint16 temp7, Uint16 temp8, Uint32 temp9, Uint16 temp10)
{
 /*
    temp1 = The slot number of the model to edit.
    temp2 = The number of the polygon on the model to edit.

    For the rest of the variables, please see the allowed values of the 'ATTRIBUTE' command in manual# ST_238-R1-051795 - page# 229 - 230.
 */
 int  temp11 = 0;
 ATTR temp_attributes[1] = {ATTRIBUTE(temp3, temp4, temp5, temp6, temp7, temp8, temp9, temp10)};

 pIMAGE3D[temp1].model_attributes[temp2] = temp_attributes[0];
 return;
}
// --------------------------------------------------
e2_IMAGE3D_load_from_CDROM(int image3D_number, char image3D_sheet_filename[])
{
 /*
    image3D_number         = The starting slot number of the model to begin loading into.
    image3D_sheet_filename = The file name of the models to load.
 */
 int number_of_3D_images, image_data[max_CDROM_load][XY], temp1 = 0, temp2 = 0, temp3 = 0, temp4 = 0, temp5 = 0;
 int temp_attributes[8];

 e2_CDROM_load_file(image3D_sheet_filename);
 number_of_3D_images = e2_CDROM_read_number(4);
 e2_IMAGE3D_reallocate(image3D_number, image3D_number + number_of_3D_images);

 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  image_data[temp1][X] = e2_CDROM_read_number(4); pIMAGE3D[image3D_number + temp1].total_vertices = image_data[temp1][X];
  image_data[temp1][Y] = e2_CDROM_read_number(4); pIMAGE3D[image3D_number + temp1].total_polygons = image_data[temp1][Y];
 }

 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  pIMAGE3D[image3D_number + temp1].model_points     = (POINT(*))realloc(pIMAGE3D[image3D_number + temp1].model_points, pIMAGE3D[image3D_number + temp1].total_vertices * sizeof(POINT));
  pIMAGE3D[image3D_number + temp1].model_polygons   = (POLYGON(*))realloc(pIMAGE3D[image3D_number + temp1].model_polygons, pIMAGE3D[image3D_number + temp1].total_polygons * sizeof(POLYGON));
  pIMAGE3D[image3D_number + temp1].model_attributes = (ATTR(*))realloc(pIMAGE3D[image3D_number + temp1].model_attributes, pIMAGE3D[image3D_number + temp1].total_polygons * sizeof(ATTR));
 }

 //  Read and Store the POINT data:
 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  for(temp2 = 0; temp2 != pIMAGE3D[image3D_number + temp1].total_vertices; temp2++)
  {
   for(temp3 = 0; temp3 != 3; temp3++)
    pIMAGE3D[image3D_number + temp1].model_points[temp2][temp3] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }

 // Read and Store the NORMAL data:
 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  for(temp2 = 0; temp2 != pIMAGE3D[image3D_number + temp1].total_polygons; temp2++)
  {
   for(temp3 = 0; temp3 != 3; temp3++)
    pIMAGE3D[image3D_number + temp1].model_polygons[temp2].norm[temp3] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }

 // Read and Store the VERTEX (polygon face) data:
 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  for(temp2 = 0; temp2 != pIMAGE3D[image3D_number + temp1].total_polygons; temp2++)
  {
   for(temp3 = 0; temp3 != 4; temp3++)
    pIMAGE3D[image3D_number + temp1].model_polygons[temp2].Vertices[temp3] = (Uint16)e2_CDROM_read_number(4);
  }
 }

 // Read and Store the ATTRIBUTE data:
 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  for(temp2 = 0; temp2 != pIMAGE3D[image3D_number + temp1].total_polygons; temp2++)
  {
   temp3 = e2_CDROM_read_number(1);
   switch(temp3)
   {
    case 0:
     temp_attributes[0] = (Uint8)Single_Plane;
     break;

    case 1:
     temp_attributes[0] = (Uint8)Dual_Plane;
     break;
   }

   temp3 = e2_CDROM_read_number(1);
   temp4 = e2_CDROM_read_number(1);
   switch(temp3)
   {
    case 0:
     switch(temp4)
     {
      case 0:
       temp_attributes[1] = (Uint8)SORT_MIN;
       temp_attributes[7] = (Uint16)No_Option;
       break;

      case 1:
       temp_attributes[1] = (Uint8)SORT_MIN;
       temp_attributes[7] = (Uint16)UseLight;
       break;

      case 2:
       temp_attributes[1] = (Uint8)SORT_MIN;
       temp_attributes[7] = (Uint16)UseNearClip;
       break;

      case 3:
       temp_attributes[1] = (Uint8)SORT_MIN;
       temp_attributes[7] = (Uint16)UseLight|UseNearClip;
       break;
     }
     break;

    case 1:
     switch(temp4)
     {
      case 0:
       temp_attributes[1] = (Uint8)SORT_CEN;
       temp_attributes[7] = (Uint16)No_Option;
       break;

      case 1:
       temp_attributes[1] = (Uint8)SORT_CEN;
       temp_attributes[7] = (Uint16)UseLight;
       break;

      case 2:
       temp_attributes[1] = (Uint8)SORT_CEN;
       temp_attributes[7] = (Uint16)UseNearClip;
       break;

      case 3:
       temp_attributes[1] = (Uint8)SORT_CEN;
       temp_attributes[7] = (Uint16)UseLight|UseNearClip;
       break;
     }
     break;

    case 2:
     switch(temp4)
     {
      case 0:
       temp_attributes[1] = (Uint8)SORT_MAX;
       temp_attributes[7] = (Uint16)No_Option;
       break;

      case 1:
       temp_attributes[1] = (Uint8)SORT_MAX;
       temp_attributes[7] = (Uint16)UseLight;
       break;

      case 2:
       temp_attributes[1] = (Uint8)SORT_MAX;
       temp_attributes[7] = (Uint16)UseNearClip;
       break;

      case 3:
       temp_attributes[1] = (Uint8)SORT_MAX;
       temp_attributes[7] = (Uint16)UseLight|UseNearClip;
       break;
     }
     break;
   }

   temp3 = e2_CDROM_read_number(2);
   temp4 = e2_CDROM_read_number(2);
   temp5 = e2_CDROM_read_number(2);
   temp_attributes[3] = (Uint16)C_RGB(temp3, temp4, temp5);

   temp3 = e2_CDROM_read_number(1);
   switch(temp3)
   {
    case 0:
     temp_attributes[5] = (Uint16)CL32KRGB|MESHoff;
     break;

    case 1:
     temp_attributes[5] = (Uint16)CL32KRGB|MESHon;
     break;
   }

   temp3 = e2_CDROM_read_number(1);
   switch(temp3)
   {
    case 0:
     temp_attributes[6] = (Uint32)sprPolyLine;
     break;

    case 1:
     temp_attributes[6] = (Uint32)sprPolygon;
     break;
   }

// TEXTURE and GOURAUD Settings are Defaulted to NONE:
   temp_attributes[2] = (Uint16)No_Texture;
   temp_attributes[4] = (Uint16)No_Gouraud;

   e2_IMAGE3D_modify(image3D_number + temp1, temp2, (Uint8)temp_attributes[0], (Uint8)temp_attributes[1], (Uint16)temp_attributes[2], (Uint16)temp_attributes[3], (Uint16)temp_attributes[4], (Uint16)temp_attributes[5], (Uint32)temp_attributes[6], (Uint16)temp_attributes[7]);
  }
 }

 // Create the PDATA for the 3D Model:
 for(temp1 = 0; temp1 != number_of_3D_images; temp1++)
 {
  pIMAGE3D[image3D_number + temp1].model_data.pntbl     = pIMAGE3D[image3D_number + temp1].model_points;
  pIMAGE3D[image3D_number + temp1].model_data.nbPoint   = (Uint32)pIMAGE3D[image3D_number + temp1].total_vertices;
  pIMAGE3D[image3D_number + temp1].model_data.pltbl     = pIMAGE3D[image3D_number + temp1].model_polygons;
  pIMAGE3D[image3D_number + temp1].model_data.nbPolygon = (Uint32)pIMAGE3D[image3D_number + temp1].total_polygons;
  pIMAGE3D[image3D_number + temp1].model_data.attbl     = pIMAGE3D[image3D_number + temp1].model_attributes;
 }
 return;
}
// --------------------------------------------------
e2_IMAGE3D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the model to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3 = 0;

 slDMACopy((void*)&pIMAGE3D[temp1].total_vertices, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pIMAGE3D[temp1].total_polygons, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pIMAGE3D[temp1].total_vertices; temp3++)
 {
  slDMACopy((void*)&pIMAGE3D[temp1].model_points[temp3], (void*)temp2, sizeof(POINT));
  temp2 += sizeof(POINT);
 }

 for(temp3 = 0; temp3 != pIMAGE3D[temp1].total_polygons; temp3++)
 {
  slDMACopy((void*)&pIMAGE3D[temp1].model_polygons[temp3], (void*)temp2, sizeof(POLYGON));
  temp2 += sizeof(POLYGON);
 }

 for(temp3 = 0; temp3 != pIMAGE3D[temp1].total_polygons; temp3++)
 {
  slDMACopy((void*)&pIMAGE3D[temp1].model_attributes[temp3], (void*)temp2, sizeof(ATTR));
  temp2 += sizeof(ATTR);
 }

 slDMACopy((void*)&pIMAGE3D[temp1].model_data, (void*)temp2, sizeof(PDATA));
 temp2 += sizeof(PDATA);
 return;
}
// --------------------------------------------------
e2_IMAGE3D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the model into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3 = 0;

 slDMACopy((void*)temp2, (void*)&pIMAGE3D[temp1].total_vertices, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pIMAGE3D[temp1].total_polygons, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pIMAGE3D[temp1].total_vertices; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pIMAGE3D[temp1].model_points[temp3], sizeof(POINT));
  temp2 += sizeof(POINT);
 }

 for(temp3 = 0; temp3 != pIMAGE3D[temp1].total_polygons; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pIMAGE3D[temp1].model_polygons[temp3], sizeof(POLYGON));
  temp2 += sizeof(POLYGON);
 }

 for(temp3 = 0; temp3 != pIMAGE3D[temp1].total_polygons; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pIMAGE3D[temp1].model_attributes[temp3], sizeof(ATTR));
  temp2 += sizeof(ATTR);
 }

 slDMACopy((void*)temp2, (void*)&pIMAGE3D[temp1].model_data, sizeof(PDATA));
 temp2 += sizeof(PDATA);
 return;
}
// ==================================================
//	[SPRITE3D_ANIMATION_MOVEMENT] :  <<SPRITE3D_ANIMATION_MOVEMENT>>
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE3D_ANIMATION_MOVEMENT = (SPRITE3D_ANIMATION_MOVEMENT*)realloc(pSPRITE3D_ANIMATION_MOVEMENT, temp2 * sizeof(SPRITE3D_ANIMATION_MOVEMENT));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE3D_ANIMATION_MOVEMENT[temp3].movement_target);
   free(pSPRITE3D_ANIMATION_MOVEMENT[temp3].movement_increment);
  }
  pSPRITE3D_ANIMATION_MOVEMENT = (SPRITE3D_ANIMATION_MOVEMENT*)realloc(pSPRITE3D_ANIMATION_MOVEMENT, temp2 * sizeof(SPRITE3D_ANIMATION_MOVEMENT));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].total_frames = temp2;
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target = (int(*)[3])realloc(pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target, temp2 * sizeof(int * [3]));
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment = (FIXED(*)[3])realloc(pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment, temp2 * sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_setup(int temp1, int temp2, int temp3, int temp4, int temp5, FIXED temp6, FIXED temp7, FIXED temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = temp3;
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = temp4;
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = temp5;
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = temp6;
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = temp7;
 pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_setup_interpolated(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, FIXED temp7, FIXED temp8, FIXED temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting position.
    temp5 = The Y starting position.
    temp6 = The Z starting position.
    temp7 = The X desired ending position.
    temp8 = The Y desired ending position.
    temp9 = The Z desired ending position.
 */
 int temp10 = 0;
 FIXED chk_val[XYZ] = {(temp7 - temp4), (temp8 - temp5), (temp9 - temp6)};

 for(temp10 = 0; temp10 != 3; temp10++) if(chk_val[temp10] <= 0) chk_val[temp10] *= -1;

 if(chk_val[X] >= chk_val[Y] && chk_val[X] >= chk_val[Z])
 {
  if(chk_val[X] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = toFIXED(temp3); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = (temp7 - temp4) / toFIXED(temp3);}
  if(chk_val[Y] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp7 - temp4) / toFIXED(temp3)); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
  if(chk_val[Z] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp7 - temp4) / toFIXED(temp3)); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X];}
 }

 if(chk_val[Y] >= chk_val[X] && chk_val[Y] >= chk_val[Z])
 {
  if(chk_val[Y] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = toFIXED(temp3); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = (temp8 - temp5) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp8 - temp5) / toFIXED(temp3)); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
  if(chk_val[Z] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = (temp9 - temp6) / ((temp8 - temp5) / toFIXED(temp3)); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y];}
 }

 if(chk_val[Z] >= chk_val[X] && chk_val[Z] >= chk_val[Y])
 {
  if(chk_val[Z] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Z] = toFIXED(temp3); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z] = (temp9 - temp6) / toFIXED(temp3);}
  if(chk_val[X] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][X] = (temp7 - temp4) / ((temp9 - temp6) / toFIXED(temp3)); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][X] = pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
  if(chk_val[Y] >= toFIXED(0.0)){pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][Y] = (temp8 - temp5) / ((temp9 - temp6) / toFIXED(temp3)); pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Y] = pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][Z];}
 }

 for(temp10 = 0; temp10 != 3; temp10++) if(pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] <= 0)
 {
  pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp2][temp10] *= -1;
  pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp2][temp10] *= -1;
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE3D_ANIMATION_MOVEMENT_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE3D_ANIMATION_MOVEMENT_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][X] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Y] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].movement_target[temp2][Z] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_MOVEMENT[animation_number + temp1].movement_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_MOVEMENT_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_MOVEMENT[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_MOVEMENT[temp1].movement_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return;
}
// ==================================================
//	[SPRITE3D_ANIMATION_ROTATION] :  <<SPRITE3D_ANIMATION_ROTATION>>
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE3D_ANIMATION_ROTATION = (SPRITE3D_ANIMATION_ROTATION*)realloc(pSPRITE3D_ANIMATION_ROTATION, temp2 * sizeof(SPRITE3D_ANIMATION_ROTATION));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE3D_ANIMATION_ROTATION[temp3].rotation_target);
   free(pSPRITE3D_ANIMATION_ROTATION[temp3].rotation_increment);
   free(pSPRITE3D_ANIMATION_ROTATION[temp3].rotation_final_position);
  }
  pSPRITE3D_ANIMATION_ROTATION = (SPRITE3D_ANIMATION_ROTATION*)realloc(pSPRITE3D_ANIMATION_ROTATION, temp2 * sizeof(SPRITE3D_ANIMATION_ROTATION));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE3D_ANIMATION_ROTATION[temp1].total_frames = temp2;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target = (int(*)[3])realloc(pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target, temp2 * sizeof(int * [3]));
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment = (ANGLE(*)[3])realloc(pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment, temp2 * sizeof(ANGLE * [3]));
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position = (ANGLE(*)[4])realloc(pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position, temp2 * sizeof(ANGLE * [4]));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_setup(int temp1, int temp2, int temp3, int temp4, int temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8)
{
 /*
    temp1  = The slot number of the animation to edit.
    temp2  = The frame number of the animation to edit.
    temp3  = The number of times to repeat the X per-frame-increment.
    temp4  = The number of times to repeat the Y per-frame-increment.
    temp5  = The number of times to repeat the Z per-frame-increment.
    temp6  = The X per-frame-increment.
    temp7  = The Y per-frame-increment.
    temp8  = The Z per-frame-increment.
 */
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp2][X] = temp3;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp2][Y] = temp4;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp2][Z] = temp5;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = temp6;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = temp7;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = temp8;

 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][X] = DEGtoANG(temp3 * temp6);
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Y] = DEGtoANG(temp4 * temp7);
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = DEGtoANG(temp5 * temp8);
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][3] = DEGtoANG(NO);
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_setup_interpolated(int temp1, int temp2, int temp3, ANGLE temp4, ANGLE temp5, ANGLE temp6, ANGLE temp7, ANGLE temp8, ANGLE temp9)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The desired number of times to repeat the X,Y, and Z per-frame-increments (How many cycles to complete the movement in).
    temp4 = The X starting angle.
    temp5 = The Y starting angle.
    temp6 = The Z starting angle.
    temp7 = The X desired ending angle.
    temp8 = The Y desired ending angle.
    temp9 = The Z desired ending angle.
 */
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp2][X] = temp3;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp2][Y] = temp3;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp2][Z] = temp3;

 if(temp4 >= temp7)
  pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = ((temp4 - temp7) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else
  pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][X] = ((temp7 - temp4) / DEGtoANG(temp3));

 if(temp5 >= temp8)
  pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = ((temp5 - temp8) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else
  pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Y] = ((temp8 - temp5) / DEGtoANG(temp3));

 if(temp6 >= temp9)
  pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = ((temp6 - temp9) / DEGtoANG(temp3)) * DEGtoANG(-1.0);
 else                                                                                  
  pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp2][Z] = ((temp9 - temp6) / DEGtoANG(temp3));

 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][X] = temp7;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Y] = temp8;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][Z] = temp9;
 pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp2][3] = DEGtoANG(YES);
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE3D_ANIMATION_ROTATION_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE3D_ANIMATION_ROTATION_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][X] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Y] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_target[temp2][Z] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_increment[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_ROTATION[animation_number + temp1].rotation_final_position[temp2][3] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);

  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][X], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Y], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Z], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][3], (void*)temp2, sizeof(ANGLE));
  temp2 += sizeof(ANGLE);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_ROTATION_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_ROTATION[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_increment[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));

  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][X], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Y], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][Z], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_ROTATION[temp1].rotation_final_position[temp3][3], sizeof(ANGLE));
  temp2 += (sizeof(ANGLE));
 }
 return;
}
// ==================================================
//	[SPRITE3D_ANIMATION_SCALING] :  <<SPRITE3D_ANIMATION_SCALING>>
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_SCALING_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE3D_ANIMATION_SCALING = (SPRITE3D_ANIMATION_SCALING*)realloc(pSPRITE3D_ANIMATION_SCALING, temp2 * sizeof(SPRITE3D_ANIMATION_SCALING));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE3D_ANIMATION_SCALING[temp3].scaling_target);
   free(pSPRITE3D_ANIMATION_SCALING[temp3].scaling_increment);
  }
  pSPRITE3D_ANIMATION_SCALING = (SPRITE3D_ANIMATION_SCALING*)realloc(pSPRITE3D_ANIMATION_SCALING, temp2 * sizeof(SPRITE3D_ANIMATION_SCALING));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_SCALING_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE3D_ANIMATION_SCALING[temp1].total_frames = temp2;
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target = (int(*)[3])realloc(pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target, temp2 * sizeof(int * [3]));
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment = (FIXED(*)[3])realloc(pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment, temp2 * sizeof(FIXED * [3]));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_SCALING_setup(int temp1, int temp2, int temp3, int temp4, int temp5, FIXED temp6, FIXED temp7, FIXED temp8)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The number of times to repeat the X per-frame-increment.
    temp4 = The number of times to repeat the Y per-frame-increment.
    temp5 = The number of times to repeat the Z per-frame-increment.
    temp6 = The X per-frame-increment.
    temp7 = The Y per-frame-increment.
    temp8 = The Z per-frame-increment.
 */
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp2][X] = temp3;
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp2][Y] = temp4;
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp2][Z] = temp5;
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp2][X] = temp6;
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp2][Y] = temp7;
 pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp2][Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_SCALING_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE3D_ANIMATION_SCALING_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE3D_ANIMATION_SCALING_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2][X] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2][Y] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].scaling_target[temp2][Z] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2][X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2][Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
   pSPRITE3D_ANIMATION_SCALING[animation_number + temp1].scaling_increment[temp2][Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_SCALING_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;

 slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_SCALING[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp3][X], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp3][Y], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp3][Z], (void*)temp2, sizeof(int));
  temp2 += sizeof(int);

  slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp3][X], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp3][Y], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
  slDMACopy((void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp3][Z], (void*)temp2, sizeof(FIXED));
  temp2 += sizeof(FIXED);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_SCALING_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;

 slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_SCALING[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp3][X], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp3][Y], sizeof(int));
  temp2 += (sizeof(int));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_target[temp3][Z], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp3][X], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp3][Y], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_SCALING[temp1].scaling_increment[temp3][Z], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return;
}
// ==================================================
//	[SPRITE3D]           :  <<SPRITE3D>>
// --------------------------------------------------
e2_SPRITE3D_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE3D = (SPRITE3D*)realloc(pSPRITE3D, temp1 * sizeof(SPRITE3D));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_setup(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5, FIXED temp6, ANGLE temp7, ANGLE temp8, ANGLE temp9, FIXED temp10, FIXED temp11, FIXED temp12, int temp13, FIXED temp14, FIXED temp15, FIXED temp16, FIXED temp17, FIXED temp18, FIXED temp19)
{
 /*
    temp1  = The slot number of the sprite to edit.
    temp2  = Whether to show the sprite or not.
             Specify either YES or NO.
    temp3  = The slot number of the 3D model to display.
    temp4  = The X position of the sprite.
    temp5  = The Y position of the sprite.
    temp6  = The Z position of the sprite.
    temp7  = The X angle of the sprite.
    temp8  = The Y angle of the sprite.
    temp9  = The Z angle of the sprite.
    temp10 = The X scale of the sprite.
    temp11 = The Y scale of the sprite.
    temp12 = The Z scale of the sprite.
    temp13 = Whether to use boundary clipping on the sprite or not.
             Specify either YES or NO.
    temp14 = The left clipping boundary.
    temp15 = The right clipping boundary.
    temp16 = The top clipping boundary.
    temp17 = The bottom clipping boundary.
    temp18 = The front clipping boundary.
    temp19 = The back clipping boundary.
 */
 pSPRITE3D[temp1].show_sprite = temp2;
 pSPRITE3D[temp1].image3D_number = temp3;
 pSPRITE3D[temp1].position[X] = temp4;
 pSPRITE3D[temp1].position[Y] = temp5;
 pSPRITE3D[temp1].position[Z] = temp6;
 pSPRITE3D[temp1].angle[X] = temp7;
 pSPRITE3D[temp1].angle[Y] = temp8;
 pSPRITE3D[temp1].angle[Z] = temp9;
 pSPRITE3D[temp1].scale[X] = temp10;
 pSPRITE3D[temp1].scale[Y] = temp11;
 pSPRITE3D[temp1].scale[Z] = temp12;

 pSPRITE3D[temp1].clipping_check = temp13;
 pSPRITE3D[temp1].clipping_left_boundary   = temp14;
 pSPRITE3D[temp1].clipping_right_boundary  = temp15;
 pSPRITE3D[temp1].clipping_top_boundary    = temp16;
 pSPRITE3D[temp1].clipping_bottom_boundary = temp17;
 pSPRITE3D[temp1].clipping_front_boundary  = temp18;
 pSPRITE3D[temp1].clipping_back_boundary   = temp19;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_setup_ANIMATION_MOVEMENT(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE3D[temp1].movement_animate = temp2;
 pSPRITE3D[temp1].movement_loop = temp3;
 pSPRITE3D[temp1].movement_current_animation = temp4;
 pSPRITE3D[temp1].movement_current_frame = temp5;
 pSPRITE3D[temp1].movement_timer[X] = temp6;
 pSPRITE3D[temp1].movement_timer[Y] = temp7;
 pSPRITE3D[temp1].movement_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_setup_ANIMATION_ROTATION(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE3D[temp1].rotation_animate = temp2;
 pSPRITE3D[temp1].rotation_loop = temp3;
 pSPRITE3D[temp1].rotation_current_animation = temp4;
 pSPRITE3D[temp1].rotation_current_frame = temp5;
 pSPRITE3D[temp1].rotation_timer[X] = temp6;
 pSPRITE3D[temp1].rotation_timer[Y] = temp7;
 pSPRITE3D[temp1].rotation_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_setup_ANIMATION_SCALING(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, int temp7, int temp8)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The X frame's delay timer (Usually want to initialize at 0).
    temp7 = The Y frame's delay timer (Usually want to initialize at 0).
    temp8 = The Z frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE3D[temp1].scaling_animate = temp2;
 pSPRITE3D[temp1].scaling_loop = temp3;
 pSPRITE3D[temp1].scaling_current_animation = temp4;
 pSPRITE3D[temp1].scaling_current_frame = temp5;
 pSPRITE3D[temp1].scaling_timer[X] = temp6;
 pSPRITE3D[temp1].scaling_timer[Y] = temp7;
 pSPRITE3D[temp1].scaling_timer[Z] = temp8;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 int temp2;
 static FIXED temp_position[XYZ];
 static ANGLE temp_angle[XYZ];

 if(pSPRITE3D[temp1].movement_current_animation != NONE)
 {
  if(pSPRITE3D[temp1].movement_animate == YES)
  {
   if(pSPRITE3D[temp1].movement_current_frame != pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSPRITE3D[temp1].movement_timer[temp2] != pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].movement_target[pSPRITE3D[temp1].movement_current_frame][temp2])
     {
      pSPRITE3D[temp1].position[temp2] += pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].movement_increment[pSPRITE3D[temp1].movement_current_frame][temp2];
      pSPRITE3D[temp1].movement_timer[temp2]++;
     }
    }
    if(pSPRITE3D[temp1].movement_timer[X] == pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].movement_target[pSPRITE3D[temp1].movement_current_frame][X] && pSPRITE3D[temp1].movement_timer[Y] == pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].movement_target[pSPRITE3D[temp1].movement_current_frame][Y] && pSPRITE3D[temp1].movement_timer[Z] == pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].movement_target[pSPRITE3D[temp1].movement_current_frame][Z])
    {
     pSPRITE3D[temp1].movement_current_frame++;
     pSPRITE3D[temp1].movement_timer[X] = pSPRITE3D[temp1].movement_timer[Y] = pSPRITE3D[temp1].movement_timer[Z] = 0;
    }
   }
   if(pSPRITE3D[temp1].movement_current_frame >= pSPRITE3D_ANIMATION_MOVEMENT[pSPRITE3D[temp1].movement_current_animation].total_frames)
   {
    if(pSPRITE3D[temp1].movement_loop == YES)
     pSPRITE3D[temp1].movement_current_frame = 0;
    else
     pSPRITE3D[temp1].movement_animate = NO;
   }
  }
 }

 if(pSPRITE3D[temp1].rotation_current_animation != NONE)
 {
  if(pSPRITE3D[temp1].rotation_animate == YES)
  {
   if(pSPRITE3D[temp1].rotation_current_frame != pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSPRITE3D[temp1].rotation_timer[temp2] != pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_target[pSPRITE3D[temp1].rotation_current_frame][temp2])
     {
      pSPRITE3D[temp1].angle[temp2] += pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_increment[pSPRITE3D[temp1].rotation_current_frame][temp2];
      pSPRITE3D[temp1].rotation_timer[temp2]++;
     }
    }
    if(pSPRITE3D[temp1].rotation_timer[X] == pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_target[pSPRITE3D[temp1].rotation_current_frame][X] && pSPRITE3D[temp1].rotation_timer[Y] == pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_target[pSPRITE3D[temp1].rotation_current_frame][Y] && pSPRITE3D[temp1].rotation_timer[Z] == pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_target[pSPRITE3D[temp1].rotation_current_frame][Z])
    {
     if(pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_final_position[pSPRITE3D[temp1].rotation_current_frame][3] == DEGtoANG(YES))
     {
      pSPRITE3D[temp1].angle[X] = pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_final_position[pSPRITE3D[temp1].rotation_current_frame][X];
      pSPRITE3D[temp1].angle[Y] = pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_final_position[pSPRITE3D[temp1].rotation_current_frame][Y];
      pSPRITE3D[temp1].angle[Z] = pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].rotation_final_position[pSPRITE3D[temp1].rotation_current_frame][Z];
     }
     pSPRITE3D[temp1].rotation_current_frame++;
     pSPRITE3D[temp1].rotation_timer[X] = pSPRITE3D[temp1].rotation_timer[Y] = pSPRITE3D[temp1].rotation_timer[Z] = 0;
    }
   }
   if(pSPRITE3D[temp1].rotation_current_frame >= pSPRITE3D_ANIMATION_ROTATION[pSPRITE3D[temp1].rotation_current_animation].total_frames)
   {
    if(pSPRITE3D[temp1].rotation_loop == YES)
     pSPRITE3D[temp1].rotation_current_frame = 0;
    else
     pSPRITE3D[temp1].rotation_animate = NO;
   }
  }
 }

 if(pSPRITE3D[temp1].scaling_current_animation != NONE)
 {
  if(pSPRITE3D[temp1].scaling_animate == YES)
  {
   if(pSPRITE3D[temp1].scaling_current_frame != pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].total_frames)
   {
    for(temp2 = 0; temp2 != 3; temp2++)
    {
     if(pSPRITE3D[temp1].scaling_timer[temp2] != pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].scaling_target[pSPRITE3D[temp1].scaling_current_frame][temp2])
     {
      pSPRITE3D[temp1].scale[temp2] += pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].scaling_increment[pSPRITE3D[temp1].scaling_current_frame][temp2];
      pSPRITE3D[temp1].scaling_timer[temp2]++;
     }
    }
    if(pSPRITE3D[temp1].scaling_timer[X] == pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].scaling_target[pSPRITE3D[temp1].scaling_current_frame][X] && pSPRITE3D[temp1].scaling_timer[Y] == pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].scaling_target[pSPRITE3D[temp1].scaling_current_frame][Y] && pSPRITE3D[temp1].scaling_timer[Z] == pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].scaling_target[pSPRITE3D[temp1].scaling_current_frame][Z])
    {
     pSPRITE3D[temp1].scaling_current_frame++;
     pSPRITE3D[temp1].scaling_timer[X] = pSPRITE3D[temp1].scaling_timer[Y] = pSPRITE3D[temp1].scaling_timer[Z] = 0;
    }
   }
   if(pSPRITE3D[temp1].scaling_current_frame >= pSPRITE3D_ANIMATION_SCALING[pSPRITE3D[temp1].scaling_current_animation].total_frames)
   {
    if(pSPRITE3D[temp1].scaling_loop == YES)
     pSPRITE3D[temp1].scaling_current_frame = 0;
    else
     pSPRITE3D[temp1].scaling_animate = NO;
   }
  }
 }

 slTranslate(pSPRITE3D[temp1].position[X], pSPRITE3D[temp1].position[Y], pSPRITE3D[temp1].position[Z]);
 slRotX(pSPRITE3D[temp1].angle[X]);
 slRotY(pSPRITE3D[temp1].angle[Y]);
 slRotZ(pSPRITE3D[temp1].angle[Z]);
 slScale(pSPRITE3D[temp1].scale[X], pSPRITE3D[temp1].scale[Y], pSPRITE3D[temp1].scale[Z]);

 if(pSPRITE3D[temp1].clipping_check == YES && pSPRITE3D[temp1].position[X] < pSPRITE3D[temp1].clipping_left_boundary  || pSPRITE3D[temp1].clipping_check == YES && pSPRITE3D[temp1].position[X] > pSPRITE3D[temp1].clipping_right_boundary  ||
    pSPRITE3D[temp1].clipping_check == YES && pSPRITE3D[temp1].position[Y] < pSPRITE3D[temp1].clipping_top_boundary   || pSPRITE3D[temp1].clipping_check == YES && pSPRITE3D[temp1].position[Y] > pSPRITE3D[temp1].clipping_bottom_boundary ||
    pSPRITE3D[temp1].clipping_check == YES && pSPRITE3D[temp1].position[Z] < pSPRITE3D[temp1].clipping_front_boundary || pSPRITE3D[temp1].clipping_check == YES && pSPRITE3D[temp1].position[Z] > pSPRITE3D[temp1].clipping_back_boundary);
 else
 {
  if(pSPRITE3D[temp1].show_sprite == YES)
   slPutPolygon(&pIMAGE3D[pSPRITE3D[temp1].image3D_number].model_data);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE3D_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE3D[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].image3D_number = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].movement_animate = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].movement_loop = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].movement_current_animation = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].movement_current_frame = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].movement_timer[X] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].movement_timer[Y] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].movement_timer[Z] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].rotation_animate = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].rotation_loop = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].rotation_current_animation = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].rotation_current_frame = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].rotation_timer[X] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].rotation_timer[Y] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].rotation_timer[Z] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].scaling_animate = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].scaling_loop = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].scaling_current_animation = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].scaling_current_frame = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].scaling_timer[X] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].scaling_timer[Y] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].scaling_timer[Z] = e2_CDROM_read_number(4);
  pSPRITE3D[sprite_number + temp1].position[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].position[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].position[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].angle[X] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].angle[Y] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].angle[Z] = DEGtoANG(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].scale[X] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].scale[Y] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].scale[Z] = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].clipping_check = e2_CDROM_read_number(1);
  pSPRITE3D[sprite_number + temp1].clipping_left_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].clipping_right_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].clipping_top_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].clipping_bottom_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].clipping_front_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
  pSPRITE3D[sprite_number + temp1].clipping_back_boundary = toFIXED(e2_CDROM_read_number(9) * 0.0001);
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE3D[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].image3D_number, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSPRITE3D[temp1].movement_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].movement_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].movement_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].movement_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].movement_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].movement_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].movement_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSPRITE3D[temp1].rotation_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].rotation_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].rotation_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].rotation_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].rotation_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].rotation_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].rotation_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSPRITE3D[temp1].scaling_animate, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].scaling_loop, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].scaling_current_animation, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].scaling_current_frame, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].scaling_timer[X], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].scaling_timer[Y], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].scaling_timer[Z], (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));

 slDMACopy((void*)&pSPRITE3D[temp1].position[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].position[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].position[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSPRITE3D[temp1].angle[X], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pSPRITE3D[temp1].angle[Y], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));
 slDMACopy((void*)&pSPRITE3D[temp1].angle[Z], (void*)temp2, sizeof(ANGLE));
 temp2 += (sizeof(ANGLE));

 slDMACopy((void*)&pSPRITE3D[temp1].scale[X], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].scale[Y], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].scale[Z], (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));

 slDMACopy((void*)&pSPRITE3D[temp1].clipping_check, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 slDMACopy((void*)&pSPRITE3D[temp1].clipping_left_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].clipping_right_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].clipping_top_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].clipping_bottom_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].clipping_front_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 slDMACopy((void*)&pSPRITE3D[temp1].clipping_back_boundary, (void*)temp2, sizeof(FIXED));
 temp2 += (sizeof(FIXED));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].image3D_number, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].movement_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].rotation_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_timer[X], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_timer[Y], sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scaling_timer[Z], sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].position[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].position[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].position[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].angle[X], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].angle[Y], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].angle[Z], sizeof(ANGLE));
 temp2 += sizeof(ANGLE);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scale[X], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scale[Y], sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].scale[Z], sizeof(FIXED));
 temp2 += sizeof(FIXED);

 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_check, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_left_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_right_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_top_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_bottom_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_front_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D[temp1].clipping_back_boundary, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return;
}
// ==================================================
//	[SPRITE3D_ANIMATION_TEXTURE] :  <<SPRITE3D_ANIMATION_TEXTURE>>
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_TEXTURE_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSPRITE3D_ANIMATION_TEXTURE = (SPRITE3D_ANIMATION_TEXTURE*)realloc(pSPRITE3D_ANIMATION_TEXTURE, temp2 * sizeof(SPRITE3D_ANIMATION_TEXTURE));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSPRITE3D_ANIMATION_TEXTURE[temp3].image2D_number);
   free(pSPRITE3D_ANIMATION_TEXTURE[temp3].frame_target);
   free(pSPRITE3D_ANIMATION_TEXTURE[temp3].frame_increment);
  }
  pSPRITE3D_ANIMATION_TEXTURE = (SPRITE3D_ANIMATION_TEXTURE*)realloc(pSPRITE3D_ANIMATION_TEXTURE, temp2 * sizeof(SPRITE3D_ANIMATION_TEXTURE));
 }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_TEXTURE_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the animation.
 */
 pSPRITE3D_ANIMATION_TEXTURE[temp1].total_frames = temp2;
 pSPRITE3D_ANIMATION_TEXTURE[temp1].image2D_number = (int*)realloc(pSPRITE3D_ANIMATION_TEXTURE[temp1].image2D_number, temp2 * sizeof(int));
 pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_target = (FIXED*)realloc(pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_target, temp2 * sizeof(FIXED));
 pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_increment = (FIXED*)realloc(pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_increment, temp2 * sizeof(FIXED));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_TEXTURE_setup(int temp1, int temp2, int temp3, FIXED temp4, FIXED temp5)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The slot number of the image to display.
    temp4 = The delay value of this frame (How long to display this frame onscreen).
    temp5 = The per-frame-increment of this frame.
 */
 pSPRITE3D_ANIMATION_TEXTURE[temp1].image2D_number[temp2] = temp3;
 pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_target[temp2] = temp4;
 pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_increment[temp2] = temp5;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_TEXTURE_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SPRITE3D_ANIMATION_TEXTURE_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SPRITE3D_ANIMATION_TEXTURE_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSPRITE3D_ANIMATION_TEXTURE[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSPRITE3D_ANIMATION_TEXTURE[animation_number + temp1].image2D_number[temp2] = e2_CDROM_read_number(4);
   pSPRITE3D_ANIMATION_TEXTURE[animation_number + temp1].frame_target[temp2] = toFIXED(e2_CDROM_read_number(8) * 0.0001);
   pSPRITE3D_ANIMATION_TEXTURE[animation_number + temp1].frame_increment[temp2] = toFIXED(e2_CDROM_read_number(8) * 0.0001);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_TEXTURE_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_TEXTURE[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].image2D_number[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));  

  slDMACopy((void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_target[temp3], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_increment[temp3], (void*)temp2, sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE3D_ANIMATION_TEXTURE_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSPRITE3D_ANIMATION_TEXTURE[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].image2D_number[temp3], sizeof(int));
  temp2 += (sizeof(int));  

  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_target[temp3], sizeof(FIXED));
  temp2 += (sizeof(FIXED));  

  slDMACopy((void*)temp2, (void*)&pSPRITE3D_ANIMATION_TEXTURE[temp1].frame_increment[temp3], sizeof(FIXED));
  temp2 += (sizeof(FIXED));
 }
 return(temp2);
}
// ==================================================
//	[SPRITE3D_TEXTURE] :  <<SPRITE3D_TEXTURE>>
// --------------------------------------------------
e2_SPRITE3D_TEXTURE_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSPRITE3D_TEXTURE = (SPRITE3D_TEXTURE*)realloc(pSPRITE3D_TEXTURE, temp1 * sizeof(SPRITE3D_TEXTURE));
 return;
}
// --------------------------------------------------
e2_SPRITE3D_TEXTURE_setup(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6, FIXED temp7)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to show the sprite or not.
            Specify either YES or NO.
    temp3 = Whether to animate the sprite or not.
            Specify either YES or NO.
    temp4 = Whether to loop the sprite's animation or not.
            Specify either YES or NO.
    temp5 = The slot number of the current animation.
    temp6 = The current frame number of the animation.
    temp7 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSPRITE3D_TEXTURE[temp1].show_sprite = temp2;

 pSPRITE3D_TEXTURE[temp1].frame_animate = temp3;
 pSPRITE3D_TEXTURE[temp1].frame_loop = temp4;
 pSPRITE3D_TEXTURE[temp1].frame_current_animation = temp5;
 pSPRITE3D_TEXTURE[temp1].frame_current_frame = temp6;
 pSPRITE3D_TEXTURE[temp1].frame_timer = temp7;
 return;
}
// --------------------------------------------------
e2_SPRITE3D_TEXTURE_animate(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the 3D model to apply the texture to.
    temp2 = The number of the polygon on that 3D model to apply the texture to.
    temp3 = The slot number of the sprite to animate.
 */
 if(pSPRITE3D_TEXTURE[temp3].frame_current_animation != NONE)
 {
  if(pSPRITE3D_TEXTURE[temp3].frame_animate == YES)
   if(pSPRITE3D_TEXTURE[temp3].frame_current_frame != pSPRITE3D_ANIMATION_TEXTURE[pSPRITE3D_TEXTURE[temp3].frame_current_animation].total_frames)
   {
    if(pSPRITE3D_TEXTURE[temp3].frame_timer != pSPRITE3D_ANIMATION_TEXTURE[pSPRITE3D_TEXTURE[temp3].frame_current_animation].frame_target[pSPRITE3D_TEXTURE[temp3].frame_current_frame])
     pSPRITE3D_TEXTURE[temp3].frame_timer += pSPRITE3D_ANIMATION_TEXTURE[pSPRITE3D_TEXTURE[temp3].frame_current_animation].frame_increment[pSPRITE3D_TEXTURE[temp3].frame_current_frame];
    else
    {
     pSPRITE3D_TEXTURE[temp3].frame_timer = toFIXED(0.0);
     pSPRITE3D_TEXTURE[temp3].frame_current_frame++;
     if(pSPRITE3D_TEXTURE[temp3].frame_current_frame >= pSPRITE3D_ANIMATION_TEXTURE[pSPRITE3D_TEXTURE[temp3].frame_current_animation].total_frames)
     {
      if(pSPRITE3D_TEXTURE[temp3].frame_loop == YES)
       pSPRITE3D_TEXTURE[temp3].frame_current_frame = 0;
      else
      {
       pSPRITE3D_TEXTURE[temp3].frame_current_frame--;
       pSPRITE3D_TEXTURE[temp3].frame_animate = NO;
      }
     }
     if(pSPRITE3D_TEXTURE[temp3].show_sprite == YES)
     {
      if(pSPRITE3D_ANIMATION_TEXTURE[pSPRITE3D_TEXTURE[temp3].frame_current_animation].image2D_number[pSPRITE3D_TEXTURE[temp3].frame_current_frame] == NONE)
       pIMAGE3D[temp1].model_attributes[temp2].texno = No_Texture;
      else
       pIMAGE3D[temp1].model_attributes[temp2].texno = pSPRITE3D_ANIMATION_TEXTURE[pSPRITE3D_TEXTURE[temp3].frame_current_animation].image2D_number[pSPRITE3D_TEXTURE[temp3].frame_current_frame];
     }
    }
   }
  }
 return;
}
// --------------------------------------------------
e2_SPRITE3D_TEXTURE_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SPRITE3D_TEXTURE_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSPRITE3D_TEXTURE[sprite_number + temp1].show_sprite = e2_CDROM_read_number(1);
  pSPRITE3D_TEXTURE[sprite_number + temp1].frame_animate = e2_CDROM_read_number(1);
  pSPRITE3D_TEXTURE[sprite_number + temp1].frame_loop = e2_CDROM_read_number(1);
  pSPRITE3D_TEXTURE[sprite_number + temp1].frame_current_animation = e2_CDROM_read_number(4);
  pSPRITE3D_TEXTURE[sprite_number + temp1].frame_current_frame = e2_CDROM_read_number(4);
  pSPRITE3D_TEXTURE[sprite_number + temp1].frame_timer = toFIXED(e2_CDROM_read_number(8) * 0.0001);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SPRITE3D_TEXTURE_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSPRITE3D_TEXTURE[temp1].show_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE3D_TEXTURE[temp1].frame_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE3D_TEXTURE[temp1].frame_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE3D_TEXTURE[temp1].frame_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE3D_TEXTURE[temp1].frame_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSPRITE3D_TEXTURE[temp1].frame_timer, (void*)temp2, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return(temp2);
}
// --------------------------------------------------
e2_SPRITE3D_TEXTURE_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_TEXTURE[temp1].show_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_TEXTURE[temp1].frame_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_TEXTURE[temp1].frame_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_TEXTURE[temp1].frame_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_TEXTURE[temp1].frame_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSPRITE3D_TEXTURE[temp1].frame_timer, sizeof(FIXED));
 temp2 += sizeof(FIXED);
 return(temp2);
}
// ==================================================
//	[SOUND]              :  <<SOUND>>
// --------------------------------------------------
void e2_SOUND_initialize(int temp1)
{
 /*
    temp1 = The size of the sound map (I usually use multiples of 2..like 2, 4, or 8).
 */
 int  temp2;
 char temp3[temp1];

 for(temp2 = 0; temp2 != temp1; temp2++)
  temp3[temp2] = 0xff;

 slInitSound(sddrvstsk, sizeof(sddrvstsk), (Uint8*)temp3, sizeof(temp3));
}
// ==================================================
//	[SOUND_CDDA]         :  <<SOUND_CDDA>>
// --------------------------------------------------
void e2_SOUND_CDDA_initialize()
{
 CDC_CdInit(0x00,0x00,0x05,0x0f);
 return;
}
// --------------------------------------------------
void e2_SOUND_CDDA_play(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The starting track number.
    temp2 = The ending track number.
    temp3 = The number of times to loop playback (from start track to end track).
            Specify repeat_forever to loop forever.

    Below is an example of its use:
            e2_SOUND_CDDA_initialize();
            slSndVolume(Uint8 volume);            // Set the global sound volume.
            slCDDAOn(temp1, temp2, temp3, temp4); // Set the left channel volume, right channel volume, left pan, and right pan.
            e2_SOUND_CDDA_play(temp1, temp2, temp3);

    And then use 'slCDDAOff()' when you want to stop playback!!
 */
 CdcPly plywk;
 CdcPly *ply = &plywk;
 CDC_PLY_STYPE(ply) = CDC_PTYPE_TNO ;
 CDC_PLY_STNO(ply)  = temp1 ;
 CDC_PLY_SIDX(ply)  = 1 ;
 CDC_PLY_ETYPE(ply) = CDC_PTYPE_TNO ;
 CDC_PLY_ETNO(ply)  = temp2 ;
 CDC_PLY_EIDX(ply)  = 99 ;
 CDC_PLY_PMODE(ply) = CDC_PM_DFL + temp3;
 CDC_CdPlay(ply);
 return;
}
// ==================================================
//	[SOUND_PCM]          :  <<SOUND_PCM>>
// --------------------------------------------------
e2_SOUND_PCM_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of sound effect slots.
    temp2 = The desired number of sound effect slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSOUND_PCM = (SOUND_PCM*)realloc(pSOUND_PCM, temp2 * sizeof(SOUND_PCM));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
   free(pSOUND_PCM[temp3].sound_data);
  pSOUND_PCM = (SOUND_PCM*)realloc(pSOUND_PCM, temp2 * sizeof(SOUND_PCM));
 }
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_reallocate_sound_size(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the sound effect to edit.
    temp2 = The number of entries in the sound effect's data.
 */
 pSOUND_PCM[temp1].sound_data = (char*)realloc(pSOUND_PCM[temp1].sound_data, temp2 * sizeof(char));
 return;
}

// --------------------------------------------------
e2_SOUND_PCM_change_channel_and_volume(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the sound effect to edit.
    temp2 = The new channel number of the sound effect.
            Specify a number from 0 to 7, or use NONE for no change.
    temp3 = The new volume of the sound effect.
            Specify a number from 0(mute) to 127(full volume), or use NONE for no change.
 */
 if(temp2 > NONE)
  pSOUND_PCM[temp1].sound_info.channel = temp2;
 if(temp3 > NONE)
  pSOUND_PCM[temp1].sound_info.level   = temp3;
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_play(int temp1)
{
 /*
    temp1 = The slot number of the sound effect to playback.
 */
 slPCMOn(&pSOUND_PCM[temp1].sound_info, &pSOUND_PCM[temp1].sound_data[0], pSOUND_PCM[temp1].sound_size);
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_play_on_available_channel(int temp1)
{
 /*
    temp1 = The slot number of the sound effect to playback.
 */
 int temp2 = slSndPCMNum(pSOUND_PCM[temp1].sound_info.mode);

 if(temp2 != NONE)
 {
  pSOUND_PCM[temp1].sound_info.channel = temp2;
  slPCMOn(&pSOUND_PCM[temp1].sound_info, pSOUND_PCM[temp1].sound_data, pSOUND_PCM[temp1].sound_size);
 }
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_stop_and_play(int temp1)
{
 /*
    temp1 = The slot number of the sound effect to playback.
 */
 int temp2 = slPCMStat(&pSOUND_PCM[temp1].sound_info), temp3;

 if(temp2 == YES)
 {
  temp3 = temp2;
  slPCMOff(&pSOUND_PCM[temp1].sound_info);
  while(temp3 == YES)
  {
   temp3 = slPCMStat(&pSOUND_PCM[temp1].sound_info);
  }
  slPCMOn( &pSOUND_PCM[temp1].sound_info, pSOUND_PCM[temp1].sound_data, pSOUND_PCM[temp1].sound_size);
 }
 else
  slPCMOn( &pSOUND_PCM[temp1].sound_info, pSOUND_PCM[temp1].sound_data, pSOUND_PCM[temp1].sound_size);
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_stop_all(int temp1)
{
 /*
    temp1 = The current number of total sound effects.
 */
 int temp2, temp3;

 for(temp2 = 0; temp2 != temp1; temp2++)
 {
  temp3 = slPCMStat(&pSOUND_PCM[temp2].sound_info);

  if(temp3 == YES)
   slPCMOff(&pSOUND_PCM[temp2].sound_info);
 }
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_load_from_CDROM(int sound_number, char sound_sheet_filename[])
{
 /*
    sound_number         = The starting slot number of the sound effect to begin loading into.
    sound_sheet_filename = The file name of the sound effects to load.
 */
 int number_of_sounds, temp_sound_data[max_CDROM_load][5], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(sound_sheet_filename);
 number_of_sounds = e2_CDROM_read_number(4);
 e2_SOUND_PCM_reallocate(sound_number, sound_number + number_of_sounds);

 for(temp1 = 0; temp1 != number_of_sounds; temp1++)
  temp_sound_data[temp1][0] = e2_CDROM_read_number(1); // the channel to play the sound effect on (0 - 3 for Stereo, 0 - 7 for Mono).

 for(temp1 = 0; temp1 != number_of_sounds; temp1++)
 {
  temp_sound_data[temp1][1] = e2_CDROM_read_number(1); // whether the sound effect is Stereo or Mono.
  temp_sound_data[temp1][2] = e2_CDROM_read_number(1); // whether the sound effect is 16Bit or 8Bit.
  temp_sound_data[temp1][3] = e2_CDROM_read_number(8); // the pitch of the sound effect.
  temp_sound_data[temp1][4] = e2_CDROM_read_number(8); // the size of the sound effect.
 }

 for(temp1 = 0; temp1 != number_of_sounds; temp1++)
 {
  if(temp_sound_data[temp1][1] == 0 && temp_sound_data[temp1][2] == 0)
   pSOUND_PCM[sound_number + temp1].sound_info.mode = (_Mono|_PCM8Bit);
  if(temp_sound_data[temp1][1] == 0 && temp_sound_data[temp1][2] == 1)
   pSOUND_PCM[sound_number + temp1].sound_info.mode = (_Mono|_PCM16Bit);
  if(temp_sound_data[temp1][1] == 1 && temp_sound_data[temp1][2] == 0)
   pSOUND_PCM[sound_number + temp1].sound_info.mode = (_Stereo|_PCM8Bit);
  if(temp_sound_data[temp1][1] == 1 && temp_sound_data[temp1][2] == 1)
   pSOUND_PCM[sound_number + temp1].sound_info.mode = (_Stereo|_PCM16Bit);

  pSOUND_PCM[sound_number + temp1].sound_info.channel   = temp_sound_data[temp1][0];
  pSOUND_PCM[sound_number + temp1].sound_info.level     = 127;
  pSOUND_PCM[sound_number + temp1].sound_info.pan       = 0;
  pSOUND_PCM[sound_number + temp1].sound_info.pitch     = temp_sound_data[temp1][3];
  pSOUND_PCM[sound_number + temp1].sound_info.eflevelR  = 0;
  pSOUND_PCM[sound_number + temp1].sound_info.efselectR = 0;
  pSOUND_PCM[sound_number + temp1].sound_info.eflevelL  = 0;
  pSOUND_PCM[sound_number + temp1].sound_info.efselectL = 0;

  pSOUND_PCM[sound_number + temp1].sound_size = (sizeof(char) * temp_sound_data[temp1][4]);
 }

 for(temp1 = 0; temp1 != number_of_sounds; temp1++)
 {
  e2_SOUND_PCM_reallocate_sound_size((sound_number + temp1), temp_sound_data[temp1][4]);
  for(temp2 = 0; temp2 != temp_sound_data[temp1][4]; temp2++)
   pSOUND_PCM[sound_number + temp1].sound_data[temp2] = e2_CDROM_read_number(3);
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sound effect to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3 = 0;

 slDMACopy((void*)&pSOUND_PCM[temp1].sound_size, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)&pSOUND_PCM[temp1].sound_info, (void*)temp2, sizeof(PCM));
 temp2 += sizeof(PCM);

 for(temp3 = 0; temp3 != pSOUND_PCM[temp1].sound_size / sizeof(char); temp3++)
 {
  slDMACopy((void*)&pSOUND_PCM[temp1].sound_data[temp3], (void*)temp2, sizeof(char));
  temp2 += sizeof(char);
 }
 return;
}
// --------------------------------------------------
e2_SOUND_PCM_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sound effect into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3 = 0;

 slDMACopy((void*)temp2, (void*)&pSOUND_PCM[temp1].sound_size, sizeof(int));
 temp2 += sizeof(int);

 slDMACopy((void*)temp2, (void*)&pSOUND_PCM[temp1].sound_info, sizeof(PCM));
 temp2 += sizeof(PCM);

 for(temp3 = 0; temp3 != pSOUND_PCM[temp1].sound_size / sizeof(char); temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSOUND_PCM[temp1].sound_data[temp3], sizeof(char));
  temp2 += sizeof(char);
 }
 return;
}
// ==================================================
//	[SOUND_ANIMATION_PCM] :  <<SOUND_ANIMATION_PCM>>
// --------------------------------------------------
e2_SOUND_ANIMATION_PCM_reallocate(int temp1, int temp2)
{
 /*
    temp1 = The current number of animation slots.
    temp2 = The desired number of animation slots.
 */
 int temp3 = 0;
 if(temp1 < temp2)
 {
  pSOUND_ANIMATION_PCM = (SOUND_ANIMATION_PCM*)realloc(pSOUND_ANIMATION_PCM, temp2 * sizeof(SOUND_ANIMATION_PCM));
  return;
 }
 if(temp1 > temp2)
 {
  for(temp3 = (temp1 - 1); temp3 != (temp2 - 1); temp3--)
  {
   free(pSOUND_ANIMATION_PCM[temp3].frame_target);
   free(pSOUND_ANIMATION_PCM[temp3].pcm_number);
  }
  pSOUND_ANIMATION_PCM = (SOUND_ANIMATION_PCM*)realloc(pSOUND_ANIMATION_PCM, temp2 * sizeof(SOUND_ANIMATION_PCM));
 }
 return;
}
// --------------------------------------------------
e2_SOUND_ANIMATION_PCM_reallocate_frame(int temp1, int temp2)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The desired number of frames in the sound.
 */
 pSOUND_ANIMATION_PCM[temp1].total_frames = temp2;
 pSOUND_ANIMATION_PCM[temp1].frame_target = (int*)realloc(pSOUND_ANIMATION_PCM[temp1].frame_target, temp2 * sizeof(int));
 pSOUND_ANIMATION_PCM[temp1].pcm_number   = (int*)realloc(pSOUND_ANIMATION_PCM[temp1].pcm_number,   temp2 * sizeof(int));
 return;
}
// --------------------------------------------------
e2_SOUND_ANIMATION_PCM_setup(int temp1, int temp2, int temp3, int temp4)
{
 /*
    temp1 = The slot number of the animation to edit.
    temp2 = The frame number of the animation to edit.
    temp3 = The frame's delay value (How long to wait before playing the sound effect).
    temp4 = The slot number of the sound effect to play.
 */
 pSOUND_ANIMATION_PCM[temp1].frame_target[temp2] = temp3;
 pSOUND_ANIMATION_PCM[temp1].pcm_number[temp2]   = temp4;
 return;
}
// --------------------------------------------------
e2_SOUND_ANIMATION_PCM_load_from_CDROM(int animation_number, char animation_sheet_filename[])
{
 /*
    animation_number         = The starting slot number of the animation to begin loading into.
    animation_sheet_filename = The file name of the animations to load.
 */
 int number_of_animations, temp_animation_data[max_CDROM_load], temp1 = 0, temp2 = 0;

 e2_CDROM_load_file(animation_sheet_filename);
 number_of_animations = e2_CDROM_read_number(4);
 e2_SOUND_ANIMATION_PCM_reallocate(animation_number, animation_number + number_of_animations);
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  temp_animation_data[temp1] = e2_CDROM_read_number(4);	// number of frames in the animation.
  e2_SOUND_ANIMATION_PCM_reallocate_frame(animation_number + temp1, temp_animation_data[temp1]);
 }
 for(temp1 = 0; temp1 != number_of_animations; temp1++)
 {
  pSOUND_ANIMATION_PCM[animation_number + temp1].total_frames = temp_animation_data[temp1];
  for(temp2 = 0; temp2 != temp_animation_data[temp1]; temp2++)
  {
   pSOUND_ANIMATION_PCM[animation_number + temp1].frame_target[temp2] = e2_CDROM_read_number(4);
   pSOUND_ANIMATION_PCM[animation_number + temp1].pcm_number[temp2]   = e2_CDROM_read_number(4);
  }
 }
 e2_CDROM_clear_data_buffer();
 return;
}
// --------------------------------------------------
e2_SOUND_ANIMATION_PCM_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the animation to save.
    temp2 = The ramcart address to begin saving at.
 */
 int temp3;
 
 slDMACopy((void*)&pSOUND_ANIMATION_PCM[temp1].total_frames, (void*)temp2, sizeof(int));
 temp2 += (sizeof(int));
 
 for(temp3 = 0; temp3 != pSOUND_ANIMATION_PCM[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)&pSOUND_ANIMATION_PCM[temp1].frame_target[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)&pSOUND_ANIMATION_PCM[temp1].pcm_number[temp3], (void*)temp2, sizeof(int));
  temp2 += (sizeof(int));  
 }
 return(temp2);
}
// --------------------------------------------------
e2_SOUND_ANIMATION_PCM_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the animation into.
    temp2 = The ramcart address to begin loading from.
 */
 int temp3;
 
 slDMACopy((void*)temp2, (void*)&pSOUND_ANIMATION_PCM[temp1].total_frames, sizeof(int));
 temp2 += sizeof(int);

 for(temp3 = 0; temp3 != pSOUND_ANIMATION_PCM[temp1].total_frames; temp3++)
 {
  slDMACopy((void*)temp2, (void*)&pSOUND_ANIMATION_PCM[temp1].frame_target[temp3], sizeof(int));
  temp2 += (sizeof(int));

  slDMACopy((void*)temp2, (void*)&pSOUND_ANIMATION_PCM[temp1].pcm_number[temp3], sizeof(int));
  temp2 += (sizeof(int));  
 }
 return(temp2);
}
// ==================================================
//	[SOUND_SPRITE_PCM]   :  <<SOUND_SPRITE_PCM>>
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_reallocate(int temp1)
{
 /*
    temp1 = The desired number of sprite slots.
 */
 pSOUND_SPRITE_PCM = (SOUND_SPRITE_PCM*)realloc(pSOUND_SPRITE_PCM, temp1 * sizeof(SOUND_SPRITE_PCM));
 return;
}
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_setup(int temp1, int temp2, int temp3)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to animate the sprite or not.
            Specify either YES or NO.
    temp3 = The desired playback type.
            Specify 0 for regular playback, 1 for find available channel and playback, or 2 for stop playback on same channel and then playback.
 */
 pSOUND_SPRITE_PCM[temp1].play_sprite = temp2;
 pSOUND_SPRITE_PCM[temp1].play_mode   = temp3;
 return;
}
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_setup_ANIMATION_FRAME(int temp1, int temp2, int temp3, int temp4, int temp5, int temp6)
{
 /*
    temp1 = The slot number of the sprite to edit.
    temp2 = Whether to play the animation or not.
            Specify either YES or NO.
    temp3 = Whether to loop the animation or not.
            Specify either YES or NO.
    temp4 = The slot number of the current animation.
    temp5 = The current frame number of the animation.
    temp6 = The frame's delay timer (Usually want to initialize at 0).
 */
 pSOUND_SPRITE_PCM[temp1].frame_animate = temp2;
 pSOUND_SPRITE_PCM[temp1].frame_loop = temp3;
 pSOUND_SPRITE_PCM[temp1].frame_current_animation = temp4;
 pSOUND_SPRITE_PCM[temp1].frame_current_frame = temp5;
 pSOUND_SPRITE_PCM[temp1].frame_timer = temp6;
 return;
}
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_animate(int temp1)
{
 /*
    temp1 = The slot number of the sprite to animate.
 */
 if(pSOUND_SPRITE_PCM[temp1].frame_current_animation != NONE)
 {
  if(pSOUND_SPRITE_PCM[temp1].frame_animate == YES)
   if(pSOUND_SPRITE_PCM[temp1].frame_current_frame != pSOUND_ANIMATION_PCM[pSOUND_SPRITE_PCM[temp1].frame_current_animation].total_frames)
   {
    if(pSOUND_SPRITE_PCM[temp1].frame_timer < pSOUND_ANIMATION_PCM[pSOUND_SPRITE_PCM[temp1].frame_current_animation].frame_target[pSOUND_SPRITE_PCM[temp1].frame_current_frame])
    {
     pSOUND_SPRITE_PCM[temp1].frame_timer++;
    }
    else
    {
     if(pSOUND_SPRITE_PCM[temp1].play_sprite == YES)
     {
      switch(pSOUND_SPRITE_PCM[temp1].play_mode)
      {
       case 0:
        e2_SOUND_PCM_play(pSOUND_ANIMATION_PCM[pSOUND_SPRITE_PCM[temp1].frame_current_animation].pcm_number[pSOUND_SPRITE_PCM[temp1].frame_current_frame]);
        break;

       case 1:
        e2_SOUND_PCM_play_on_available_channel(pSOUND_ANIMATION_PCM[pSOUND_SPRITE_PCM[temp1].frame_current_animation].pcm_number[pSOUND_SPRITE_PCM[temp1].frame_current_frame]);
        break;

       case 2:
        e2_SOUND_PCM_stop_and_play(pSOUND_ANIMATION_PCM[pSOUND_SPRITE_PCM[temp1].frame_current_animation].pcm_number[pSOUND_SPRITE_PCM[temp1].frame_current_frame]);
        break;
      }
     }
     pSOUND_SPRITE_PCM[temp1].frame_current_frame++;
     pSOUND_SPRITE_PCM[temp1].frame_timer = 0;

     if(pSOUND_SPRITE_PCM[temp1].frame_current_frame >= pSOUND_ANIMATION_PCM[pSOUND_SPRITE_PCM[temp1].frame_current_animation].total_frames)
     {
      if(pSOUND_SPRITE_PCM[temp1].frame_loop == YES)
       pSOUND_SPRITE_PCM[temp1].frame_current_frame = 0;
      else
       {pSOUND_SPRITE_PCM[temp1].frame_current_frame--; pSOUND_SPRITE_PCM[temp1].frame_animate = NO;}
     }
    }
   }
 }
 return;
}
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_load_from_CDROM(int sprite_number, char sprite_sheet_filename[])
{
 /*
    sprite_number         = The starting slot number of the sprite to begin loading into.
    sprite_sheet_filename = The file name of the sprites to load.
 */
 int number_of_sprites, temp1;

 e2_CDROM_load_file(sprite_sheet_filename);
 number_of_sprites = e2_CDROM_read_number(4);
 e2_SOUND_SPRITE_PCM_reallocate(sprite_number + number_of_sprites);
 for(temp1 = 0; temp1 != number_of_sprites; temp1++)
 {
  pSOUND_SPRITE_PCM[sprite_number + temp1].play_sprite = e2_CDROM_read_number(1);
  pSOUND_SPRITE_PCM[sprite_number + temp1].frame_animate = e2_CDROM_read_number(1);
  pSOUND_SPRITE_PCM[sprite_number + temp1].frame_loop = e2_CDROM_read_number(1);
  pSOUND_SPRITE_PCM[sprite_number + temp1].frame_current_animation = e2_CDROM_read_number(4);
  pSOUND_SPRITE_PCM[sprite_number + temp1].frame_current_frame = e2_CDROM_read_number(4);
  pSOUND_SPRITE_PCM[sprite_number + temp1].frame_timer = e2_CDROM_read_number(4);
  pSOUND_SPRITE_PCM[sprite_number + temp1].play_mode = e2_CDROM_read_number(1);
 }
 return;
}
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_save_to_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number of the sprite to save.
    temp2 = The ramcart address to begin saving at.
 */
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].play_sprite, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].frame_animate, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].frame_loop, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].frame_current_animation, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].frame_current_frame, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].frame_timer, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)&pSOUND_SPRITE_PCM[temp1].play_mode, (void*)temp2, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// --------------------------------------------------
e2_SOUND_SPRITE_PCM_load_from_RAMCART(int temp1, Uint32 temp2)
{
 /*
    temp1 = The slot number to load the sprite into.
    temp2 = The ramcart address to begin loading from.
 */
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].play_sprite, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].frame_animate, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].frame_loop, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].frame_current_animation, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].frame_current_frame, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].frame_timer, sizeof(int));
 temp2 += sizeof(int);
 slDMACopy((void*)temp2, (void*)&pSOUND_SPRITE_PCM[temp1].play_mode, sizeof(int));
 temp2 += sizeof(int);
 return(temp2);
}
// ==================================================
//	[BACKUP]             :  <<BACKUP>>
// --------------------------------------------------
e2_BACKUP_filename(char temp1[])
{
 /*
    temp1 = The name of the backup file to create/edit (MUST BE 11 CHARACTERS LONG!!).
 */
 int temp2;

 for(temp2 = 0; temp2 != 11; temp2++)
   BACKUP_filename[temp2]  = temp1[temp2];
 return;
}
// --------------------------------------------------
e2_BACKUP_comment(char temp1[])
{
 /*
    temp1 = The comment to write about the current backup file (MUST BE 10 CHARACTERS LONG!!).
 */
 int temp2;

 for(temp2 = 0; temp2 != 10; temp2++)
   BACKUP_comment[temp2]  = temp1[temp2];
 return;
}
// --------------------------------------------------
e2_BACKUP_data_buffer_write(int temp1, Uint8 temp2)
{
 /*
    temp1 = The slot number in the data buffer to edit.
    temp2 = The data to write.
 */
 BACKUP_data_buffer[temp1] = (Uint8)temp2;
 return;
}
// --------------------------------------------------
e2_BACKUP_data_buffer_read(int temp1)
{
 /*
    temp1 = The slot number in the data buffer to read.
 */
 Uint8 temp2;

 temp2 = BACKUP_data_buffer[temp1];
 return(temp2);
}
// --------------------------------------------------
Sint32 e2_BACKUP_get_status()
{
 Sint32 status;

 status = BUP_Stat(BACKUP_device, BACKUP_data_buffer_size, &BACKUP_system_sttb);
 return(status);
}
// --------------------------------------------------
e2_BACKUP_initialize()
{
 Sint32 status;
 Uint32	BackUpRamWork[2048];
 int    temp1;

 slGetStatus();
 for(temp1 = 0; temp1 < 100; temp1++) slSynch();
 slResetDisable();
 BUP_Init((Uint32 *)BACKUP_memory_address, BackUpRamWork, BACKUP_system_conf);
 slResetEnable();
 status = e2_BACKUP_get_status();
 return(status);
}
// --------------------------------------------------
Sint32 e2_BACKUP_format()
{
 Sint32 status;

 slResetDisable();
 status = BUP_Format(BACKUP_device);
 slResetEnable();
 status = e2_BACKUP_get_status();
 return(status);
}
// --------------------------------------------------
Sint32 e2_BACKUP_write_file()
{
 Sint32 status;

 status = e2_BACKUP_get_status();
 if(BACKUP_system_sttb.freeblock > 0)
 {
  strncpy(BACKUP_system_dir.filename, BACKUP_filename, 11);
  strncpy(BACKUP_system_dir.comment , BACKUP_comment , 10);
  BACKUP_system_dir.language = BUP_ENGLISH;
  BACKUP_system_dir.datasize = BACKUP_data_buffer_size;
  BACKUP_system_dir.date     = 0;
  slResetDisable();
  status = BUP_Write( BACKUP_device, &BACKUP_system_dir, BACKUP_data_buffer, OFF);
  slResetEnable();
  status = BUP_Verify(BACKUP_device, (Uint8 *)BACKUP_filename, (Uint8 *)BACKUP_data_buffer);
 }
 return(status);
}
// --------------------------------------------------
Sint32 e2_BACKUP_read_file()
{
 Sint32 status;

 status = BUP_Read(BACKUP_device, (Uint8 *)BACKUP_filename, BACKUP_data_buffer);
 return(status);
}
// --------------------------------------------------
Sint32 e2_BACKUP_delete_file()
{
 Sint32 status;

 slResetDisable();
 status = BUP_Delete(BACKUP_device, BACKUP_filename);
 slResetEnable();
 return(status);
}
// ==================================================
//	[END OF FILE]        :  <<EOF>>
// ==================================================
